2007-04-24  Chong Yidong  <cyd@stupidchicken.com>

	* Branch for 22.1.

2007-04-24  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (redisplay_window): Use BEG_UNCHANGED and END_UNCHANGED
	values of the actual window.

2007-04-23  Richard Stallman  <rms@gnu.org>

	* process.c (Fstart_process): Doc fix.

2007-04-23  Eli Zaretskii  <eliz@gnu.org>

	* process.c (Fstart_process): Doc fix.

2007-04-22  Richard Stallman  <rms@gnu.org>

	* abbrev.c (Fdefine_abbrev): Doc fix.

	* keymap.c (Fdefine_key): Minor doc fix.

2007-04-21  Glenn Morris  <rgm@gnu.org>

	* keymap.c (Fdefine_key): Fix info ref in doc string.

2007-04-20  Glenn Morris  <rgm@gnu.org>

	* sysdep.c (init_system_name): Don't accept localhost.localdomain.

2007-04-19  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (Fminibuffer_contents, Fminibuffer_contents_no_properties)
	(Fminibuffer_completion_contents, Fdelete_minibuffer_contents):
	Doc fixes.

2007-04-16  Chong Yidong  <cyd@stupidchicken.com>

	* dispnew.c (adjust_frame_glyphs_for_frame_redisplay):
	Set garbaged flag in presence of window margins.
	(showing_window_margins_p): New function.

	* xdisp.c (cursor_row_p): Only end row on newline if it's a
	display string.  Suggested by Lennart Borgman.

2007-04-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (mem_insert): Set min_heap_address and max_heap_address
	if they are not yet initialized.

2007-04-15  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (redisplay_window): When deciding whether or not to
	recenter, don't use the reset values of BEG_UNCHANGED and
	END_UNCHANGED.

2007-04-13  Kim F. Storm  <storm@cua.dk>

	* buffer.c (Fkill_buffer): gcpro BUF during kill_buffer_processes
	and check that buffer is still alive upon return.

2007-04-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [!TARGET_API_MAC_CARBON]: Include Displays.h.
	(mac_screen_config_changed): New variable.
	(mac_handle_dm_notification, init_dm_notification_handler)
	(mac_get_screen_info): New functions.
	[MAC_OS8] (main): Call init_dm_notification_handler.
	(mac_initialize) [MAC_OSX]: Likewise.
	(XTread_socket): Call mac_get_screen_info if screen config changed.
	(mac_initialized): Make static.
	(mac_initialize_display_info): Remove function.
	(mac_term_init): Call mac_get_screen_info.  Add partial contents of
	mac_initialize_display_info.

2007-04-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (xrm_get_preference_database, Fmac_get_preference)
	[TARGET_API_MAC_CARBON]: Use CFPreferencesAppSynchronize.

	* macterm.c [TARGET_API_MAC_CARBON] (mac_post_mouse_moved_event):
	Use GetGlobalMouse instead of GetMouse and LocalToGlobal.
	(mac_initialize_display_info) [MAC_OSX]: Use CGRectZero.
	(mac_initialize_display_info) [!MAC_OSX]: dpyinfo->height and
	dpyinfo->width are those of whole screen.

2007-04-10  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (note_mode_line_or_margin_highlight): Don't decrement
	glyph pointer before start of glyph row.

2007-04-09  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* s/darwin.h (__restrict, struct kboard): Remove outdated workarounds.
	(C_SWITCH_SYSTEM): Remove `-I../mac/src'.

2007-04-09  Martin Rudalics  <rudalics@gmx.at>

	* indent.c (Fmove_to_column): Set next_boundary with correct start pt.

2007-04-08  Richard Stallman  <rms@gnu.org>

	* xdisp.c (syms_of_xdisp) <message-log-max>: Default 100.

2007-04-07  Chong Yidong  <cyd@stupidchicken.com>

	* editfns.c (Ftranspose_regions): Validate interval before setting
	text properties.

2007-04-03  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (main): Fix instructions for building Emacs for profiling.

2007-04-03  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_update_menubar): Call g_list_next after moving
	menu bar item.

2007-04-02  Juanma Barranquero  <lekktu@gmail.com>

	* print.c (Fprin1_to_string): Use macro SPECPDL_INDEX.

2007-04-01  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fcommand_remapping): New optional argument.
	(where_is_internal): Use new keymaps argument.
	(Fkey_binding): Caller changed.

	* keyboard.c (command_loop_1): Caller changed.

2007-03-31  Eli Zaretskii  <eliz@gnu.org>

	* window.c (Fget_lru_window): Doc fix.

2007-03-30  Chong Yidong  <cyd@stupidchicken.com>

	* undo.c (Fprimitive_undo): Give clearer error message when trying
	to change text properties outside accessible part of buffer.

2007-03-29  Kim F. Storm  <storm@cua.dk>

	* process.c (wait_reading_process_output) [HAVE_PTYS]:
	When EIO happens, clear channel from descriptor masks before raising
	SIGCHLD signal to avoid busy loop between read and sigchld_handler.
	(sigchld_handler): Remove sleep (2007-03-11 & 2007-03-26 changes).

2007-03-29  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (Fset_buffer_major_mode): Check that BUFFER is valid.

	* process.c (Fformat_network_address): Return nil when the
	argument vector contains invalid values.

2007-03-28  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* gmalloc.c [HAVE_GTK_AND_PTHREAD]: Define USE_PTHREAD.
	[USE_PTHREAD]: Include pthread.h.
	(malloc_init_once_control, _malloc_mutex) [USE_PTHREAD]: New variables.
	(malloc_initialize_1): New function created from __malloc_initialize.
	(__malloc_initialize): Use it.
	(LOCK, UNLOCK): New macros to make malloc etc. thread safe.
	(_malloc_internal, _free_internal, _realloc_internal): Use them.

	* lread.c (readchar): Extend BLOCK_INPUT block to ferror/clearerr.

2007-03-27  Juanma Barranquero  <lekktu@gmail.com>

	* process.c (Fformat_network_address): Make args array big enough
	to format IPv6 addresses.

2007-03-27  Glenn Morris  <rgm@gnu.org>

	* m/hp800.h: Restore HP-UX support (removed 2007-01-29).

2007-03-26  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_display_mm_height, Fx_display_mm_width): Scale whole
	screen size in pixels by millimeters per pixel of main display.

	* macselect.c (get_scrap_target_type_list, x_own_selection):
	Move assignments outside predicate macros.
	(Vselection_converter_alist): Doc fix.

	* macterm.c (create_text_encoding_info_alist): Move assignments
	outside predicate macros.
	(mac_initialize_display_info) [MAC_OSX]: dpyinfo->height and
	dpyinfo->width are those of whole screen.

2007-03-26  Sam Steingold  <sds@gnu.org>

	* process.c (sigchld_handler): Delay by 1ms instead of 1s to
	alleviate sluggishness (the original problem is still fixed).

2007-03-25  Kim F. Storm  <storm@cua.dk>

	* intervals.c (merge_properties): Use explicit loop instead of
	Fplist_member to avoid QUIT.  Don't use Fcdr.
	(intervals_equal): Likewise.  Rewrite loop to perform length check
	on the fly rather than calling Flength.  Don't use Fcar.

2007-03-24  Eli Zaretskii  <eliz@gnu.org>

	* editfns.c (Fgoto_char): Doc fix.

	* indent.c (Findent_to): Doc fix.

2007-03-24  Chong Yidong  <cyd@stupidchicken.com>

	* editfns.c (Ftranspose_regions): Use set_text_properties_1
	instead of Fset_text_properties to avoid GC.  Signal after change.

2007-03-24  Eli Zaretskii  <eliz@gnu.org>

	* xfns.c (Fx_show_tip): Doc fix.

	* macfns.c (Fx_show_tip): Doc fix.

	* w32fns.c (Fx_show_tip): Doc fix.

2007-03-23  Kim F. Storm  <storm@cua.dk>

	* intervals.c (merge_properties, intervals_equal):
	Use Fplist_member instead of Fmemq to find properties.

2007-03-23  Glenn Morris  <rgm@gnu.org>

	* unexhp9k800.c: Restore file with clarified legal status.
	* m/sr2k.h: Restore since dependency unexhp9k800.c is restored.

2007-03-22  Chong Yidong  <cyd@stupidchicken.com>

	* widget.c (EmacsFrameSetCharSize): Catch X errors.

2007-03-22  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Fcopy_file): Call barf_or_query_if_file_exists with
	non-encoded file name.
	(Frename_file): Likewise.
	(Fadd_name_to_file): Likewise.
	(Fmake_symbolic_link): Likewise.

2007-03-20  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (alloca.o, gtkutil.o): Depend on systime.h.
	(dired.o, editfns.o, fileio.o, msdos.o): Depend on atimer.h.
	(dosfns.o, window.o, fns.o, macselect.o): Depend on atimer.h and
	systime.h.
	(term.o, print.o, lread.o): Depend on blockinput.h, atimer.h, and
	systime.h.
	(macfns.o): Remove duplicate dependency on systime.h.

	* dispnew.c (Fopen_termscript): Add BLOCK_INPUT around fclose.
	(Fsend_string_to_terminal): Add BLOCK_INPUT around fwrite.

	* fileio.c (do_auto_save_unwind): Add BLOCK_INPUT around fclose.
	(Fdo_auto_save): Add BLOCK_INPUT around fwrite.

	* keyboard.c (record_char): Add BLOCK_INPUT around fwrite.
	(Fopen_dribble_file): Add BLOCK_INPUT around fclose.

	* lread.c: Include blockinput.h.
	(readchar, Fget_file_char): Add BLOCK_INPUT around getc.
	(unreadchar): Add BLOCK_INPUT around ungetc.
	(load_unwind): Add BLOCK_INPUT around fclose.

	* print.c: Include blockinput.h.
	(Fredirect_debugging_output): Add BLOCK_INPUT around fclose.

	* process.c (Fmake_network_process) [HAVE_GETADDRINFO]:
	Clear immediate_quit before calling freeaddrinfo.
	Add BLOCK_INPUT around freeaddrinfo.

	* term.c: Include blockinput.h.
	(write_glyphs, insert_glyphs): Add BLOCK_INPUT around fwrite.

2007-03-19  Richard Stallman  <rms@gnu.org>

	* keyboard.c (NUM_RECENT_KEYS): Bump up to 300.

	* buffer.c (syms_of_buffer): Doc fix.

2007-03-18  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (pbm_load): Signal error for invalid image size.

2007-03-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement): Don't return immediately for
	LeaveNotify case.

	* macmenu.c (popup_activated_flag): New variable.
	(x_activate_menubar, mac_menu_show): Set it during menu tracking.
	(popup_activated): New function.

	* xdisp.c (redisplay_internal, note_mouse_highlight):
	Check popup_activated for MAC_OS.

2007-03-17  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <buffer-display-table>: Doc fix.
	Reported by Nikolaj Schumacher <n_schumacher@web.de>.

2007-03-17  Richard Stallman  <rms@gnu.org>

	* dired.c (file_name_completion): gcpro NAME.

2007-03-17  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (try_window_id): Increment matrix positions if the
	buffer's byte count has increased, but not the character count.

2007-03-12  Andreas Schwab  <schwab@suse.de>

	* lisp.h: Declare check_obarray.

	* process.c (Fdelete_process): Properly handle deletion of first
	element of deleted_pid_list.
	(create_process): Declare pid as pid_t.

2007-03-12  Kim F. Storm  <storm@cua.dk>

	* process.c (sigchld_handler): Change type of pid to pid_t.
	Scan deleted_pid_list explicitly to avoid using Fmember which don't
	know about mark bits and make_fixnum_or_float which may malloc.
	Reported by Andreas Schwab.

	* keyboard.c (read_key_sequence): Store original event into keybuf
	when replaying sequence with local keymap(s) from string.

2007-03-12  Glenn Morris  <rgm@gnu.org>

	* editfns.c (Fdecode_time, Fencode_time): Doc fix ("daylight
	savings" to "daylight saving").

2007-03-11  Sam Steingold  <sds@gnu.org>

	* process.c (sigchld_handler): Sleep before wait3 to avoid a busyloop.

2007-03-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_server_vendor): Change vendor string to "Apple Inc.".

2007-03-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_CARBON_EVENTS] (mac_handle_mouse_event):
	Ignore mouse wheel movement on title bar or tool bar.

2007-03-10  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (help_form_saved_window_configs): New var.
	(read_char_help_form_unwind): New function.
	(read_char): Don't restore window configuration if a mouse click
	arrives while the help form is being displayed.

2007-03-10  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Don't automatically select a new window
	start for a contination line during mouse-click.

2007-03-09  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Ignore buttons > 3 for the tool bar.

2007-03-09  Juanma Barranquero  <lekktu@gmail.com>

	* keymap.c (Fdescribe_buffer_bindings): Check that BUFFER is valid.

2007-03-08  Richard Stallman  <rms@gnu.org>

	* keyboard.c (syms_of_keyboard): Doc fix.

2007-03-08  Chong Yidong  <cyd@stupidchicken.com>

	* minibuf.c (Ftry_completion): Don't short circuit if
	completion-ignore-case is non-nil.

2007-03-07  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (mac_set_scroll_bar_width, mac_frame_parm_handlers):
	Undo 2006-03-06 changes.

	* macterm.c (XTset_vertical_scroll_bar) [MAC_OSX]: Don't show scroll
	bar if its width is smaller than that of Aqua small scroll bar.

2007-03-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (read_minibuf): Bind inhibit-read-only a bit longer so as
	to handle correctly prompts with read-only property.

2007-03-06  Jan Djärv  <jan.h.d@swipnet.se>

	* sound.c (wav_play): Check header->data_length to see how much we
	shall read.
	(alsa_period_size): Convert ALSA period size in frames to bytes.
	(alsa_write): Return if frames is zero.

2007-03-06  Kenichi Handa  <handa@m17n.org>

	* xselect.c (Vselection_coding_system): Documentation improved.

2007-03-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_scroll_bar_create, XTread_socket): Replace #if
	USE_TOOLKIT_SCROLL_BARS with #ifdef USE_TOOLKIT_SCROLL_BARS.
	(x_set_window_size): Call SET_FRAME_GARBAGED.  Clear window if
	internal border width has changed.

	* macterm.h (struct mac_output): New member `internal_border_width'.

2007-03-04  Richard Stallman  <rms@gnu.org>

	* window.c (Fdisplay_buffer): Doc fix.

2007-03-03  Glenn Morris  <rgm@gnu.org>

	* Makefile.in: Don't clear out LIB_X11_LIB, since XFT_LIBS does
	not include -lX11 on Solaris.

2007-03-02  Stuart D. Herring  <herring@lanl.gov>

	* keymap.c (Fkey_binding): Don't consider one-element lists as events.

2007-03-01  Kenichi Handa  <handa@m17n.org>

	* process.c (send_process_object): Check the process status and
	signal an error if something is wrong.

2007-02-28  Chong Yidong  <cyd@stupidchicken.com>

	* insdel.c (Fcombine_after_change_execute): Return nil if
	combine_after_change_buffer has been invalidated.

2007-02-25  Dan Nicolaescu  <dann@ics.uci.edu>

	* m/xtensa.h: New file.

2007-02-24  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit (xprintstr): Ensure GDB (> 6.6) prints symbol name
	as strings and not character arrays.

2007-02-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_TOOLKIT_SCROLL_BARS] (x_scroll_bar_handle_drag)
	(x_set_toolkit_scroll_bar_thumb): Add bar->min_handle as margin to
	scroll bar handle size in order to avoid `scroll backward' problem.
	(x_scroll_bar_create, XTset_vertical_scroll_bar)
	[USE_TOOLKIT_SCROLL_BARS]: Initialize bar->min_handle.

	* macterm.h (struct scroll_bar) [USE_TOOLKIT_SCROLL_BARS]:
	New member `min_handle'.

2007-02-23  Kim F. Storm  <storm@cua.dk>

	* print.c (print): Reset print_number_index if Vprint_number_table
	is nil.

2007-02-23  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (stat, get_long_basename, is_unc_volume): Use _mbspbrk
	instead of strpbrk.

2007-02-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (mac_menu_show): Call unbind_to early.  Use variable
	`menu_item_selection' as in W32 version.
	[TARGET_API_MAC_CARBON] (mac_handle_dialog_event): Add explicit
	braces to avoid ambiguous `else'.

	* macterm.c (mac_display_info_for_display): Remove function.
	(mac_flush_display_optional) [USE_CG_DRAWING]: New function.
	(x_redisplay_interface) [USE_CG_DRAWING]: Set it as handler for
	flush_display_optional.
	[USE_TOOLKIT_SCROLL_BARS] (x_scroll_bar_handle_press):
	New argument MOUSE_POS.  All uses changed.  Set bar->dragging to
	negative integer if scroll bar handle is pressed.
	[USE_TOOLKIT_SCROLL_BARS] (x_scroll_bar_handle_release):
	Negative bar->dragging means scroll bar handle is not dragged.
	[USE_TOOLKIT_SCROLL_BARS] (x_scroll_bar_handle_drag): Get initial
	offset of scroll bar handle from negative bar->dragging.
	(XTread_socket) [USE_TOOLKIT_SCROLL_BARS]: Modifiers for scroll
	bar click is compared against mapped one.  Set down/up_modifier
	for scroll bar click event with control key.

	* macterm.h (x_display_info_for_display): Remove extern.
	(SCROLL_BAR_UNPACK, SET_SCROLL_BAR_CONTROL_HANDLE): Don't limit
	value to be unpacked to 32-bit on LP64 model.

2007-02-23  Kenichi Handa  <handa@m17n.org>

	* process.c (send_process_object_unwind): New function.
	(send_process_object): New function.
	(Fprocess_send_region): Call send_process_object.
	(Fprocess_send_string): Likewise.

2007-02-22  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (w32_menu_show): Mark the frame's menu as inactive
	when popup menu finishes.

	* w32fns.c (menubar_in_use): New flag.
	(w32_wnd_proc) <WM_INITMENU, WM_EXITMENULOOP, WM_TIMER, WM_COMMAND>:
	Use it.

	* w32menu.c (Fx_popup_menu): Don't free menu strings here.
	(w32_menu_show): Do it here instead.

	* w32fns.c (w32_wnd_proc) <WM_INITMENU>: Set menubar_active frame
	parameter.

	* w32menu.c (current_popup_menu): Make available globally.
	(menubar_selection_callback): Free menu strings before pushing the
	menu event into the keyboard buffer.  Remove menu_command_in_progress.

	* w32fns.c (current_popup_menu): Use from w32menu.c.
	(w32_wnd_proc) <WM_EXITMENULOOP, WM_TIMER>: Use menubar_active
	and current_popup_menu to determine whether a menubar menu has
	been cancelled.

	* w32term.h (w32_output): Remove menu_command_in_progress.

2007-02-22  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (update_frame, update_single_window): Set force_p here if
	redisplay_dont_pause is set or Vredisplay_preemption_period is nil...
	(update_window, update_frame_1): ... instead of here.
	(update_text_area): Clear mouse face on header lines.

2007-02-21  Kim F. Storm  <storm@cua.dk>

	* minibuf.c (Fassoc_string): Doc fix.  Allow symbol for KEY too.

2007-02-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (WINDOW_RESOURCE, TERM_WINDOW_RESOURCE): Remove macros.
	[USE_MAC_TSM] (mac_handle_text_input_event): Remove unused variable
	`mapped_modifiers'.
	(XTread_socket) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1020]: Use Keyboard
	Layout Services routines to get current Unicode keyboard layout.

2007-02-20  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (x_set_screen_gamma): Apply gamma value to the frame's
	bgcolor.

2007-02-19  Kim F. Storm  <storm@cua.dk>

	* minibuf.c (Fassoc_string): Allow symbols as keys.

	* w32term.c (w32_set_scroll_bar_thumb): Don't resize scroll-bar
	handle while dragging, except when we get close to eob.
	Fix position and size calculations so we don't scroll backwards
	just by clicking on the handle.

2007-02-17  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (${emacsapp}Contents/Resources/Emacs.rsrc)
	[HAVE_CARBON]: Remove target.
	(macosx-app) [HAVE_CARBON]: Don't depend on it.

2007-02-17  Juanma Barranquero  <lekktu@gmail.com>

	* callproc.c (syms_of_callproc) <doc-directory>:
	<configure-info-directory>:
	(Fgetenv_internal): Fix typos in docstrings.

	* doc.c (Fsubstitute_command_keys): Fix typo in docstring.

2007-02-16  Andreas Schwab  <schwab@suse.de>

	* frame.c (Fmodify_frame_parameters): Return a value.

	* editfns.c (Fformat): Add support for '+' flag.
	* doprnt.c (doprnt1): Likewise.  Fix overflow checking.

2007-02-14  Chong Yidong  <cyd@stupidchicken.com>

	* s/umips.h: Unused file removed.

2007-02-14  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Fcolor_distance): Don't continue checking a color for
	errors after it has been correctly parsed as an RGB list.

2007-02-14  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (do_ewmh_fullscreen): Also check for _NET_WM_STATE_FULLSCREEN.

2007-02-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_focus_frame): Move current process to foreground if
	it is not.
	[TARGET_API_MAC_CARBON] (Fx_file_dialog): Replace #if MAC_OSX with
	#ifdef MAC_OSX.
	(Fmac_set_font_panel_visible_p) [USE_MAC_FONT_PANEL]: Rename from
	Fmac_set_font_panel_visibility.  All uses changed.  Rename argument
	VISIBLE to FLAG.

	* macterm.c (MakeMeTheFrontProcess) [MAC_OSX]: Remove function.
	(mac_initialize) [MAC_OSX]: Call SetFrontProcess instead of
	MakeMeTheFrontProcess.

2007-02-12  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (x_set_screen_gamma): Clear face cache.

2007-02-11  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (Fgenerate_new_buffer_name, Fbuffer_modified_tick):
	Reflow docstrings.

2007-02-10  Eli Zaretskii  <eliz@gnu.org>

	* window.c (Fwindow_height, Fwindow_hscroll)
	(Fwindow_redisplay_end_trigger, Fwindow_point, Fwindow_start)
	(Fwindow_end, Fwindow_display_table, Fwindow_text_height):
	Document the effect of WINDOW arg being nil.

2007-02-08  Kim F. Storm  <storm@cua.dk>

	* minibuf.c (read_minibuf): Fix 2007-01-30 change.
	Use Qlambda as interim value of Vminibuffer_completing_file_name.
	(Fcompleting_read): Use non-filename maps if value is Qlambda (or Qnil).
	(syms_of_minibuf) <minibuffer-completing-file-name>: Document lambda.

2007-02-07  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(TRES)): Use literal "../nt/emacs.rc" instead
	of $(ALL_DEPS).

2007-02-07  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(TRES)): Depend on stamp_BLD, since $(TRES) is
	put into $(BLD).

2007-02-06  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (Fmodify_frame_parameters): Don't bind
	Qinhibit_default_face_x_resources, which has no effect.
	(Qinhibit_default_face_x_resources): Symbol deleted.

2007-02-03  Eli Zaretskii  <eliz@gnu.org>

	* indent.c (Fmove_to_column): Document that the argument COLUMN is
	taken from prefix numeric argument.

2007-02-03  Juanma Barranquero  <lekktu@gmail.com>

	* lread.c (syms_of_lread) <load-history>: Doc fix.

2007-01-29  Andreas Seltenreich  <uwi7@rz.uni-karlsruhe.de>  (tiny change)

	* xterm.c [!USE_TOOLKIT_SCROLL_BARS] (x_scroll_bar_expose):
	Use the foreground color of the scroll-bar face when drawing
	the scroll-bar's border.

2007-02-02  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (do_ewmh_fullscreen): Check that what != NULL before
	calling wm_supports.

2007-02-01  Juanma Barranquero  <lekktu@gmail.com>

	* lread.c (syms_of_lread) <user-init-file>: Doc fix.
	Wording by Eli Zaretskii.

2007-01-31  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (update_frame_tool_bar): Initialize h/vmargin to 0.

2007-01-30  Richard Stallman  <rms@gnu.org>

	* minibuf.c (read_minibuf):
	Save and clear Vminibuffer_completing_file_name.
	(read_minibuf_unwind): Restore it.
	(Vminibuffer_completion_table, Qminibuffer_completion_table)
	(Vminibuffer_completion_predicate, Qminibuffer_completion_predicate)
	(Vminibuffer_completion_confirm, Qminibuffer_completion_confirm)
	(Vminibuffer_completing_file_name): Definitions moved up.

2007-01-29  Chong Yidong  <cyd@stupidchicken.com>

	* m/hp800.h: Restore, removing HP-UX support.

2007-01-29  Jan Djärv  <jan.h.d@swipnet.se>

	* Makefile.in: Use a variable, XFT_LIBS, instead #define LIB_X11_LIB.

2007-01-28  Richard Stallman  <rms@gnu.org>

	* minibuf.c (Ftry_completion, Fall_completions)
	(Fcompleting_read, Ftest_completion):
	Rename arg ALIST or TABLE to COLLECTION.

2007-01-27  Chong Yidong  <cyd@stupidchicken.com>

	* unexhp9k800.c: Remove due to lack of legal papers.

	* m/sr2k.h, m/hp800.h: Remove due to dependence on above.

2007-01-27  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (Fthis_command_keys, Fthis_command_keys_vector): Doc fix.

	* minibuf.c (Fcompleting_read): Doc fix.

2007-01-26  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_initialize): Call XftInit if HAVE_XFT.

	* Makefile.in: Use XFT_LIBS if defined.

2007-01-26  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (BLOCK_INPUT_ALLOC, UNBLOCK_INPUT_ALLOC): Use
	BLOCK_INPUT/UNBLOCK_INPUT.

	* blockinput.h (interrupt_input_blocked): Declare volatile.

	* keyboard.c (interrupt_input_blocked): Declare volatile.

	* syssignal.h (SIGNAL_THREAD_CHECK): Use pthread_equal.

2007-01-24  Kim F. Storm  <storm@cua.dk>

	* keymap.c (describe_map): Don't consider prefix keys to be shadowed.

2007-01-23  Juanma Barranquero  <lekktu@gmail.com>

	* editfns.c (Finsert_char): Doc fix.
	(Fget_internal_run_time, Fdecode_time): Fix typos in docstrings.

2007-01-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macselect.c [TARGET_API_MAC_CARBON] (mac_do_receive_drag):
	Don't pass keyboard modifiers to mac_store_drag_event, but put
	them as kEventParamKeyModifiers Apple event parameter.

2007-01-21  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (try_window): Revert previous change.

	* dispnew.c (update_text_area): Revert 2006-09-17 change.
	Always redraw non-mode-line rows with mouse-face.

2007-01-20  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (try_window): Clear mouse-face highlights first.

	* window.c (set_window_buffer): Revert 2006-11-22 change.

2007-01-20  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit (ppt, xtype, xmisctype, xint, xptr, xmarker, xframe)
	(xbuffer, xcons, xcar, xcdr): Fix doc strings.

2007-01-20  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_key_sequence): Extract local map only if the
	given position is in an accessible buffer region.

2007-01-19  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit: Reformat documentation so that first sentence
	displays properly with "help user-defined" (like apropos).

2007-01-18  Bruno Haible  <bruno@clisp.org>  (tiny change)

	* epaths.in: Move PATH_DOC from local/info to local/share/info.

2007-01-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (create_and_show_dialog) [TARGET_API_MAC_CARBON]:
	Create movable modal window instead of movable alert window.
	(create_and_show_dialog) [!MAC_OSX]: Use DeactivateControl instead
	of DisableControl.

	* macselect.c (Fmac_resume_apple_event): Set error number when
	descriptor type of reply is non-null.

2007-01-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (create_and_show_dialog) [TARGET_API_MAC_CARBON]:
	Use DisableControl for disabled items.  Set default button to first
	enabled one.  Use icon of application in execution.

2007-01-13  Eli Zaretskii  <eliz@gnu.org>

	* process.c (Fdelete_process, Fprocess_id, sigchld_handler):
	Copy PID into EMACS_INT to avoid GCC warnings.

	* fns.c (maybe_resize_hash_table): Copy new size of hash table
	into EMACS_INT to avoid GCC warnings.

	* editfns.c (Fuser_uid, Fuser_real_uid): Copy values returned by
	geteuid and getuid into EMACS_INT to avoid GCC warnings.

	* dired.c (Ffile_attributes): Fix last change.

2007-01-12  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Copy some members of `struct stat'
	into int's to avoid GCC warnings about limited range of short in
	arguments to FIXNUM_OVERFLOW_P.

2007-01-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (HAVE_DIALOGS): Define if TARGET_API_MAC_CARBON.
	(mac_handle_dialog_event, install_dialog_event_handler)
	(create_and_show_dialog) [TARGET_API_MAC_CARBON]: New functions.
	(DIALOG_LEFT_MARGIN, DIALOG_TOP_MARGIN, DIALOG_RIGHT_MARGIN)
	(DIALOG_BOTTOM_MARGIN, DIALOG_MIN_INNER_WIDTH)
	(DIALOG_MAX_INNER_WIDTH, DIALOG_BUTTON_BUTTON_HORIZONTAL_SPACE)
	(DIALOG_BUTTON_BUTTON_VERTICAL_SPACE, DIALOG_BUTTON_MIN_WIDTH)
	(DIALOG_TEXT_MIN_HEIGHT, DIALOG_TEXT_BUTTONS_VERTICAL_SPACE)
	(DIALOG_ICON_WIDTH, DIALOG_ICON_HEIGHT, DIALOG_ICON_LEFT_MARGIN)
	(DIALOG_ICON_TOP_MARGIN) [TARGET_API_MAC_CARBON]: New macros.
	(mac_dialog) [TARGET_API_MAC_CARBON]: Remove function.
	(mac_dialog_show) [TARGET_API_MAC_CARBON]: Use create_and_show_dialog.

	* macterm.c (x_free_frame_resources) [USE_CG_DRAWING]:
	Call mac_prepare_for_quickdraw.
	(quit_char, make_ctrl_char) [TARGET_API_MAC_CARBON]: Move externs
	outside #ifdef MAC_OSX.
	(mac_quit_char_key_p) [TARGET_API_MAC_CARBON]: Move function
	outside #ifdef MAC_OSX.
	(mac_check_bundle) [MAC_OSX]: Remove unused function.

	* macterm.h (mac_quit_char_key_p): Move extern outside #ifdef MAC_OSX.
	(HOURGLASS_WIDTH, HOURGLASS_HEIGHT): Parenthesize definitions.

2007-01-11  Jan Djärv  <jan.h.d@swipnet.se>

	* alloc.c (BLOCK_INPUT_ALLOC, UNBLOCK_INPUT_ALLOC): Use pthread_equal,
	block/unblock SIGIO.

2007-01-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fformat): Allow integer-format to work with floats of size
	larger than most-positive-fixnum (but still smaller than MAXINT).

	* dired.c (Ffile_attributes): Use floats for large uids/gids.

2007-01-09  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (syms_of_emacs) <path-separator>: Doc fix.

2007-01-09  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* callproc.c (Fcall_process_region) [HAVE_MKSTEMP]: Add BLOCK_INPUT
	around mkstemp.

	* image.c (XDrawLine) [MAC_OS]: Remove macro.
	(XCreateGC_pixmap) [!HAVE_NTGUI]: Likewise.
	(x_disable_image) [!HAVE_NTGUI]: Use XCreateGC instead of
	XCreateGC_pixmap.

	* macgui.h (Display): Typedef to opaque type.

	* macmenu.c (mac_dialog_modal_filter) [MAC_OSX]: New function.
	(Fx_popup_dialog) [MAC_OSX]: Use standard alert if called from
	Fmessage_box, Fyes_or_no_p, or Fy_or_n_p.
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030] (menu_quit_handler):
	Use mac_quit_char_key_p.

	* macterm.c (XDrawLine): Rename from mac_draw_line_to_pixmap.
	(XCreateGC): Change type of 2nd argument to void *.
	(XFreeGC) [USE_CG_DRAWING && MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Fix last change.
	(mac_to_emacs_modifiers): Change return type to int.
	[USE_CARBON_EVENTS] (mac_event_to_emacs_modifiers): Likewise.
	(mac_mapped_modifiers): New function.
	(XTread_socket): Use it.
	[USE_TSM] (mac_handle_text_input_event): Likewise.
	(do_window_update) [USE_CG_DRAWING]: Call mac_prepare_for_quickdraw.
	(mac_quit_char_modifiers, mac_quit_char_keycode) [MAC_OSX]:
	Remove variables.
	(mac_determine_quit_char_modifiers, init_quit_char_handler)
	[MAC_OSX]: Remove functions.
	(make_ctrl_char) [MAC_OSX]: Add extern.
	(mac_quit_char_key_p) [MAC_OSX]: New function.
	(mac_initialize) [MAC_OSX]: Don't call init_quit_char_handler.

	* macterm.h (FONT_MAX_WIDTH): Remove unused macro.
	(XCreateGC): Change type in extern.
	(XDrawLine): Rename from mac_draw_line_to_pixmap.
	(mac_quit_char_key_p) [MAC_OSX]: Add extern.

2007-01-08  Jan Djärv  <jan.h.d@swipnet.se>

	* keyboard.c (init_keyboard): Initialize interrupt_input_blocked and
	interrupt_input_pending.

	* xterm.h (x_display_info): New: net_supported_atoms,
	nr_net_supported_atoms and net_supported_window.

	* xterm.c (last_user_time): New variable.
	(handle_one_xevent): Set last_user_time from events that have Time.
	Set net_supported_window to 0 when reparented.
	(wm_supports): New function.
	(do_ewmh_fullscreen): Use wm_supports to check for _NET_WM_STATE.
	(x_term_init): Initialize net_supported_atoms, nr_net_supported_atoms
	and net_supported_window.

2007-01-05  Kim F. Storm  <storm@cua.dk>

	* indent.c (Fvertical_motion): Fix it overshoot check for overlay
	strings without embedded newlines immediately followed by newline.

2007-01-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* editfns.c (Fformat_time_string, Fdecode_time, Fencode_time)
	(Fcurrent_time_string, Fcurrent_time_zone): Add BLOCK_INPUT around
	gmtime/localtime/emacs_memftimeu/mktime.

	* mac.c (Fmac_set_file_creator): Use MAC_EMACS_CREATOR_CODE
	instead of 'EMAx'.
	[!MAC_OSX] (sys_open, sys_creat, sys_fopen): Likewise.

	* macgui.h (struct _XGC) [USE_CG_DRAWING
	&& MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: New members cg_fore_color
	and cg_back_color.

	* macmenu.c (Vshow_help_function) [TARGET_API_MAC_CARBON]: Add extern.
	(restore_show_help_function, menu_target_item_handler)
	[TARGET_API_MAC_CARBON]: New functions.
	(install_menu_target_item_handler): New function.
	(add_menu_item) [TARGET_API_MAC_CARBON]: Set help string as menu
	item property.

	* macterm.c (CG_SET_FILL_COLOR_MAYBE_WITH_CGCOLOR)
	(CG_SET_FILL_COLOR_WITH_GC_FOREGROUND)
	(CG_SET_FILL_COLOR_WITH_GC_BACKGROUND)
	(CG_SET_STROKE_COLOR_MAYBE_WITH_CGCOLOR)
	(CG_SET_STROKE_COLOR_WITH_GC_FOREGROUND): New macros.
	(mac_cg_color_space_rgb) [USE_CG_DRAWING]: New variable.
	(mac_cg_color_black) [USE_CG_DRAWING
	&& MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: New variable.
	(init_cg_color) [USE_CG_DRAWING]: New function.
	(mac_draw_line, mac_draw_rectangle) [USE_CG_DRAWING]: Use
	CG_SET_STROKE_COLOR_WITH_GC_FOREGROUND instead of CG_SET_STROKE_COLOR.
	(mac_erase_rectangle, mac_clear_window, mac_draw_cg_image)
	(mac_fill_rectangle, mac_draw_image_string_cg) [USE_CG_DRAWING]:
	Use CG_SET_FILL_COLOR_WITH_GC_FOREGROUND or
	CG_SET_FILL_COLOR_WITH_GC_BACKGROUND instead of CG_SET_FILL_COLOR.
	(mac_draw_string_common) [MAC_OSX && USE_ATSUI]: Likewise.
	(XCreateGC, XFreeGC, XSetForeground, XSetBackground) [USE_CG_DRAWING
	&& MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Use gc->cg_fore_color and/or
	gc->cg_back_color.
	(install_drag_handler, remove_drag_handler): Make extern.
	(install_menu_target_item_handler): Add extern.
	(install_window_handler): Call install_menu_target_item_handler.
	[MAC_OS8] (main): Use MAC_EMACS_CREATOR_CODE instead of 'EMAx'.
	(mac_initialize) [USE_CG_DRAWING]: Call init_cg_color.

	* macterm.h (MAC_EMACS_CREATOR_CODE): New enumerator.

2007-01-04  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fwindow_end): Fix use of >= operator.

2007-01-03  Richard Stallman  <rms@gnu.org>

	* window.c (Fwindow_end): Check BUF_OVERLAY_MODIFF like BUF_MODIFF.

2007-01-02  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.h (xg_menu_item_cb_data_): Remove highlight_id and
	unhighlight_id.

	* gtkutil.c (menuitem_highlight_callback): Invoked widget is the
	parent of the menu item.  Get menu item widget from event.
	(xg_create_one_menuitem, xg_update_menu_item): highlight_id and
	unhighlight_id has been removed.
	(create_menus): Connect enter/leave-notify-event to the menu instead
	of individual items.

2006-12-31  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (update_frame_tool_bar): Connect create-menu-proxy with
	xg_tool_bar_menu_proxy.
	(xg_tool_bar_menu_proxy): New function.
	(xg_tool_bar_proxy_callback): New function.

2006-12-30  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_tool_bar_button_cb): Save last modifier on widget.
	(xg_tool_bar_callback): Remove check for button.
	(update_frame_tool_bar): Put an event box in the tool bar and a button
	in the event box.  Attach enter/leave-notify-event to the event box.

2006-12-30  Richard Stallman  <rms@gnu.org>

	* keymap.c (Fdefine_key): Doc fix.

2006-12-29  Kim F. Storm  <storm@cua.dk>

	* frame.h (struct frame): New member minimize_tool_bar_window_p.

	* xdisp.c (auto_resize_tool_bars_p): Replace with ...
	(Vauto_resize_tool_bars): ... this.
	(syms_of_xdisp): DEFVAR_LISP and initialize it.  Update doc string
	to describe new value `grow-only', and use of C-l.
	(display_tool_bar_line): Only use default face for border below
	toolbar if not grow-only (to get acceptable visual appearence).
	Explicitly set visible_height for empty toolbar lines.
	(redisplay_tool_bar): Handle `grow-only' setting.  Check and clear
	minimize_tool_bar_window_p flag.

	* window.c (Frecenter): Set minimize_tool_bar_window_p flag
	when called without arg to redraw with minimum toolbar height.
	Update doc string.

2006-12-29  Jason Rumney  <jasonr@gnu.org>

	* s/ms-w32.h (tzname): Do not define in msvc8.
	(utime): Do not define in msvc8.

	* regex.c (regerror): Change parameter name err_code.

2006-12-26  Richard Stallman  <rms@gnu.org>

	* search.c (Fsearch_forward): Doc fix.

	* callint.c (Finteractive): Doc fix.

2006-12-25  Kim F. Storm  <storm@cua.dk>

	* s/ms-w32.h (BROKEN_DATAGRAM_SOCKETS): Define it.

2006-12-23  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (some_mouse_moved): Fix last change.

2006-12-22  Eli Zaretskii  <eliz@gnu.org>

	* callproc.c (syms_of_callproc) <shell-file-name>: Doc fix.

2006-12-22  Mark Davies  <mark@mcs.vuw.ac.nz>

	* m/amdx86-64.h, m/hp800.h: Add support for NetBSD.
	* m/sh3el.h: New file.

2006-12-22  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (emacs, temacs): Depend on stamp_BLD instead of
	$(BLD).
	($(OBJ0) $(OBJ1) $(WIN32OBJ)): New dependency on stamp_BLD.
	(bootstrap-temacs): Pass $(XMFLAGS) to sub-make.
	($(OBJ0) $(OBJ1) $(WIN32OBJ)): Add lastfile.$(O) and firstfile.$(O).
	(clean): Delete stamp_BLD.

2006-12-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (mac_update_title_bar) [TARGET_API_MAC_CARBON]:
	Call mac_update_proxy_icon also when buffer modification flag changed.
	[TARGET_API_MAC_CARBON] (mac_update_proxy_icon): Don't update alias,
	but compare FSRef/FSSpec of resolved alias.

2006-12-21  Kim F. Storm  <storm@cua.dk>

	* w32.c (_sys_wait_accept): Fix handle leak.

2006-12-20  Jan Djärv  <jan.h.d@swipnet.se>

	* sound.c: Include <alsa/asoundlib.h> if ALSA_SUBDIR_INCLUDE is
	defined.

2006-12-20  Kim F. Storm  <storm@cua.dk>

	* s/ms-w32.h (BROKEN_NON_BLOCKING_CONNECT): Define it.

2006-12-19  Juanma Barranquero  <lekktu@gmail.com>

	* keyboard.c (syms_of_keyboard) <double-click-time>:
	* mac.c (Fmac_code_convert_string):
	* search.c (Fsearch_forward): Doc fixes.

2006-12-19  Kim F. Storm  <storm@cua.dk>

	Rework 2006-12-04 change.  A SIGUSR1 (SIGUSR2) signal now generates
	a sigusr1 event instead of [signal usr1] sequence, and signal events
	are now supposed to be handled via special-event-map.

	* keyboard.c (kbd_buffer_store_event_hold): Undo 2006-12-04 change.
	(make_lispy_event): Don't generate Qsignal prefix for code 0.
	Abort if signal code is unknown.
	(store_user_signal_events): Don't make Qsignal prefix (code 0).
	(Qsignal): Move declaration back to process.c.
	(syms_of_keyboard): Don't intern or staticpro it here.

	* process.c (Qsignal): Declare here.
	(syms_of_process): Intern or staticpro it.

	* emacs.c (main): Rename user signals to sigusr1 and sigusr2.

	* .gdbinit: Pass on SIGUSR1 and SIGUSR2 to Emacs.

2006-12-19  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <buffer-display-table>:
	<scroll-up-aggressively, scroll-down-aggressively>: Doc fixes.

2006-12-17  Richard Stallman  <rms@gnu.org>

	* fileio.c (Fread_file_name_internal): Pass Vread_file_name_predicate
	to Ffile_name_completion.

	* dired.c (file_name_completion): New arg PREDICATE.  Some cleanup.
	(Ffile_name_completion): New arg PREDICATE.

2006-12-17  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (Fkill_buffer): Doc fix.
	(syms_of_buffer) <kill-buffer-query-functions>: Doc fix.

2006-12-16  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (Ftry_completion): Check that obarray buckets are symbols.

2006-12-16  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32-window-exists-p): New function.
	(syms_of_w32fns): Defsubr it.

	* prefix-args.c [STDC_HEADERS]: Include stdlib.h.

2006-12-16  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (Ftry_completion): Use `check_obarray' if ALIST is a vector.

2006-12-15  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (USAGE3): Clarify documentation of --color.

2006-12-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (wakeup_from_rne_enabled_p) [TARGET_API_MAC_CARBON]:
	New variable.
	(ENABLE_WAKEUP_FROM_RNE, DISABLE_WAKEUP_FROM_RNE): New macros.
	[!MAC_OSX] (select): Use them.
	[MAC_OSX] (select_and_poll_event, sys_select): Likewise.
	(mac_wakeup_from_rne) [TARGET_API_MAC_CARBON]: New function.

	* macfns.c (mac_atsu_font_face_attributes) [USE_ATSUI]: Add extern.
	(Fmac_atsu_font_face_attributes) [USE_ATSUI]: New function.
	(syms_of_macfns) [USE_ATSUI]: Defsubr it.

	* macselect.c [TARGET_API_MAC_CARBON] (mac_do_receive_drag):
	Use mac_wakeup_from_rne instead of mac_post_mouse_moved_event.

	* macterm.c (mac_query_char_extents) [USE_ATSUI]: Don't call
	ATSUGetGlyphBounds if not necessary.
	(Vmac_atsu_font_table) [USE_ATSUI]: Remove variable.
	(syms_of_macterm) [USE_ATSUI]: Don't defvar it.
	(fm_get_style_from_font, atsu_find_font_from_family_name)
	(atsu_find_font_family_name, mac_atsu_font_face_attributes)
	[USE_ATSUI]: New functions.
	(init_font_name_table) [USE_ATSUI]: Use atsu_find_font_family_name.
	(mac_load_query_font) [USE_ATSUI]: Use atsu_find_font_from_family_name.
	Don't get metrics for Latin-1 right half characters.
	(mac_load_query_font): Don't load font if space width is not positive.
	[TARGET_API_MAC_CARBON] (mac_store_event_ref_as_apple_event):
	Use mac_wakeup_from_rne instead of mac_post_mouse_moved_event.
	(XTread_socket): Call SelectWindow when unfocused frame is clicked.

	* macterm.h (mac_wakeup_from_rne) [TARGET_API_MAC_CARBON]: Add extern.

2006-12-15  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (ignore_mouse_drag_p): New global var.
	(some_mouse_moved): Return 0 if it is non-zero.
	(make_lispy_event): Generate click event on mouse up if
	ignore_mouse_drag_p is non-zero, even if mouse moved.
	Clear ignore_mouse_drag_p on mouse down/up.

	* xdisp.c (redisplay_window): Set ignore_mouse_drag_p if tool-bar
	is resized to avoid generating a mouse drag event.

2006-12-14  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (w32_wnd_proc): Force non-tooltip frames to respect the
	minimum tracking size.  Remove non-working old hack to do the same.

2006-12-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (handle_user_signal): Move function to keyboard.c.
	(main): Use add_user_signal for SIGUSR1 and SIGUSR2.

	* keyboard.c (make_lispy_event): Use find_user_signal_name.
	(read_avail_input): Store pending user signal events.
	(struct user_signal_info): New struct.
	(user_signals): New variable.
	(add_user_signal, store_user_signal_events)
	(find_user_signal_name): New functions.
	(handle_user_signal): Move function from emacs.c.  Don't store
	USER_SIGNAL_EVENT here, but increment number of pending signals.

	* keyboard.h (add_user_signals): Add extern.

2006-12-11  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <cursor-in-non-selected-windows>:
	<default-scroll-up-aggressively, default-scroll-down-aggressively>:
	<line-spacing, left-margin>: Doc fixes.

	* xdisp.c (syms_of_xdisp) <mode-line-inverse-video>: Doc fix.

2006-12-10  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (show_mouse_face): Never use text cursor in tool-bar.

2006-12-10  Juanma Barranquero  <lekktu@gmail.com>

	* abbrev.c (syms_of_abbrev) <last-abbrev-text>:
	* buffer.c (syms_of_buffer) <default-major-mode>:
	* keymap.c (Flookup_key):
	* lread.c (Feval_buffer, Feval_region):
	* macterm.c (syms_of_macterm) <x-use-underline-position-properties>:
	<x-underline-at-descent-line, mac-emulate-three-button-mouse>:
	* marker.c (Fmarker_insertion_type):
	* minibuf.c (syms_of_minibuf) <minibuffer-completion-table>:
	* msdos.c (syms_of_msdos) <delete-exited-processes>:
	* w32term.c (syms_of_w32term) <x-use-underline-position-properties>:
	<x-underline-at-descent-line>:
	* xdisp.c (format-mode-line):
	* xterm.c (syms_of_xterm) <x-use-underline-position-properties>:
	<x-underline-at-descent-line>: Doc fixes.

2006-12-10  Andreas Schwab  <schwab@suse.de>

	* systime.h (EMACS_GET_TIME): Remove check for
	HAVE_STRUCT_TIMEZONE which is never defined.

2006-12-10  Alan Mackenzie  <acm@muc.de>

	* syntax.c (Fpartial_parse_sexp): Correct Docco: Elt 8 of the
	result is now neither the last elt nor optional for OLDSTATE.

2006-12-09  Eli Zaretskii  <eliz@gnu.org>

	* process.c (Fsignal_process): Doc fix.  Use XFLOAT_DATA to
	extract the process ID from a Lisp float.

2006-12-09  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (XTframe_raise_lower): Comment out _NET_ACTIVE_WINDOW code.

2006-12-08  Eli Zaretskii  <eliz@gnu.org>

	* frame.h (PIX_TYPE): Redefine as `unsigned long', for 64-bit
	platforms where long is 64-bit.

	* msdos.h (PIX_TYPE): Redefine as `unsigned long'.

2006-12-08  NAKAJI Hiroyuki  <nakaji@jp.freebsd.org>  (tiny change)

	* m/amdx86-64.h: Add support for Solaris 10 on x86-64.

2006-12-08  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_query_font): Use xstricmp instead off strcasecmp.

2006-12-08  Juanma Barranquero  <lekktu@gmail.com>

	* emacs.c (syms_of_emacs) <system-type>: Doc fix.

2006-12-07  Kim F. Storm  <storm@cua.dk>

	* process.c (parse_signal): Use xstricmp instead of strcasecmp.
	(Fsignal_process): Don't use strncasecmp.

2006-12-05  Glenn Morris  <rgm@gnu.org>

	* abbrev.c (Qforce): New Lisp_Object.
	(Fdefine_abbrev): Do not overwrite non-system abbrevs with system
	abbrevs, unless 'force is applied.
	(syms_of_abbrev): Add Qforce.

2006-12-04  Kim F. Storm  <storm@cua.dk>

	* process.c (parse_signal): Rename macro from handle_signal.
	(Fsignal_process): Also accept lower-case variants of signal
	names (to align with signal names generated by Emacs itself).

	* emacs.c (handle_USR1_signal, handle_USR2_signal): Replace by...
	(handle_user_signal): ... this, which generates two USER_SIGNAL_EVENTs
	first with code == 0 [signal] and one with code == sig number.
	(main): Use it as handler for SIGUR1 and SIGUSR2.

	* keyboard.c (kbd_buffer_store_event_hold): Don't throw-on-input
	if first event in [signal xxx] sequence.
	(lispy_user_signals, Qusr1_signal, Qusr2_signal): Remove.
	(syms_of_keyboard): Don't intern and staticpro them.
	(Qsignal): Declare here.
	(syms_of_keyboard): Intern and staticpro it.
	(make_lispy_event): Use it.  Intern symbols on the fly for other
	USER_SIGNAL_EVENTs events.

	* process.c (Qsignal): Declare extern.
	(syms_of_process): Don't intern/staticpro it here.

	* process.c (read_process_output): Abort if carryover < 0.

2006-12-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* config.in: Regenerate.

	* fileio.c [__NetBSD__]: Don't define `unix'.
	(Funix_sync, syms_of_fileio): Use `#ifdef HAVE_SYNC' instead of
	`#ifdef unix'.

2006-12-04  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (version): New variable, set by configure.
	(bootstrapclean, mostlyclean): Also remove emacs-${version}.

2006-12-03  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (update_frame_tool_bar): Handle modifying a toolbar item
	without an image.

2006-12-01  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (Fw32_shell_execute): Doc fix.

2006-11-30  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (move_it_to): Correctly count tab glyphs for continued
	lines ending in tab.

2006-11-30  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (x_raise_frame): Move setting of _NET_ACTIVE_WINDOW
	property ...
	(XTframe_raise_lower): ... to here.

2006-11-30  Kenichi Handa  <handa@m17n.org>

	* regex.c (regex_compile): Fix previous change.

2006-11-29  Juanma Barranquero  <lekktu@gmail.com>

	* sound.c (Fplay_sound_internal): Remove spurious newline in docstring.

2006-11-28  Chong Yidong  <cyd@stupidchicken.com>

	* config.in: Regenerate.

2006-11-28  Kenichi Handa  <handa@m17n.org>

	* regex.c (regex_compile): Don't call SET_LIST_BIT with a
	multibyte character.

2006-11-27  Chong Yidong  <cyd@stupidchicken.com>

	* s/aix4-2.h: Undefine _NO_PROTO.  Suggested by Joe Buehler.

2006-11-27  Kim F. Storm  <storm@cua.dk>

	* window.c (set_window_buffer): Refactor recent changes.

2006-11-27  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_msg_worker): Declare correctly.
	(w32_initialize): Don't cast w32_msg_worker.

	* w32fns.c (w32_msg_worker): Define as WINAPI and arg as void pointer.

2006-11-26  Chong Yidong  <cyd@stupidchicken.com>

	* m/amdx86-64.h: Look for standard libs in /usr/lib64 only if that
	directory exists.

2006-11-25  Eli Zaretskii  <eliz@gnu.org>

	* w16select.c (Fw16_set_clipboard_data): Fix the call to sit_for
	as per the calling sequence change on 2006-07-11.

2006-11-25  Chong Yidong  <cyd@stupidchicken.com>

	* window.c (set_window_buffer): Use BLOCK_INPUT.

2006-11-24  Juanma Barranquero  <lekktu@gmail.com>

	* fns.c (substring_both): Add missing address operator.

2006-11-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fns.c: Use AREF/ASIZE macros.
	(concat): Provide the full ANSI prototype.

2006-11-24  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <buffer-undo-list>: Doc fix.

2006-11-23  William Smith  <William.Smith@global360.com>  (tiny change)

	* strftime.c (HAVE_SYS__MBSTATE_T_H): Fix typo.

2006-11-22  Alfred M. Szmidt  <ams@gnu.org>  (tiny change)

	* s/openbsd.h (LD_SWITCH_SYSTEM): Remove /usr/pkg/lib and
	/usr/pkg/lib from the library search path.
	(LD_SWITCH_X_DEFAULT): New macro.

2006-11-22  Chong Yidong  <cyd@stupidchicken.com>

	* window.c (set_window_buffer): Clear mouse highlight if it is in
	this window.

2006-11-21  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (realize_default_face): Check if the default font name
	exists on this display before trying to use it.

2006-11-21  Richard Stallman  <rms@gnu.org>

	* fileio.c: Break line before &&, not after.

2006-11-20  Eli Zaretskii  <eliz@gnu.org>

	* fns.c (concat) [!__GNUC__]: Add prototype.

2006-11-20  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Fread_file_name_internal): Use SBYTES (not SCHARS) to
	check the tailing slash of a filename.

2006-11-20  KOBAYASHI Yasuhiro  <kobayays@otsukakj.co.jp>  (tiny change)

	* indent.c (Fvertical_motion): Include composition in the case of
	overshoot expected.

2006-11-19  Andreas Schwab  <schwab@gnu.org>

	* xfaces.c (Fdisplay_supports_face_attributes_p): Initialize supports.

	* xmenu.c (Fx_popup_menu): Initialize selection.

2006-11-18  Andreas Schwab  <schwab@suse.de>

	* s/gnu-linux.h (GC_MARK_SECONDARY_STACK): Update call to mark_memory.

2006-11-17  Tetsurou Okazaki  <okazaki@be.to>  (tiny change)

	* xterm.c (do_ewmh_fullscreen): Declare variable before XSETFRAME
	to avoid gcc 2.96 error.

2006-11-17  NIIMI Satoshi  <sa2c@sa2c.net>  (tiny change)

	* search.c (simple_search): In the loop of backward searching,
	check also the byte position against the limit.

2006-11-14  Romain Francoise  <romain@orebokech.com>

	* minibuf.c (Fcompleting_read): Fix typo in docstring.

2006-11-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_convert_region): Initialize coding->heading_ascii.
	(decode_coding_string, code_convert_region): Likewise.

2006-11-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* config.in: Regenerate.

	* macfns.c (Fx_display_mm_height, Fx_display_mm_width)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030
	&& MAC_OS_X_VERSION_MIN_REQUIRED == 1020]: Check if
	CGDisplayScreenSize is available.

	* macmenu.c (menu_quit_handler, install_menu_quit_handler):
	Replace `#ifdef HAVE_CANCELMENUTRACKING' with
	`#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1030'.
	(install_menu_quit_handler) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030
	&& MAC_OS_X_VERSION_MIN_REQUIRED == 1020]: Check if
	CancelMenuTracking is available.

	* macterm.c [USE_CG_TEXT_DRAWING] (mac_draw_image_string_cg)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030
	&& MAC_OS_X_VERSION_MIN_REQUIRED == 1020]: Check if
	CGContextShowGlyphsWithAdvances is available.

2006-11-13  Jason Rumney  <jasonr@gnu.org>

	* s/ms-w32.h: Define HAVE_INET_SOCKETS.

2006-11-13  Nozomu Ando  <nand@mac.com>

	* alloc.c (mark_memory): New argument OFFSET.  All uses changed.
	Fix address calculations for case END < START.
	(mark_stack): Impose Lisp_Object alignment on jmp_buf.

2006-11-12  Juanma Barranquero  <lekktu@gmail.com>

	* coding.c (Fencode_sjis_char, Fencode_big5_char):
	Improve argument/docstring consistency.

	* editfns.c (Fmessage): Doc fixes.

	* process.c (syms_of_process) <delete-exited-processes>: Doc fix.

2006-11-12  Chong Yidong  <cyd@stupidchicken.com>

	* xmenu.c (popup_activated): Define outside HAVE_MENUS.

2006-11-12  Romain Francoise  <romain@orebokech.com>

	* xselect.c (selection-coding-system): Fix docstring.

2006-11-12  Juanma Barranquero  <lekktu@gmail.com>

	* category.c (Fchar_category_set): Improve arg/docstring consistency.

	* data.c (Flogxor):
	* fns.c (Frandom, Flength, Fsafe_length, Fstring_bytes)
	(Fstring_equal, Fcompare_strings, Fstring_lessp, Fcopy_sequence)
	(Fstring_make_unibyte): Fix typos in docstrings.

2006-11-10  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.h (struct x_display_info): Fix indentation.

	* xterm.c (do_ewmh_fullscreen, XTfullscreen_hook): New functions.
	(x_check_fullscreen): Call do_ewmh_fullscreen.
	(x_initialize): Set fullscreen_hook to XTfullscreen_hook.

	* frame.c (x_set_fullscreen): Call fullscreen_hook if set.

	* term.c: Define fullscreen_hook.
	(syms_of_term): Initialize fullscreen_hook to NULL.

	* termhooks.h: Add fullscreen_hook.

2006-11-08  Juanma Barranquero  <lekktu@gmail.com>

	* bytecode.c (Fbyte_code):
	* data.c (Fmakunbound): Use SYMBOL_CONSTANT_P macro.

2006-11-06  Juanma Barranquero  <lekktu@gmail.com>

	* lread.c (syms_of_lread):
	* xsmfns.c (syms_of_xsmfns): Fix typo in docstring.

2006-11-06  Martin Rudalics  <rudalics@gmx.at>

	* macmenu.c (Fmenu_or_popup_active_p): Define outside HAVE_MENUS.

	* w32menu.c (Fmenu_or_popup_active_p): Define outside HAVE_MENUS.
	Return nil if building without menus.

	* xmenu.c (Fmenu_or_popup_active_p): Define outside HAVE_MENUS.
	Return nil if building without menus.

2006-11-05  Mark Davies  <mark@mcs.vuw.ac.nz>  (tiny change)

	* s/netbsd.h (POSIX_SIGNALS): Define.

2006-11-05  Martin Rudalics  <rudalics@gmx.at>

	* macmenu.c (Fmenu_or_popup_active_p): New function.
	(syms_of_macmenu): Defsubr it.

	* w32menu.c (Fmenu_or_popup_active_p): New function.
	(syms_of_w32menu): Defsubr it.
	(popup_activated_flag, popup_activated): Remove.

	* xdisp.c (note_mouse_highlight) [HAVE_NTGUI]: Don't bother to
	check popup_activated.

	* xmenu.c (Fmenu_or_popup_active_p): New function.
	(syms_of_xmenu): Defsubr it.

2006-11-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* unexmacosx.c (malloc_cookie): Remove unused variable.
	(region_list_head, region_list_tail, lca, nlc, infile_lc_highest_addr)
	(text_seg_lowest_offset, mh, curr_header_offset, infd, outfd)
	(emacs_zone, data_segment_old_fileoff, data_segment_scp)
	(num_unexec_regions, unexec_regions): Make variables static.
	(print_regions, find_emacs_zone_regions): Make static.
	(unexec_region_info): New typedef.
	(unexec_regions): Change type from vm_range_t[] to unexec_region_info[].
	All uses changed.
	(unexec_regions_recorder): Subtract size of trailing null pages from
	filesize.  Show filesize.
	(unexec_regions_merge): Don't merge if null pages of preceding region
	is not too small.  Use long format in printf.
	(copy_segment, copy_data_segment): Show filesize.
	(copy_data_segment): Write filesize bytes of region data.
	Adjust filesize in segment command accordingly.
	(dump_it): Use long format in printf.

2006-11-05  Juanma Barranquero  <lekktu@gmail.com>

	* dosfns.c (Finsert_startup_screen):
	* fns.c (Ffeaturep, syms_of_fns):
	* frame.c (syms_of_frame): Fix typos in docstrings.

	* unexcw.c (unexec): Fix typo in output message.

2006-11-04  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): Remove code for handling -geometry
	command line option and `initial-frame-alist' which is superfluous
	after the last change to `w32_createwindow'.

2006-11-04  Slawomir Nowaczyk  <slawek@cs.lth.se>  (tiny change)

	* w32proc.c (sys_wait): Only wait for processes with fd<0.
	Others should be handled by sys_select instead.  Fixes problems
	with (progn (start-process "" nil "ls") (call-process "ls")).

2006-11-04  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* xmenu.c (Fmenu_bar_open): Declare variable before BLOCK_INPUT to
	avoid gcc 2.95 error.

2006-11-04  Chong Yidong  <cyd@stupidchicken.com>

	* gtkutil.c (update_frame_tool_bar): If icon image is invalid and
	wicon is null, insert an empty button.

2006-11-03  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (x_raise_frame): Send _NET_ACTIVE_WINDOW when raising the
	window.

2006-11-02  Juanma Barranquero  <lekktu@gmail.com>

	* emacs.c (Fkill_emacs): Fix typo in docstring.

2006-11-02  Nozomu Ando  <nand@mac.com>

	* unexmacosx.c (mach_header, segment_command, vm_region, section)
	[_LP64]: New defines.
	(VM_REGION_BASIC_INFO_COUNT, VM_REGION_BASIC_INFO, LC_SEGMENT)
	(MH_MAGIC) [_LP64]: Redefine.
	(delta): Remove variable.
	(curr_file_offset, pagesize): New variables.
	(ROUNDUP_TO_PAGE_BOUNDARY): New macro.
	(data_segment_old_fileoff): Initialize explicitly.
	(print_region, unexec_regions_recorder, print_load_command_name)
	(copy_segment, copy_data_segment): Use long format in printf.
	(MAX_UNEXEC_REGIONS): Increase to 400.
	(unexec_regions_recorder): Don't warn too many regions here.
	(find_emacs_zone_regions): Warn too many regions here.
	(print_load_command_name) [_LP64]: Show correct load command name.
	(copy_segment, copy_data_segment): Use variable `curr_file_offset'.
	Show starting virtual memory address.  Don't show ending file offset.
	(copy_symtab, copy_dysymtab, copy_twolevelhints): New argument DELTA.
	(dump_it): Use new local variable `linkedit_delta' and pass to them.
	Error if trying to handle multiple DATA segments.
	(unexec): Initialize variable `pagesize'.

2006-11-01  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fcatch): Doc fix.

2006-10-31  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (image_load_qt_1, xpm_scan, xpm_make_color_table_v)
	(xpm_put_color_table_v, xpm_get_color_table_v, xpm_make_color_table_h)
	(xpm_put_color_table_h, xpm_get_color_table_h, xpm_str_to_color_key)
	(xpm_load_image): Add const qualifier to arguments.
	[MAC_OS] (xpm_color_key_strings): Make static const.

	* mac.c (create_apple_event_from_event_ref)
	(create_apple_event_from_drag_ref, skip_white_space, parse_comment)
	(parse_include_file, parse_binding, parse_component)
	(parse_resource_name, parse_value, parse_resource_line)
	(xrm_merge_string_database, xrm_get_resource)
	(xrm_get_preference_database): Add const qualifier to arguments.
	[MAC_OSX] (sys_select): Make variable `context' static const.

	* macfns.c (mac_color_map): Make static const.
	(mac_color_map_lookup): Add const qualifier to arguments.

	* macmenu.c (install_menu_quit_handler): Make variable `typesList'
	static const.
	(name_is_separator): Add const qualifier to arguments.

	* macselect.c (init_service_handler): Make variable `specs' static
	const.

	* macterm.c (mac_create_bitmap_from_bitmap_data): Make variable
	`swap_nibbles' static const.
	(atsu_get_text_layout_with_text_ptr): Make variables `lengths',
	`tags', `sizes', `values' static const.
	(mac_draw_string_common): Make variables `context' static.
	Make variables `tags', `sizes', and `values' static const.
	(pcm_get_status, x_detect_focus_change, x_scroll_bar_handle_click)
	(xlfdpat_create, xlfdpat_block_match_1, xlfdpat_match)
	(mac_to_x_fontname, parse_x_font_name, add_mac_font_name)
	(mac_do_list_fonts, is_fully_specified_xlfd, do_grow_window)
	(mac_store_event_ref_as_apple_event, mac_make_rdb): Add const
	qualifier to arguments.
	(xlfd_scalable_fields, keycode_to_xkeysym_table)
	(fn_keycode_to_keycode_table): Make static const.
	(mac_load_query_font): Make variables `tags', `sizes', `values',
	`types', and `selectors' static const.
	(mac_handle_command_event, mac_handle_window_event):
	Make variables `names' and `types' static const.
	(init_command_handler, install_window_handler): Make variables
	`specs*' static const.
	(mac_handle_font_event, mac_handle_text_input_event)
	(mac_store_service_event): Make variables `names' and `types'
	const.  Make variables `names_*' and `types_*' static const.

	* macterm.h (create_apple_event_from_event_ref)
	(create_apple_event_from_drag_ref, xrm_merge_string_database)
	(xrm_get_resource, xrm_get_preference_database): Add const
	qualifier to arguments in externs.

2006-10-31  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xic_create_xfontset): Fix previous change.

2006-10-30  Chong Yidong  <cyd@stupidchicken.com>

	* s/openbsd.h (LD_SWITCH_SYSTEM): Add /usr/pkg/lib and
	/usr/pkg/lib to library search path.

2006-10-29  Mark Davies  <mark@mcs.vuw.ac.nz>  (tiny change)

	* ralloc.c (relinquish): Use a long for excess space counter to
	handle 64-bit case correctly.

2006-10-29  Jeramey Crawford  <jeramey@jeramey.com>

	* m/amdx86-64.h: Add defines for OpenBSD x86-64.

2006-10-29  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fdisplay_buffer): Fix typo in docstring.

2006-10-27  Ben North  <ben@redfrontdoor.org>  (tiny change)

	* w32term.c (x_draw_glyph_string_foreground): Set background mode
	to TRANSPARENT before using overstrike to simulate bold faces.

	* xfaces.c (best_matching_font): Fix logic to decide whether to
	use overstriking to simulate bold-face (it was reversed).

2006-10-23  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (remember_mouse_glyph): Do nothing if glyphs are not
	initialized.

	* keyboard.c (read_char): Make an element (t . EVENT) in
	unread-command-events add EVENT to the current command's key sequence.
	(syms_of_keyboard) <unread-command-events>: Update doc.

2006-10-21  Richard Stallman  <rms@gnu.org>

	* minibuf.c (Vread_expression_map): Define here.
	(Qread_expression_history): New variable.
	(syms_of_minibuf): Initialize them.
	(Feval_minibuffer): Use Vread_expression_map and
	Qread_expression_history.

2006-10-21  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xic_create_fontsetname): If ADSTYLE field is not a wild
	card, change it to "*".
	(xic_create_xfontset): Call XCreateFontSet for each single
	fontname in fontsetname.

2006-10-19  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (callint_message): Convert to a Lisp string.
	(syms_of_callint): Initialize it.
	(callint_message_size): Var deleted.
	(Fcall_interactively): Use Fformat instead of doprnt to construct
	prompt string.

2006-10-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (display_mode_line): Clear enabled_p flag on mode-line row.

2006-10-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Vmac_carbon_version_string) [TARGET_API_MAC_CARBON]:
	New variable.
	(syms_of_macfns) [TARGET_API_MAC_CARBON]: Defvar it.

2006-10-19  Jan Djärv  <jan.h.d@swipnet.se>

	* xselect.c (x_handle_selection_request): If the converted_selection
	is nil or XCDR (converted_selection) is nil, decline the request.

2006-10-16  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (get_utf8_string): Remove warnings with casts.
	(xg_tool_bar_button_cb): Ditto.
	(xg_tool_bar_callback): Ditto.

2006-10-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispnew.c (adjust_frame_glyphs_for_frame_redisplay): Remove unused
	variable ch_dim.
	(adjust_frame_glyphs_for_window_redisplay): Likewise.  Don't allocate
	menu bar window matrices on non-X systems.

	* mac.c (Fmac_get_preference, Fmac_code_convert_string): Add GCPROs.

	* macterm.c (mac_query_char_extents): Don't return glyph ID if layout
	adjustment is needed.
	(mac_load_query_font): Check if width and height are positive.

2006-10-14  Richard Stallman  <rms@gnu.org>

	* sysdep.c (init_sys_modes): Delete DEFVAR_LISP in the wrong place.

2006-10-13  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (decode_mode_spec): Ignore %c and %l constructs in frame
	title.

2006-10-12  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fkey_binding): Check Lisp_Object types before doing
	XCAR and XINT.

2006-10-12  Romain Francoise  <romain@orebokech.com>

	* image.c (xbm_read_bitmap_data): Delete extra semicolon.

2006-10-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c: Include xterm.h for x_fully_uncatch_errors and friends.

	* dispextern.h: Declare x_create_bitmap_from_xpm_data.

	* xterm.c (x_check_expected_move): Remove unused var `count'.

	* xmenu.c (syms_of_xmenu): Use Ffset rather than Fdefalias, since
	Fdefalias is not declared in any *.h file.

2006-10-09  Chong Yidong  <cyd@stupidchicken.com>

	* dispnew.c (sit_for): Sit forever if TIMEOUT is t.

	* keyboard.c (command_loop_1): Handle non-number values of
	`minibuffer-message-timeout'.
	(Fexecute_extended_command): Fix typo.

	* minibuf.c (temp_echo_area_glyphs): Sit for
	`minibuffer-message-timeout' seconds.

2006-10-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_draw_image_string, mac_draw_image_string_16):
	Add argument OVERSTRIKE_P.
	(mac_draw_string_common, mac_draw_image_string_cg): Likewise.
	Support overstrike.
	(mac_draw_string, mac_draw_string_16): Remove functions.
	(x_draw_glyph_string_foreground): Use overstrike when needed.
	(x_draw_composite_glyph_string_foreground): Likewise.
	Use mac_draw_image_string_16 instead of mac_draw_string_16.
	(mac_load_query_font): Rename from XLoadQueryFont.  Take argument
	F instead of DPY.  All uses changed.  Don't save/restore font.

2006-10-07  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): Honour left and top positions if
	supplied explicitly.

2006-10-06  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Fix value when EOB is visible.

2006-10-05  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (Qinhibit_face_set_after_frame_default): New var.
	(syms_of_frame): Initialize it.
	(x_set_frame_parameters): Avoid resetting :font attributes to the
	new-frame defaults.

2006-10-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (clear_regexp_cache): Declare.

	* search.c (compile_pattern): Only check `cp->syntax_table' if needed.
	(compile_pattern_1): Remember `used_syntax' in `cp->syntax_table'.
	(clear_regexp_cache): Only flush those regexps which depend on
	a syntax-table.

	* regex.c (regex_compile): Set the new `used_syntax' bit.

	* regex.h: Remove file local variables.
	(struct re_pattern_buffer): New field `used_syntax'.

2006-10-03  Kim F. Storm  <storm@cua.dk>

	* process.c (list_processes_1): Run sentinels before removing dead
	processes.  Also remove `closed' network connections.

2006-10-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (handle_fontified_prop): Don't fontify at EOB.

2006-09-30  Eli Zaretskii  <eliz@gnu.org>

	* config.in: Regenerated.

2006-09-29  Juri Linkov  <juri@jurta.org>

	* buffer.c (syms_of_buffer): Reorder coding systems in the
	docstring of %z to the real order displayed in the modeline.

2006-09-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fdefine_key): Yet another int/Lisp_Object mixup (YAILOM).

2006-09-26  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Do move back if the Lisp string
	being displayed contains newlines.

2006-09-26  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_compute_glyph_string_overhangs, XLoadQueryFont)
	[USE_CG_DRAWING]: Call mac_prepare_for_quickdraw before QDTextBounds.

2006-09-26  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fsingle_key_description): For an invalid char, return
	"Invalid char code NNNNN".

2006-09-25  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (Fcall_interactively): Doc fix.

2006-09-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_underline_at_descent_line): New variable.
	(syms_of_macterm): DEFVAR_BOOL it.
	(x_draw_glyph_string): Use it.
	(XLoadQueryFont): Calculate min_bounds.descent and max_bounds.descent.

2006-09-25  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fsingle_key_description): Return unique names for
	generic characters.

2006-09-24  Richard Stallman  <rms@gnu.org>

	* search.c (compile_pattern_1): Don't BLOCK_INPUT.

2006-09-24  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(BLD)/fns.$(O), $(BLD)/w32proc.$(O)):
	Depend on nt/inc/langinfo.h and nt/inc/nl_types.h.

	* w32proc.c (nl_langinfo): New function.

	* w32fns.c (w32-pass-alt-to-system, w32-alt-is-meta)
	(w32-pass-lwindow-to-system, w32-enable-num-lock)
	(w32-enable-caps-lock, w32-scroll-lock-modifier)
	(w32-lwindow-modifier, w32-rwindow-modifier)
	(w32-apps-modifier, w32-mouse-button-tolerance): Doc fix.

2006-09-23  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (Finternal_complete_buffer, Fread_minibuffer)
	(Fdisplay_completion_list): Fix typos in docstrings.

2006-09-23  Romain Francoise  <romain@orebokech.com>

	* s/gnu-linux.h (MAIL_USE_FLOCK): Check for HAVE_LIBLOCKFILE too.

2006-09-23  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fmap_keymap): Docstring mentions about generic character.

2006-09-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.c (analyse_first): For eight-bit-control chars, mark both the
	char's value and its leading byte in the fastmap.
	(re_search_2): When fast-scanning without translation, be careful to
	check that we only match the leading byte of a multibyte char.

	* charset.h (PREV_CHAR_BOUNDARY): Make it work from within a char's
	byte sequence.
	(AT_CHAR_BOUNDARY): New macro.

2006-09-22  Kenichi Handa  <handa@m17n.org>

	* fns.c (optimize_sub_char_table): Don't optimize a sub-char-table
	whose default value is non-nil.

2006-09-22  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Only show C-l help for
	Gtk+ versions < 2.10.

	* xfns.c (syms_of_xfns): Fix typo in help text for
	x-gtk-file-dialog-help-text.

2006-09-21  Kim F. Storm  <storm@cua.dk>

	* fns.c (Fmemq): Refill doc string.
	(Fmemql): New defun, like memq but using eql.
	(syms_of_fns): Defsubr it.

2006-09-20  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): CHARPOS < 0 means return info for
	last visible glyph in window.

	* window.c (Fset_window_hscroll, Fwindow_line_height):
	Doc fix.  Use "off-window" instead of "off-screen".
	(Fpos_visible_in_window_p): Likewise.
	If POS is t, return info for last visible glyph in window.

2006-09-19  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (struct regexp_cache): New entry syntax_table.
	(compile_pattern_1): Set it.
	(syms_of_search): Initialize it.
	(compile_pattern): Require the syntax_table entry of the cache
	element to match the current syntax table entry.

2006-09-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fwindow_end): Fix recent change.

2006-09-19  Kim F. Storm  <storm@cua.dk>

	* window.c (Fset_window_hscroll, Fpos_visible_in_window_p):
	Doc fix.  Use "off-screen" instead of "invisible".
	(Fwindow_line_height): Make line numbers 0-based.  Make line arg
	optional; if nil, use current cursor row.  Handle text terminals
	properly.  Return nil if non-interactive or pseudo-window.

2006-09-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c: Include alloca.h if available.
	(Fkey_binding): Only use AREF after checking it's a vector.
	Remove unused var `window'.

2006-09-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (shut_down_emacs) [!subprocesses]: Don't set
	inhibit_sentinels.

	* mac.c [!MAC_OSX] (select): Fix argument name.

	* macmenu.c (enum mac_menu_kind, min_menu_id): New enumerator and
	menu ID for Apple menu.
	(menubar_selection_callback): Remove function.
	(find_and_call_menu_selection): New function from xmenu.c.
	(x_activate_menubar): Use it.
	(set_frame_menubar): Don't use f->output_data.mac->menubar_active.

	* macterm.c (menubar_selection_callback): Remove extern.
	(M_APPLE): Change to 234.
	(do_apple_menu) [!TARGET_API_MAC_CARBON]: Make non-static.
	(do_menu_choice): Remove function.

	* macterm.h (struct mac_output): Remove member menubar_active.
	(do_menu_choice): Remove extern.
	(do_apple_menu) [!TARGET_API_MAC_CARBON]: Add extern.

2006-09-18  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (syms_of_xfns): Rename x_gtk_show_chooser_help_text to
	x_gtk_file_dialog_help_text.

	* gtkutil.c (xg_uses_old_file_dialog): Rename x-use-old-gtk-file-dialog
	to x-gtk-use-old-file-dialog.
	(xg_get_file_with_chooser): Rename x_gtk_show_chooser_help_text to
	x_gtk_file_dialog_help_text.

	* xfns.c (syms_of_xfns): Ditto.

2006-09-18  Kim F. Storm  <storm@cua.dk>

	* window.c (Fwindow_line_visibility): Remove.
	(Fwindow_line_height): New defun replacing it.
	(syms_of_window): Defsubr it.

2006-09-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (SELECT_USE_CFSOCKET) [MAC_OSX]: Set default to 1.
	[MAC_OSX] (sys_select) [SELECT_USE_CFSOCKET]: Fix pointer type.

2006-09-17  Jay Belanger  <belanger@truman.edu>

	* gmalloc.c:
	* md5.c:
	* md5.h:
	* strftime.c: Replace "GNU Library General Public License" by "GNU
	General Public License" throughout.

2006-09-17  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (update_text_area): Undo 2000-07-18 change.
	Always redrawing whole row if line has mouse-face in it causes
	excessive flickering of the mode line.

2006-09-17  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (clear_regexp_cache): New function.

	* syntax.c (Fmodify_syntax_entry): Clear regexp cache.

2006-09-16  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser):
	Check x-gtk-show-chooser-help-text before adding the help text.

	* xfns.c (syms_of_xfns): New variable: x-gtk-show-chooser-help-text.

	* gtkutil.c (get_utf8_string): Try harder to convert to UTF8.  Gtk+
	will simply crash if we fail.

2006-09-16  Richard Stallman  <rms@gnu.org>

	* regex.c (re_compile_pattern): Set gl_state.current_syntax_table.

2006-09-15  Kim F. Storm  <storm@cua.dk>

	* window.c (Fwindow_line_visibility): New defun for line-move-partial.
	(syms_of_window): Defsubr it.
	(Fwindow_end): Use window's buffer rather than current buffer.

2006-09-15  Jay Belanger  <belanger@truman.edu>

	* COPYING: Replace "Library Public License" by "Lesser Public
	License" throughout.

2006-09-15  David Kastrup  <dak@gnu.org>

	* Makefile.in (keymap.o): Add "keymap.h" and "window.h" dependencies.

	* keymap.c: include "window.h".
	(Fcommand_remapping): New optional POSITION argument.
	(Fkey_binding): New optional POSITION argument.  Completely rework
	handling of mouse clicks to get the same order of keymaps as
	`read-key-sequence' and heed POSITION.  Also temporarily switch
	buffers to location of mouse click and back.

	* keyboard.c (command_loop_1): Adjust call of `Fcommand_remapping'
	for additional argument.
	(parse_menu_item): Adjust call of `Fkey_binding' for additional
	argument.
	(read_key_sequence): If there are both `local-map' and `keymap'
	text properties at some buffer position, heed both.

	* keymap.h: Declare additional optional arguments of
	`Fcommand_remapping' and `Fkey_binding'.

2006-09-15  Juanma Barranquero  <lekktu@gmail.com>

	* indent.c (Fcurrent_column, Findent_to): Fix typos in docstring.

2006-09-14  Andreas Schwab  <schwab@suse.de>

	* print.c: Whitespace fixup.

2006-09-14  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (produce_image_glyph): Automatically crop wide images at
	right window edge so we can draw the cursor on the same row to
	avoid confusing redisplay by placing the cursor outside the visible
	window area.

2006-09-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xterm.c (x_initialize): Don't install Xt event timer here.
	(x_timeout_atimer_activated_flag): New var.
	(x_activate_timeout_atimer): New function to install Xt timer.
	(x_send_scroll_bar_event, x_process_timeouts): Use it.

	* xmenu.c (x_menu_set_in_use, popup_activate_callback)
	(create_and_show_popup_menu, create_and_show_dialog): Use it.

	* xterm.h (x_activate_timeout_atimer): Add prototype.

2006-09-13  Richard Stallman  <rms@gnu.org>

	* print.c (print_string): When printcharfun is t,
	copy string contents and call strout on the copy.

	* keyboard.c (read_char): If end_time specified, don't put the
	event into this_command_keys.
	(read_key_sequence): If Voverriding_terminal_local_map is specified,
	don't check Voverriding_local_map at all.

2006-09-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textprop.c (Fnext_property_change, Fnext_single_property_change)
	(Fprevious_property_change, Fprevious_single_property_change):
	Avoid changing limit, so we can correctly catch the case where the
	property is constant up to limit.

2006-09-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (mac_window) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	* macterm.c (XTread_socket) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Undo 2006-09-08 change.

2006-09-11  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fkey_binding): Use string position for string objects.

2006-09-11  Kim F. Storm  <storm@cua.dk>

	* keymap.c (Fkey_binding): Fix last change.

	* editfns.c (Fmessage): Recommend using (message "%s" ...).

2006-09-10  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fkey_binding): Check for local keymap for mouse click
	events.

2006-09-10  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Finput_pending_p): Check Vunread_input_method_events
	and Vunread_post_input_method_events.

	* dispnew.c (Fredisplay): Document return value.

2006-09-10  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_close_connection): Call xg_display_close when USE_GTK.

	* gtkutil.c (xg_display_close): Always change default display if needed,
	check for < Gtk+ version 2.10 before calling gdk_display_close.

2006-09-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [MAC_OSX] (sys_select): Check argument `nfds' more rigidly.
	Make variable `ofds' static.  Remove variable `maxfd'.

	* macfns.c (Fx_file_dialog): Remove unused variable `f'.
	Call check_mac.

	* macmenu.c (Vmenu_updating_frame, syms_of_macmenu):
	* w32menu.c (Vmenu_updating_frame, syms_of_w32menu):
	Apply 2006-09-08 change for xmenu.c.

	* xfns.c (Fx_file_dialog): Call check_x.

2006-09-10  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_window_cursor_type): Use hollow cursor on
	non-transparent images.

2006-09-09  Eli Zaretskii  <eliz@gnu.org>

	* editfns.c (Fsystem_name): Mention "host" in the doc string.
	(syms_of_editfns) <system-name>: Likewise.

2006-09-08  Martin Rudalics  <rudalics@gmx.at>

	* xdisp.c (mouse_autoselect_window): Remove.
	(Vmouse_autoselect_window): New variable.  DEFVAR_LISP it.

	* dispextern.h (mouse_autoselect_window): Remove extern.
	(Vmouse_autoselect_window): Add extern.

	* macterm.c (XTread_socket): Test Vmouse_autoselect_window
	instead of mouse_autoselect_window.

	* msdos.c (dos_rawgetc): Likewise.

	* w32term.c (w32_read_socket): Likewise.

	* xterm.c (handle_one_xevent): Likewise.

2006-09-08  Richard Stallman  <rms@gnu.org>

	* xdisp.c (Vmenu_updating_frame): Define here.
	(syms_of_xdisp): DEFVAR it here.
	(update_menu_bar): Always return hooks_run.
	Set Vmenu_updating_frame.

	* xdisp.c (redisplay_internal): Test Vinhibit_redisplay
	before calculating SELECTED_FRAME.

	* xmenu.c (Vmenu_updating_frame): Don't define here.
	(syms_of_xmenu): Don't DEFVAR it here.

	* xterm.c (x_error_quitter): For BadName error, just return.

	* eval.c (find_handler_clause): Give up on debugger if INPUT_BLOCKED_P.

	* casetab.c (init_casetab_once): Call set_case_table.

	* emacs.c (shut_down_emacs): Set inhibit_sentinels.

	* process.c (inhibit_sentinels): New variable.
	(exec_sentinel): Test inhibit_sentinels.
	(init_process): Initialize it.

	* process.h (inhibit_sentinels): Add decl.

	* search.c (looking_at_1, string_match_1, search_command):
	Make syntax table's canon table point to eqv table.

2006-09-08  Andreas Schwab  <schwab@suse.de>

	* print.c (strout): Fix whitespace.

2006-09-08  Kim F. Storm  <storm@cua.dk>

	* xterm.c (x_draw_glyph_string): Fix 2006-08-24 change.

2006-09-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!MAC_OSX]: Don't include keyboard.h.
	[!MAC_OSX] (select): Try detect_input_pending before ReceiveNextEvent
	in the same BLOCK_INPUT block, in case that some input has already
	been read asynchronously.  Pretend to be interrupted by a signal
	if some input is available.
	[MAC_OSX] (select_and_poll_event, sys_select): Likewise.
	(SELECT_POLLING_PERIOD_USEC) [SELECT_USE_CFSOCKET]: Change to 100000.
	Now used for ReceiveNextEvent timeout instead of select timeout.
	(EVENT_CLASS_SOCK) [SELECT_USE_CFSOCKET]: Remove macro.
	[SELECT_USE_CFSOCKET] (socket_callback): Add non-blocking connect
	support.  Quit event loop.
	[MAC_OSX] (sys_select) [SELECT_USE_CFSOCKET]: Add non-blocking
	connect support.  Reuse previously allocated CFRunLoopSource.
	(Fmac_process_hi_command) [TARGET_API_MAC_CARBON]: New function.
	(syms_of_mac) [TARGET_API_MAC_CARBON]: Defsubr it.

	* macfns.c (mac_window) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Specify kWindowAsyncDragAttribute.

	* macterm.c (mac_handle_origin_change, mac_handle_size_change)
	(mac_get_ideal_size): New functions.
	(x_set_offset, x_set_window_size, x_make_frame_visible)
	(do_zoom_window, mac_handle_window_event, XTread_socket): Use them.
	(install_window_handler, mac_handle_window_event)
	[USE_CARBON_EVENTS]: Handle kEventWindowGetIdealSize and
	kEventWindowBoundsChanged.
	(XTread_socket) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Don't call
	DragWindow.

2006-09-07  Andreas Schwab  <schwab@suse.de>

	* m/ibms390x.h (START_FILES, LIB_STANDARD): Override to
	use lib64 instead of lib.

2006-09-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in: Avoid double quotes when possible.

2006-09-06  Kenichi Handa  <handa@m17n.org>

	* editfns.c (Fformat_time_string): Use make_unibyte_string to make
	a Lisp string from the result of emacs_memftimeu call.

2006-09-06  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Remove exact_mode_line_heights_p arg;
	so calculate heights even when pos-visible-in-window-p is called
	with partially = t.  Don't overshoot last_visible_y in move_it_to.
	Return row height and row number in new rowh and vpos args.
	(cursor_row_fully_visible_p): First line is always "fully visible".
	(try_window): Don't clear matrix if vscrolled.

	* lisp.h (pos_visible_p): Update prototype.

	* window.c (Fpos_visible_in_window_p): Adapt to new pos_visible_p.
	Return row height and row number for partially visible rows.
	Modify return value to a 2 element list for fully visible rows and
	6 for partially visible row.
	(window_scroll_pixel_based): Use pos_visible_p directly instead of
	Fpos_visible_in_window_p.  Fix auto vscrolling for partially
	visible lines.  Only vscroll backwards if already vscrolled
	forwards.  Unconditionally vscroll forwards if PT is first (and
	only) line.  Set new window start instead of scrolling at
	start/end of tall line.

2006-09-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (install_window_handler, mac_handle_window_event)
	[USE_CARBON_EVENTS]: Handle kEventWindowClose.
	[USE_MAC_TSM] (mac_handle_text_input_event): Set modifiers for
	ASCII keystroke event.

2006-09-04  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Don't mention specific keys in
	the file chooser message.  Only call gtk_file_chooser_set_current_name
	when action is SAVE.

2006-09-04  Andreas Schwab  <schwab@suse.de>

	* Makefile.in: Double all single and back quotes in C-style
	comments to help fontifier.

2006-09-03  Jason Rumney  <jasonr@gnu.org>

	* w32.c (shutdown_handler): New function to exit cleanly on shutdown.
	(globals_of_w32): Register it as a signal handler.

2006-09-02  Juri Linkov  <juri@jurta.org>

	* marker.c (Fmarker_position): Doc fix.

2006-09-03  Eli Zaretskii  <eliz@gnu.org>

	* window.c (syms_of_window) <split-height-threshold>:
	<window-min-height, window-min-width>: Doc fix.

2006-09-02  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Change file chooser message
	for writing files.  Call gtk_file_chooser_set_current_name to keep
	default filename.

	* minibuf.c (Finternal_complete_buffer): Move after DEFUN:s it calls.

2006-09-02  Jindrich Makovicka  <makovick@gmail.com>  (tiny change)

	* fns.c (concat) [__GNUC__]: Declare with
	`__attribute__((noinline))'.

	* eval.c (apply1, call2) [__GNUC__]: Declare with
	`__attribute__((noinline))'.

2006-09-02  Stuart D. Herring  <herring@lanl.gov>

	* minibuf.c (Finternal_complete_buffer): New function.
	(syms_of_minibuf): Defsubr it.
	(Fread_buffer): Use it, instead of Vbuffer_alist.

2006-09-01  Martin Rudalics  <rudalics@gmx.at>

	* buffer.h (struct buffer_text): New field chars_modiff.
	(CHARS_MODIFF, BUF_CHARS_MODIFF): New macros.
	* buffer.c (Fbuffer_chars_modified_tick): New function returning
	value of BUF_CHARS_MODIFF.
	(syms_of_buffer): Defsubr it.
	(Fget_buffer_create): Initialize BUF_CHARS_MODIFF.
	* insdel.c (modify_region): New argument preserve_chars_modiff.
	Set CHARS_MODIFF to MODIFF provided preserve_chars_modiff is zero.
	(insert_1_both, insert_from_string_1, insert_from_buffer_1)
	(adjust_after_replace, adjust_after_replace_noundo)
	(replace_range, replace_range_2, del_range_2): Reset CHARS_MODIFF.
	* lisp.h (modify_region): Add fourth argument in extern.
	* casefiddle.c (casify_region): Call modify_region with fourth
	argument zero to assert that CHARS_MODIFF is updated.
	* editfns.c (Fsubst_char_in_region, Ftranslate_region_internal)
	(Ftranspose_regions): Likewise.
	* textprop.c (Fadd_text_properties, Fset_text_properties)
	(Fremove_text_properties, Fremove_list_of_text_properties):
	Call modify_region with fourth argument 1 to avoid that
	CHARS_MODIFF is updated.

2006-08-31  Richard Stallman  <rms@gnu.org>

	* editfns.c (Fformat): Don't sign-extend for %o or %x.

2006-08-29  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Don't move back if we were
	displaying a Lisp string, either.

2006-08-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_window_cursor_type) [!HAVE_WINDOW_SYSTEM]:
	Don't attempt to replace cursor on image glyphs.

2006-08-28  Kenichi Handa  <handa@m17n.org>

	* coding.c (Fdetect_coding_region, Fdetect_coding_string):
	Fix docstring about ISO-2022 control characters.

2006-08-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_window_cursor_type): Replace BOX cursor on images
	with a hollow box cursor if image is larger than 32x32 (or the default
	frame font if that is bigger).  Replace any other cursor on images
	with hollow box cursor, as redisplay doesn't support bar and hbar
	cursors on images.

2006-08-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (BLOCK_INPUT_ALLOC, UNBLOCK_INPUT_ALLOC): Undo previous
	change.  Move mutex lock/unlock operations inside BLOCK_INPUT.

	* dired.c (directory_files_internal_unwind, directory_files_internal)
	(file_name_completion): Add BLOCK_INPUT around opendir/closedir.

	* image.c [MAC_OS] (image_load_qt_1): Use ComponentResult instead
	of OSErr.

	* keyboard.c (in_sighandler): Remove variable.
	(Fcurrent_idle_time): Add missing `doc:'.
	(input_available_signal, init_keyboard): Undo previous change.

	* keyboard.h (in_sighandler): Remove extern.

	* mac.c (create_apple_event_from_event_ref, select)
	(Fmac_get_file_creator, Fmac_get_file_type, Fmac_set_file_creator)
	(Fmac_set_file_type, cfstring_create_normalized)
	(mac_get_system_locale, select_and_poll_event, sys_select):
	Use OSStatus instead of OSErr.

	* macfns.c [TARGET_API_MAC_CARBON] (mac_update_proxy_icon):
	Don't use FRAME_FILE_NAME.  Use (FS)UpdateAlias.
	(Fx_create_frame): Apply 2006-07-03 for xfns.c.

	* macselect.c (get_scrap_from_symbol, clear_scrap, put_scrap_string)
	(put_scrap_private_timestamp, scrap_has_target_type, get_scrap_string)
	(get_scrap_private_timestamp, get_scrap_target_type_list)
	(x_own_selection, x_get_foreign_selection)
	(Fx_disown_selection_internal, Fx_selection_owner_p)
	(Fx_selection_exists_p): Use OSStatus instead of OSErr.

	* macterm.c (mac_draw_string_common, mac_query_char_extents)
	(x_iconify_frame, XLoadQueryFont, install_window_handler)
	(mac_handle_command_event, init_command_handler, init_menu_bar):
	Use OSStatus instead of OSErr.
	(x_free_frame_resources) [TARGET_API_MAC_CARBON]: Don't use
	FRAME_FILE_NAME.
	(x_query_font): Apply 2006-08-04 change for xterm.c.
	(Qhi_command): Rename from Qhicommand.  All uses changed.

	* macterm.h (struct mac_output) [TARGET_API_MAC_CARBON]: Remove member
	file_name.
	(FRAME_FILE_NAME): Remove macro.
	(install_window_handler, create_apple_event_from_event_ref):
	Return OSStatus instead of OSErr.

2006-08-26  Kim F. Storm  <storm@cua.dk>

	* buffer.c (Fset_buffer_multibyte):
	* editfns.c (Fcurrent_time, Fget_internal_run_time):
	* macfns.c (Fxw_color_values):
	* w32fns.c (Fxw_color_values):
	* xfns.c (Fxw_color_values): Simplify; use list3.

	* fileio.c (Fmake_directory_internal, Fdelete_directory)
	(Fdelete_file): Simplify; use list1.
	(Frename_file, Fadd_name_to_file, Fmake_symbolic_link):
	Simplify; remove NO_ARG_ARRAY stuff, use list2.

2006-08-25  Richard Stallman  <rms@gnu.org>

	* buffer.c (Fswitch_to_buffer): Fix previous change.

2006-08-25  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Fcurrent_idle_time): Simplify.

2006-08-25  Richard Stallman  <rms@gnu.org>

	* fns.c (sxhash_string): Rotate properly; don't lose bits.

2006-08-24  Francesc Rocher  <francesc.rocher@gmail.com>

	* xdisp.c (overline_margin): New variable.
	(x_produce_glyphs): Use it.
	(syms_of_xdisp): DEFVAR_INT it.

	* xterm.c (x_underline_at_descent_line): New variable.
	(syms_of_xterm): DEFVAR_BOOL it.
	(x_draw_glyph_string): Use it.
	Draw underline and overline up to the end of line if the face
	extends to the end of line.

	* macterm.c: Likewise.

	* w32term.c: Likewise.

2006-08-24  Nick Roberts  <nickrob@snap.net.nz>

	* buffer.c (Fswitch_to_buffer): Move buffer to front of
	buffer-alist if necessary.

2006-08-22  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (update_tool_bar): Redisplay toolbar also when only
	number of items changes.

2006-08-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fset_buffer_multibyte): Record proper undo entry.

2006-08-21  Jan Djärv  <jan.h.d@swipnet.se>

	* keyboard.c: Clarify difference between in_sighandler and
	handling_signal.

2006-08-21  Kim F. Storm  <storm@cua.dk>

	* macterm.c (x_draw_stretch_glyph_string):
	* w32term.c (x_draw_stretch_glyph_string):
	* xterm.c (x_draw_stretch_glyph_string): It is ok to draw a
	stretch glyph in left marginal areas on header and mode lines.

2006-08-21  Kenichi Handa  <handa@m17n.org>

	* keyboard.c (syms_of_keyboard): Docstring of
	Vunread_post_input_method_events and Vunread_input_method_events
	fixed.

2006-08-20  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (show_help_echo): Preserve mouse movement flag if
	tracking mouse.

2006-08-20  Richard Stallman  <rms@gnu.org>

	* xfaces.c (load_pixmap): Add quotes in error message.

	* keyboard.c (Fcurrent_idle_time): New function.
	(syms_of_keyboard): defsubr it.

2006-08-18  Nick Roberts  <nickrob@snap.net.nz>

	* window.c (Fset_window_fringes): Do nothing on a tty.
	(Fwindow_fringes): Put ? operator after the line break.

2006-08-16  Andreas Schwab  <schwab@suse.de>

	* print.c (debug_output_compilation_hack): Fix return type.

2006-08-16  Richard Stallman  <rms@gnu.org>

	* print.c (debug_output_compilation_hack): New function.

2006-08-16  Kenichi Handa  <handa@m17n.org>

	* fileio.c (choose_write_coding_system): Use LF for end-of-line
	in auto-saving.

2006-08-15  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): Don't change idle timer state at all if
	end_time is supplied.

2006-08-15  Kenichi Handa  <handa@m17n.org>

	* coding.c (ONE_MORE_BYTE_CHECK_MULTIBYTE): New arg RET.  If SRC
	is exhausted, return with RET.
	(detect_coding_emacs_mule, detect_coding_iso2022)
	(detect_coding_sjis, detect_coding_big5, detect_coding_utf_8)
	(detect_coding_utf_16, detect_coding_ccl): Adjusted for the above
	change.

2006-08-14  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): Don't reset idle timers if a time limit
	is supplied.

2006-08-14  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Print iterator position.
	Limit stack dump in case iterator is not initialized.

2006-08-12  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (Fmouse_position, Fmouse_pixel_position)
	(Fset_mouse_position, Fset_mouse_pixel_position): Doc fix.

2006-08-11  Jan Djärv  <jan.h.d@swipnet.se>

	* xselect.c (Fx_register_dnd_atom): New function.
	(syms_of_xselect): Defsubr it.
	(x_handle_dnd_message): Check that message_type is in
	dpyinfo->x_dnd_atoms before generating lisp event.

	* xterm.h (struct x_display_info): Add x_dnd_atoms* to keep track
	of drag and drop Atoms.

	* xterm.c (x_term_init): Initialize dpyinfo->x_dnd_atoms*.

2006-08-10  Jan Djärv  <jan.h.d@swipnet.se>

	* keyboard.c: Define in_sighandler.
	(input_available_signal): Set in_sighandler.
	(init_keyboard): Initialize in_sighandler.

	* keyboard.h: Declare in_sighandler.

	* alloc.c (UNBLOCK_INPUT_ALLOC, BLOCK_INPUT_ALLOC): Use in_sighandler
	to check if mutex should be locked or not.

2006-08-09  Richard Stallman  <rms@gnu.org>

	* keyboard.c (keyremap_step): No-op if fkey->parent = nil.
	(read_key_sequence): Always start fkey.start and fkey.end at 0,
	and likewise for keytran.

2006-08-09  Kenichi Handa  <handa@m17n.org>

	* coding.c (syms_of_coding): Improve the docstring
	of file-coding-system-alist.

2006-08-07  Andreas Schwab  <schwab@suse.de>

	* puresize.h (BASE_PURESIZE): Increase to 1120000.

2006-08-06  Chong Yidong  <cyd@stupidchicken.com>

	* buffer.c (Vchange_major_mode_hook, Qchange_major_mode_hook): New vars.
	(Fkill_all_local_variables): Use it.
	(syms_of_buffer): Defvar it.

2006-08-05  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (w32_valid_pointer_p): New function.

	* w32.h: Add prototype for w32_valid_pointer_p.

	* alloc.c: Include w32.h.
	(valid_lisp_object_p) [WINDOWSNT]: Call w32_valid_pointer_p to do
	the job.

	* keyboard.c (kbd_buffer_get_event): Return Qnil when current time
	is exactly equal to end_time, not only when it is past that.

2006-08-04  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): Rebalance specpdl after receiving jump.

	* process.c: Reapply 2006-08-01 change.

2006-08-04  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_query_font): Fix last change: use stricmp.

2006-08-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fsubst_char_in_region): Redo the setup work after running
	the before-change-functions since they may have altered the buffer.

2006-08-04  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): Handle -geometry command line option
	and the geometry settings in the Registry.

2006-08-04  Kenichi Handa  <handa@m17n.org>

	* w32fns.c (w32_query_font): Compare names by ignoring case.

	* xterm.c (x_query_font): Compare names by ignoring case.

2006-08-03  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (w32_menu_show, w32_dialog_show): Call Fsignal to quit
	when no option selected.

2006-08-03  Chong Yidong  <cyd@stupidchicken.com>

	* process.c: Revert last change.

2006-08-01  Kim F. Storm  <storm@cua.dk>

	* process.c (wait_reading_process_output_unwind): New function.
	Restores waiting_for_user_input_p to saved value.
	(wait_reading_process_output): Unwind protect waiting_for_user_input_p
	instead of save/restore old value on stack.

2006-07-30  Thien-Thi Nguyen  <ttn@gnu.org>

	* editfns.c: Undo 2006-06-27 change.

2006-07-29  Eli Zaretskii  <eliz@gnu.org>

	* coding.c (Ffind_operation_coding_system): Revert the change from
	2006-05-29.

	* alloc.c [WINDOWSNT]: Include fcntl.h, to fix last change.

2006-07-28  Richard Stallman  <rms@gnu.org>

	* xfaces.c (lookup_named_face, Fdisplay_supports_face_attributes_p):
	Add conditional aborts for clarity.

	* xdisp.c (update_menu_bar): New arg HOOKS_RUN.  Callers changed.
	Used to avoid running the hooks over and over for each frame.
	(prepare_menu_bars): Pass value from update_menu_bar
	as HOOKS_RUN of next call.

	* keyboard.c (safe_run_hooks_1): Don't crash if Vrun_hooks is nil.

2006-07-28  Kim F. Storm  <storm@cua.dk>

	* alloc.c (valid_pointer_p): New function (from valid_lisp_object_p).
	(valid_lisp_object_p): Use it to check for valid SUBRP obj.

2006-07-26  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): New arg END_TIME specifying timeout.
	All callers changed.  Turn off echoing if END_TIME is non-NULL.
	(kbd_buffer_get_event): New arg END_TIME.

	* lread.c (read_filtered_event): New arg SECONDS to wait until.
	(Fread_char, Fread_event, Fread_char_exclusive): New arg SECONDS.

	* lisp.h: Update read-char, read-event, and read_filtered_event
	prototypes.

	* keyboard.h: Include systime.h.  Update read_char prototype.

2006-07-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (find_string_data_in_pure): New function.
	(make_pure_string): Use it to reuse existing string data if possible.

	* puresize.h (BASE_PURESIZE): Decrease to 1102000.

2006-07-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fdefine_key): If the key binding definition looks like an
	XEmacs-style key sequence, convert it to Emacs's format.

2006-07-22  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): If `left' and/or `top' frame
	parameters are bound to some values, use that instead of
	CW_USEDEFAULT.

2006-07-21  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (convert_time): Use explicit long double constants to
	ensure long double arithmetics is used throughout.

2006-07-20  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (pure_bytes_used_lisp, pure_bytes_used_non_lisp): New vars.
	(init_alloc_once): Initialize them.
	(pure_alloc): Allocate non-Lisp objects from the end of pure storage
	without alignment.

	* puresize.h (BASE_PURESIZE): Decrease to 1141000.

2006-07-18  Francis Litterio  <franl@world.std.com>

	* w32term.c (x_calc_absolute_position): Fix frame positioning
	with negative X/Y coordinates.

2006-07-18  Dan Nicolaescu  <dann@ics.uci.edu>

	* xterm.c (x_connection_closed, x_error_quitter): Mark as NO_RETURN.

	* textprop.c (text_read_only): Likewise.

	* lread.c (end_of_file_error): Likewise.

	* lisp.h (circular_list_error, memory_full, buffer_memory_full):
	Likewise.

	* eval.c (unwind_to_catch): Likewise.

	* buffer.h (buffer_slot_type_mismatch): Likewise.

2006-07-18  Kim F. Storm  <storm@cua.dk>

	Cleanup Fsignal calls that never returns; now only use it for Qquit.

	* eval.c (xsignal): New func.  Like Fsignal, but marked no-return.
	(xsignal0, xsignal1, xsignal2, xsignal3): New no-return functions.
	(signal_error): New no-return function (from xfaces.c).
	(Fthrow): Use xsignal2 instead of Fsignal + abort.
	(error): Use xsignal1 instead of Fsignal + abort.
	(FletX, Flet, grow_specpdl): Use signal_error.
	(Feval, Ffuncall, funcall_lambda): Use xsignal1, xsignal2.

	* alloc.c (buffer_memory_full, memory_full): Use xsignal.  Remove loop.
	(list1): New function.

	* lisp.h (list1): Add EXFUN.
	(xsignal, xsignal0, xsignal1, xsignal2, xsignal3, signal_error):
	Add prototypes.  Mark them as no-return.

	* buffer.c (Fbuffer_local_value, Fbarf_if_buffer_read_only):
	Use xsignal1.

	* callint.c (check_mark): Use xsignal0.

	* casefiddle.c (casify_object): wrong_type_argument is no-return.

	* cmds.c (Fforward_char, Fdelete_char): Use xsignal0.

	* coding.c (Fcheck_coding_system): Use xsignal1.  Remove loop.
	(Fdefine_coding_system_internal): Use xsignal1.

	* data.c (circular_list_error): Use xsignal.
	(wrong_type_argument): Use xsignal2.  Don't care about return value.
	(args_out_of_range, args_out_of_range_3): Use xsignal2, xsignal3.
	Remove loop around Fsignal.
	(indirect_variable, Fsymbol_value, set_internal, Fdefault_value)
	(indirect_function, Findirect_function, Fstring_to_number)
	(Fmakunbound, Ffmakunbound, Fsymbol_function, Ffset): Use xsignal1.
	(arith_driver, float_arith_driver, Frem, Fmod, arith_error):
	Use xsignal0.

	* doc.c (Fdocumentation): Use xsignal1.

	* editfns.c (region_limit, Fget_internal_run_time): Use xsignal0.

	* fileio.c (report_file_error): Use xsignal.
	(barf_or_query_if_file_exists, Fcopy_file, Fdelete_file)
	(Finsert_file_contents): Use xsignal2.
	(syms_of_fileio): Use list2, list3.

	* floatfns.c (arith_error, range_error, domain_error): Use xsignal2.
	(range_error2, domain_error2): Use xsignal3.
	(rounding_driver, fmod_float): Use xsignal0.
	(float_error): Use xsignal1.
	(matherr): Use xsignal.

	* fns.c (Flength): wrong_type_argument is no-return.
	(hashfn_user_defined, Fmake_hash_table): Use signal_error.
	(Fmd5): Use xsignal1.

	* frame.c (x_set_line_spacing, x_set_screen_gamma): Use signal_error.

	* keyboard.c (recursive_edit_1): Use xsignal1.

	* keymap.c (Fmap_keymap): Use xsignal1.

	* lread.c (Fload): Use xsignal2, signal_error.
	(end_of_file_error): Use xsignal0, xsignal1.
	(read0): Use xsignal1.
	(invalid_syntax): New error function marked no-return.
	(read_integer, read1, read_list): Use it.

	* macselect.c (x_get_local_selection): Use signal_error.

	* msdos.c (Fmsdos_set_mouse_buttons): Use xsignal2.

	* search.c (compile_pattern_1): Use xsignal1.
	(signal_failure): Remove (was only called once).
	(search_command): Use xsignal1 instead of signal_failure.

	* syntax.c (scan_lists): Use xsignal3.

	* textprop.c (text_read_only): Use xsignal0, xsignal1.

	* unexsol.c (unexec): Use xsignal.

	* window.c (window_scroll_pixel_based, window_scroll_line_based):
	Use xsignal0.

	* xfaces.c (signal_error): Move to eval.c.
	(resolve_face_name): Use xsignal1.

	* xfns.c (x_decode_color): Use signal_error.

	* xselect.c (x_get_local_selection, copy_multiple_data)
	(x_get_window_property_as_lisp_data)
	(lisp_data_to_selection_data, CHECK_CUT_BUFFER)
	(Fx_get_cut_buffer_internal): Use signal_error.

2006-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XTread_socket): Undo previous change.

2006-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (keycode_to_xkeysym): Remove function.  All uses now
	directly lookup keycode_to_xkeysym_table.
	[USE_MAC_TSM] (mac_handle_text_input_event): Don't construct
	ASCII_KEYSTROKE_EVENT for non-zero keycode_to_xkeysym_table entries.
	(XTread_socket): Use character codes to construct keypad key events.
	(mac_initialize_display_info) [MAC_OSX]: Use CGDisplaySamplesPerPixel.
	(x_delete_display): Apply 2006-07-04 change for xterm.c.

2006-07-17  Richard Stallman  <rms@gnu.org>

	* keyboard.c (Vcommand_error_function): New variable.
	(syms_of_keyboard): Defvar it.
	(cmd_error_internal): Simplify, and handle Vcommand_error_function.

	* dispnew.c (init_display): Mention DISPLAY as well as TERM in err msg.

2006-07-17  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_single_display_spec): Ensure the right value of
	it->position is saved by push_it.
	(pop_it): Restore it->object for GET_FROM_BUFFER and GET_FROM_STRING.
	(reseat_1): Don't setup it->object twice.
	(set_iterator_to_next): No need to set it->object after pop_it.
	(move_it_to): Explicitly check to see if last move reached to_charpos.

2006-07-17  Thien-Thi Nguyen  <ttn@gnu.org>

	* xdisp.c (display_mode_line): Preserve match data.

2006-07-14  Kim F. Storm  <storm@cua.dk>

	* w32.c (pfn_WSACreateEvent, pfn_WSACloseEvent): New func ptrs.
	(init_winsock): Load them.  Use ws2_32.dll.
	(sys_listen): Undo last change.  Just set FILE_LISTEN flag.
	(sys_accept): Undo last change.  Instead, set child status to
	STATUS_READ_ACKNOWLEDGED and reset char_avail event so next
	sys_select will wakeup the reader thread.
	(_sys_wait_accept): New function used by reader thread to wait for
	an incoming connection on a server socket.

	* w32.h (_sys_read_ahead, _sys_wait_accept): Add prototypes.

	* w32proc.c (reader_thread): Use _sys_wait_accept to wait on a
	server socket (FILE_LISTEN flag).

2006-07-14  Jan Djärv  <jan.h.d@swipnet.se>

	* sound.c (alsa_init): Call snd_pcm_close after successful snd_pcm_open.

2006-07-14  Kim F. Storm  <storm@cua.dk>

	* w32.c: Fix high cpu load for server sockets.
	(pfn_WSAEventSelect): New function ptr.
	(init_winsock): Load it.
	(sys_listen): Set FILE_LISTEN flag.  Set event mask for socket's
	char_avail event object to FD_ACCEPT.
	(sys_accept): Check FILE_LISTEN flag.  Set event mask on new
	socket's char_avail event object to FD_READ|FD_CLOSE.

	* w32.h (FILE_LISTEN): New filedesc flag value.

2006-07-13  Kim F. Storm  <storm@cua.dk>

	* bytecode.c (Fbyte_code): Use CAR, CDR for Bcar, Bcdr.
	Use CAR_SAFE, CDR_SAFE for Bcar_safe, Bcdr_safe.
	Simplify loops and use CAR for Bnth and Belt.

	* data.c (Findirect_function): Optimize for no indirection.

	* eval.c (Fthrow): Remove loop around Fsignal.
	(Feval, Fapply, Ffuncall): Optimize for no function indirection.
	Use original function name in all signaled errors.
	Simplify Fsignal calls (no return).
	(funcall_lambda): Simplify Fsignal calls (no return).

2006-07-13  Andreas Schwab  <schwab@suse.de>

	* syntax.c (scan_sexps_forward): Use EMACS_INT for out_bytepos and
	out_charpos.

2006-07-13  Kenichi Handa  <handa@m17n.org>

	* editfns.c (Fformat): Fix calculation of text property positions
	of format string.

2006-07-12  Kim F. Storm  <storm@cua.dk>

	* lisp.h (CHECK_TYPE): New macro for generic type checking.
	(CAR_SAFE, CDR_SAFE): New macros.
	(ARRAYP, CHECK_ARRAY): New macros.
	(CHECK_VECTOR_OR_STRING, CHECK_SUBR): New macros.
	(CHECK_WINDOW_CONFIGURATION): New macro.
	(CHECK_LIST_CONS, CHECK_LIST_END): New checks for list traversal.
	(CHECK_STRING_OR_BUFFER, CHECK_HASH_TABLE, CHECK_LIST)
	(CHECK_STRING, CHECK_STRING_CAR, CHECK_CONS, CHECK_SYMBOL)
	(CHECK_CHAR_TABLE, CHECK_VECTOR, CHECK_VECTOR_OR_CHAR_TABLE)
	(CHECK_BUFFER, CHECK_WINDOW, CHECK_LIVE_WINDOW, CHECK_PROCESS)
	(CHECK_NUMBER, CHECK_NATNUM, CHECK_MARKER, CHECK_OVERLAY)
	(CHECK_NUMBER_COERCE_MARKER, CHECK_FLOAT, CHECK_NUMBER_OR_FLOAT)
	(CHECK_NUMBER_OR_FLOAT_COERCE_MARKER): Use CHECK_TYPE.

	* category.h (CHECK_CATEGORY, CHECK_CATEGORY_SET):
	* frame.h (CHECK_FRAME, CHECK_LIVE_FRAME): Use CHECK_TYPE.

	* callint.c (Fcall_interactively):
	* casefiddle.c (casify_object):
	* editfns.c (general_insert_function):
	* fns.c (Flength, Felt, Ffillarray):
	* data.c (Fcar, Fcdr): Remove loop around wrong_type_argument.

	* data.c (wrong_type_argument): Remove loop around Fsignal.
	(Farrayp, Fsequencep): Use ARRAYP.
	(Fcar): Use CAR.
	(Fcar_safe): Use CAR_SAFE.
	(Fcdr): Use CDR.
	(Fcdr_safe): Use CDR_SAFE.
	(Fsetcar, Fsetcdr): Use CHECK_CONS.
	(Fsubr_arity, Fsubr_name): Use CHECK_SUBR.
	(Faset): Use CHECK_ARRAY.

	* fns.c (Felt): Use CHECK_ARRAY.
	(concat): Use CHECK_NUMBER.
	(Fsubstring, substring_both): Use CHECK_VECTOR_OR_STRING.
	(Fmemq): Use CHECK_LIST.
	(Fassq, Fassoc, Frassq, Frassoc): Use CAR.
	(assq_no_quit): Use CAR_SAFE.
	(Fnthcdr, Fmember, Fdelq, Fdelete, Fnreverse, Fnconc):
	Use CHECK_LIST_CONS.
	(Freverse, Fplist_get, Flax_plist_get): Use CHECK_LIST_END.

	* bytecode.c (Fbyte_code): Use CHECK_VECTOR.

	* casetab.c (check_case_table):
	* category.c (check_category_table):
	* marker.c (Fcopy_marker):
	* syntax.c (check_syntax_table):
	* xfaces.c (load_pixmap): Use CHECK_TYPE.

	* fns.c (Fcopy_sequence, concat):
	* fringe.c (Fdefine_fringe_bitmap):
	* lread.c (check_obarray): Cleanup wrong_type_argument use.

	* keyboard.c (access_keymap_keyremap): Use ARRAYP.

	* keymap.c (Fdefine_key, Flookup_key):
	* macros.c (Fstart_kbd_macro): Use CHECK_VECTOR_OR_STRING.

	* mac.c (Fmac_get_preference): Use CHECK_LIST_END.

	* search.c (Fset_match_data): Use CHECK_LIST.

	* sunfns.c (sun_item_create): Use CHECK_LIST_CONS.

	* window.c (Fwindow_configuration_frame, Fset_window_configuration):
	(compare_window_configurations): Use CHECK_WINDOW_CONFIGURATION.

2006-07-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (dired.o, editfns.o, fileio.o): Depend on blockinput.h.

	* dired.c: Include blockinput.h.
	(Ffile_attributes): Add BLOCK_INPUT around getpwuid/getgrgid.

	* editfns.c: Include blockinput.h.
	(Fuser_login_name, Fuser_full_name): Add BLOCK_INPUT around
	getpwuid/getpwnam.

	* fileio.c: Include blockinput.h.
	(Fexpand_file_name, search_embedded_absfilename): Add BLOCK_INPUT
	around getpwnam.
	(search_embedded_absfilename): Remove spurious xfree.

2006-07-11  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (sit_for): Reduce number of args from 5 to 3.
	Now just one TIMEOUT arg that can be a Lisp float or Lisp int.
	Combine args DISPLAY and INITIAL_DISPLAY into one arg DO_DISPLAY.
	Signal error if TIMEOUT is not a number.
	Undo 2006-06-14 change for non-preemptive display if TIMEOUT < 0.
	The rework of sit_for args also fixes several incorrect Qt args
	which should have been 1.
	(Fredisplay): Pass 1 instead of Qt to swallow_events and
	detect_input_pending_run_timers.

	* lisp.h (sit_for): Update prototype.
	(Fredisplay): Add EXFUN.

	* dispextern.h (sit_for): Remove prototype.

	* callint.c (Fcall_interactively):
	* minibuf.c (temp_echo_area_glyphs):
	* keyboard.c (command_loop_1, read_char, Fexecute_extended_command):
	* fileio.c (Fdo_auto_save): Update/simplify sit_for calls.

2006-07-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (forw_comment): Also use EMACS_INT for buffer positions.

2006-07-11  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (Fredisplay): Add FORCE argument to force redisplay when
	input is available.  Fix test for redisplay_dont_pause non-nil.
	Specbind redisplay-dont-pause to t if FORCE non-nil.

2006-07-10  Chong Yidong  <cyd@stupidchicken.com>

	* puresize.h (BASE_PURESIZE): Increment to 1211000.

	* dispnew.c (Fredisplay): New function, equivalent to (sit-for 0).
	(Fsit_for): Function deleted.

	* keyboard.c (command_loop_1, Fexecute_extended_command):
	Call sit_for instead of Fsit_for.

	* minibuf.c (temp_echo_area_glyphs): Likewise.

2006-07-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fforward_comment): Revert the reversion.
	(back_comment, scan_lists): Also use EMACS_INT for buffer positions.

2006-07-09  John Paul Wallington  <jpw@pobox.com>

	* syntax.c (Fforward_comment): Revert previous change.

2006-07-09  Kim F. Storm  <storm@cua.dk>

	* window.c (Fforce_window_update): Doc fix.

2006-07-08  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* fileio.c (do_auto_save_make_dir): Make the auto-save-list-file
	directory unreadable for better user privacy.

2006-07-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fforward_comment): Fix int-32 vs EMACS_INT-64 mixup.

	* lread.c (read_filtered_event): Remove `register' qualifier because it
	causes compilation problem with gcc-4.0.2-20051125 on amd64.
	(readevalloop): Remove unused var `bpos'.
	Yet another int/Lisp_Object mixup (YAILOM).

2006-07-07  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (Fexecute_extended_command): Mention the argument
	PREFIXARG in the doc string.

2006-07-07  Kim F. Storm  <storm@cua.dk>

	* fringe.c (Fdefine_fringe_bitmap): Doc fix.

2006-07-05  Chong Yidong  <cyd@stupidchicken.com>

	* insdel.c (prepare_to_modify_buffer): For an indirect buffer, do
	clash detection using the base buffer.

	* puresize.h (BASE_PURESIZE): Increment to 1210500.

2006-07-04  Kim F. Storm  <storm@cua.dk>

	* xterm.c (x_delete_display): Don't free or derefence NULL pointers.

2006-07-04  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Fset_overriding_fontspec_internal): Check if we need
	to update Voverriding_fontspec_alist.

2006-07-03  Richard Stallman  <rms@gnu.org>

	* xfns.c (Fx_create_frame): Move unwind_create_frame setup down.

	* xfaces.c (Fface_attribute_relative_p): Doc fix.

	* textprop.c (Fget_char_property_and_overlay): Doc fix.

	* eval.c (Fdefvaralias): Doc fix.

2006-07-03  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (sit_for): Fix preempt condition.

2006-07-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (read_filtered_event): Treat select-window just like
	switch-frame.

2006-07-02  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_tool_bar_line): Skip glyphs which are too big
	to ever fit the tool-bar,
	(MAX_FRAME_TOOL_BAR_HEIGHT): New macro.
	(tool_bar_lines_needed): Use unused mode-line row as temp_row.
	(redisplay_tool_bar): Only clear desired matrix if we actually
	change the tool-bar window height.  Only try to make the tool-bar
	window bigger if there is actually room for it.

2006-06-30  Ralf Angeli  <angeli@caeruleus.net>

	* w32term.c (x_make_frame_visible): Use SystemParametersInfo with
	SPI_GETWORKAREA to find the dimensions of the screen work area,
	and adjust vertical position of the frame in order to avoid being
	covered by the task bar.

	* w32fns.c (w32_createwindow): Use CW_USEDEFAULT instead of
	f->left_pos and SH_SHOW instead of f->top_pos in the call to
	CreateWindow.  Record the actual position in f->left_pos and
	f->top_pos.

2006-06-30  John Paul Wallington  <jpw@pobox.com>

	* w32console.c (syms_of_ntterm) <w32-use-full-screen-buffer>:
	Doc fix - default value has changed.

2006-06-28  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!TARGET_API_MAC_CARBON]: Don't include FixMath.h or Scrap.h.

	* macfns.c (Fx_create_frame): Apply 2006-06-24 change for xfns.c.

	* macgui.h (USE_MAC_TSM) [TARGET_API_MAC_CARBON]: Set default to 1.

	* macterm.c (Qeql): Add extern.
	(x_set_mouse_pixel_position) [MAC_OSX]: Use CGWarpMouseCursorPosition.
	(fm_style_face_attributes_alist) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Initialize and staticpro it.
	Change keys of Vmac_atsu_font_table from strings to numbers.
	(fm_style_to_face_attributes) [USE_ATSUI]: New function.
	(init_font_name_table) [USE_ATSUI]: Use it.
	(saved_ts_script_language_on_focus) [USE_MAC_TSM]: New variable.
	(syms_of_macterm) [USE_MAC_TSM]: Initialize and staticpro it.
	[USE_MAC_TSM] (mac_tsm_resume): Restore script and language codes
	only when saved_ts_script_language_on_focus coincides with
	Vmac_ts_script_language_on_focus.
	[USE_MAC_TSM] (mac_tsm_suspend): Save value of
	Vmac_ts_script_language_on_focus to saved_ts_script_language_on_focus.
	(XTread_socket) [USE_MAC_TSM]: Add Mac OS Classic support.
	[USE_MAC_TSM] (mac_handle_text_input_event, init_tsm): Likewise.

2006-06-27  Chong Yidong  <cyd@stupidchicken.com>

	* editfns.c (Fdelete_field, Ffield_string, Ffield_beginning)
	(Ffield_string_no_properties, Ffield_end): Mention
	args-out-of-range error condition in docstring.

2006-06-27  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_composition_prop): Set stop_charpos before push_it.

2006-06-25  Kim F. Storm  <storm@cua.dk>

	* s/gnu-linux.h (SIGNALS_VIA_CHARACTERS): Define for Linux kernel
	version 2.4 and later.

2006-06-24  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (Fx_create_frame): Set font parameter directly instead of
	using x_default_parameter, since x_get_args clears the parm alist.

2006-06-24  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (directory_files_internal) [WINDOWSNT]: Find files
	case-insensitively.

2006-06-24  Aidan Kehoe  <kehoea@parhasard.net>

	* lread.c (read_escape): When an unknown Unicode code point is
	encountered as a string or character escape, signal an error.

2006-06-23  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Dump iterator stack.

	* xdisp.c (handle_composition_prop): Push iterator on stack.
	(set_iterator_to_next): Pop iterator at end of composition.

2006-06-23  Martin Rudalics  <rudalics@gmx.at>

	* fileio.c (Frename_file) [DOS_NT]: Don't try to move directory to
	itself on DOS_NT platforms, if the old and new names are identical
	but for the letter-case.

2006-06-21  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct it): Add `position' member to iterator stack.
	Rename `pos' member to `current'.  Rearrange and add comments.

	* xdisp.c (handle_stop): Set it->ignore_overlay_strings_at_pos_p
	if  we get any overlays.
	(set_cursor_from_row): Don't clobber `end' if we rescan from
	start_string.
	(push_it, pop_it): Save it->position.

2006-06-19  Richard Stallman  <rms@gnu.org>

	* window.c (size_window): New arg FIRST_ONLY.  All callers changed.
	(adjust_window_trailing_edge): Specially compute FIRST_PARALLEL
	for the case of a top-level window and the following minibuffer.
	Don't exit because of no `next' when there is a parent.
	Use the FIRST_ONLY feature when resizing following windows.

	* syntax.c (init_syntax_once): Give most control chars' syntax Spunct.

2006-06-17  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (update_frame): Check for input pending on entry.
	(update_window, update_frame_1): Break loop if input is detected.

2006-06-16  Francis Litterio  <flitterio@gmail.com>

	* xterm.c (x_check_expected_move, handle_one_xevent)
	(x_set_offset, x_check_fullscreen): Extensive changes to make
	frame positioning deterministic under X.

	* xterm.h (x_output): Add members left_before_move and
	top_before_move.  Removed members expected_left and expected_top.

2006-06-16  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct it): Add union to iterator stack to save
	image, composition, and stretch specific paramters.

	* xdisp.c (next_overlay_string): Fix assert.
	(push_it, pop_it): Handle composition and stretch specific values.
	Only handle it->slice in image (for now).
	(back_to_previous_visible_line_start): Continue search if newline is
	part of a compisition.  Simplify.
	(reseat_1): Set it->object to buffer.
	(set_iterator_to_next): Set it->object to string or buffer, when
	setting it->method to GET_FROM_STRING or GET_FROM_BUFFER.
	(next_element_from_composition): Set it->object to buffer if not
	from string.
	(set_cursor_from_row): Only save start of string if not already
	done to handle multiple strings in a row.

	* .gdbinit (pitx): Show composition parameters.
	(pgx, pg): New commands to print a glyph structure.
	(pgi, pgn): New commands to print specific/next glyph.
	(pgrowx, pgrow): New commands to print all glyphs in a row.

2006-06-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_display_mm_height, Fx_display_mm_width)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Use CGDisplayScreenSize.

	* macterm.c (do_app_resume, do_app_suspend): Remove functions.
	(mac_tsm_resume, mac_tsm_suspend) [USE_MAC_TSM]: New functions.
	(mac_handle_window_event, XTread_socket) [USE_MAC_TSM]: Use them.
	(Vmac_ts_script_language_on_focus) [USE_MAC_TSM]: New variable.
	(syms_of_macterm) [USE_MAC_TSM]: Defvar it.
	(saved_ts_language, saved_ts_component) [USE_MAC_TSM]: New variables.
	(mac_initialize_display_info) [MAC_OSX]: Use Quartz Display
	Services functions to get size of main display in pixels.

2006-06-14  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (back_to_previous_visible_line_start):
	Reset it->continuation_lines_width.

2006-06-14  Richard Stallman  <rms@gnu.org>

	* eval.c (Fdefconst): Mark variable as risky.

	* callproc.c (Fcall_process): Doc fix.

	* window.c (adjust_window_trailing_edge): Don't break out of the loop
	because there's no next window, if there are parallel windows.
	Do break out when WINDOW is nil.

2006-06-14  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (IT_STACK_SIZE): New macro specifying size of
	iterator stack (instead of hardcoded number).  Increase from 2 to
	4 to make room for propertized overlay strings before and after a
	display string, image or composition.
	(struct it): Add image_id and method members to iterator stack.

	* xdisp.c (init_from_display_pos): Don't set it->method and
	overlay_string_index after pop_it.  Add asserts.
	(handle_stop): Look for overlay strings around a display string,
	image, or composition.  Handle properties on those strings.
	(next_overlay_string): Don't set string, pos or method after pop_it.
	(get_overlay_strings_1): Split from get_overlay_strings; don't
	modify it if no overlay strings are found.
	(get_overlay_strings): Use get_overlay_strings_1.  Always set
	it->string and it->method.
	(push_it): Push it->image_id and it->method.  Push it->object
	instead of it->string if method is GET_FROM_IMAGE.
	(pop_it): Pop it->image_id and it->method.  Ppo it->object
	instead of it->string if method is GET_FROM_IMAGE.
	Reset it->current.string_pos if popped it->string is nil.
	(reseat_1): Remove comment dated 19 May 2003.  It expressed doubt
	whether a given change was correct; but the change is correct.
	Clear it->string_from_display_prop_p.
	(set_iterator_to_next): Rely on it->method and it->image_id from
	iterator stack, instead of setting them explicitly after pop_it.

	* dispnew.c (sit_for): Undo 2006-06-01 change.  Instead, a
	negative time forces redisplay even when input is available.
	(Fsit_for): Doc fix.

2006-06-13  Kim F. Storm  <storm@cua.dk>

	* dispnew.c: Modify preemptive redisplay to be based on periodic
	checks for input.
	(PERIODIC_PREEMPTION_CHECKING): Define to 1 iff EMACS_HAS_USECS.
	(Vredisplay_preemption_period): New variable.
	(syms_of_display): DEFVAR_LISP and initialize it.
	(preemption_period, preemption_next_check): New variables.
	(update_frame, update_single_window): Initialize them based on
	Vredisplay_preemption_period if !force_p.
	(update_window, update_frame_1): Use them to determine when to
	check for input.

2006-06-03  Aidan Kehoe  <kehoea@parhasard.net>

	* lread.c (read_escape): Provide a Unicode character escape
	syntax; \u followed by exactly four or \U followed by exactly
	eight hex digits in a comment or string is read as a Unicode
	character with that code point.

2006-06-09  Eli Zaretskii  <eliz@gnu.org>

	* window.c (window_scroll_pixel_based): Signal "Beginning of
	buffer" when scroll-down at the beginning of an empty buffer.

2006-06-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_MAC_TSM] (mac_handle_text_input_event):
	Exclude 0x7f from ASCII range.

2006-06-05  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_set_scroll_bar_thumb, x_scroll_bar_create)
	(w32_set_vertical_scroll_bar, w32_scroll_bar_handle_click)
	(x_scroll_bar_report_motion): Remove workarounds for
	versions of Windows NT < 3.51.
	[!SIF_ALL]: Remove.
	(pfnSetScrollInfo, pfnGetScrollInfo): Remove.
	(w32_initialize): Don't dynamically load Get/SetScrollInfo.

2006-06-04  David Kastrup  <dak@gnu.org>

	* dispnew.c: Mention `redisplay-dont-pause' in doc string of
	`sit-for'.

2006-06-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_icon_name): Apply 2006-06-02 change for xfns.c.

	* macgui.h (USE_MAC_TSM): Set default to 1 on Mac OS X.

	* macterm.c (tsm_document_id) [USE_MAC_TSM]: New variable.
	(Qtext_input, Qupdate_active_input_area, Qunicode_for_key_event)
	[USE_MAC_TSM]: Likewise.
	(syms_of_macterm) [USE_MAC_TSM]: Intern and staticpro them.
	(Qbefore_string) [USE_MAC_TSM]: Add extern.
	(do_app_resume, do_app_suspend) [USE_MAC_TSM]: Call
	ActivateTSMDocument/DeactivateTSMDocument.
	(mac_store_event_ref_as_apple_event): Call mac_post_mouse_moved_event.
	(mac_handle_window_event) [USE_MAC_TSM]: Handle
	kEventWindowFocusAcquired/kEventWindowFocusRelinquish.
	(mac_handle_text_input_event) [USE_MAC_TSM]: New function.
	(install_window_handler) [USE_MAC_TSM]: Install it.  Register
	kEventWindowFocusAcquired/kEventWindowFocusRelinquish.
	(keycode_to_xkeysym_table): Add entry for f16.
	(XTread_socket) [USE_MAC_TSM]: Set/reset read_socket_inev
	before/after passing keystroke event to toolbox dispatcher.
	(init_tsm) [USE_MAC_TSM]: New function.
	(mac_initialize) [USE_MAC_TSM]: Call it.
	(Vmac_ts_active_input_overlay) [USE_MAC_TSM]: New defvar.

	* macterm.h (EVENT_PARAM_TEXT_INPUT_SEQUENCE_NUMBER): New enumerator.

2006-06-02  John Paul Wallington  <jpw@gnu.org>

	* xfns.c (x_set_name_internal): Set icon to `text', derived from
	name, when frame's icon_name isn't a string rather than only when
	it is nil.

2006-06-03  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (x_set_icon_name): Don't use arg if it's not a string
	and not nil.

2006-06-02  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (x_set_icon_name): No-op if arg is non-nil and not a
	string.

2006-06-02  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (next_element_from_composition): Set it->object to
	it->string if composition is coming from string.
	(set_cursor_from_row): Don't return 0 unless row displays a
	continued line.
	(dump_glyph): Dump composite glyph.

2006-06-02  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (menu_nav_ended): Check that menubar_widget is not NULL.

2006-06-01  Richard Stallman  <rms@gnu.org>

	* window.c (Fsplit_window): Doc fix.

2006-06-01  Michaël Cadilhac  <michael.cadilhac@lrde.org>

	* process.c (deleted_pid_list): New variable to store the pids
	of deleted processes.  Declare it only if SIGCHLD is defined.
	(init_process): Initialize it.
	(syms_of_process): Staticpro it.
	(Fdelete_process): Add pid of the deleted process to it.  Check after
	the addition and before the kill if the process is already stopped,
	in which case it is deleted from the list and not killed.
	(sigchld_handler): Define it only if SIGCHLD is.  Search the process
	that signaled Emacs in `deleted_pid_list' before `Vprocess_alist'.
	Original idea by Stefan Monnier.

2006-06-01  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (sit_for): Perform redisplay even if input is pending
	when redisplay-dont-pause is non-nil.

2006-06-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_handle_visibility_change): Set buf.arg to Qnil.
	(XTread_socket): Remove obsolete comment.

2006-06-01  Jan Djärv  <jan.h.d@swipnet.se>

	* xmenu.c (syms_of_xmenu): Make accelerate-menu an alias for
	menu-bar-open.

2006-06-01  Jan Djärv  <jan.h.d@swipnet.se>

	* xmenu.c (Fmenu_bar_open, syms_of_xmenu): Change menu-bar-start to
	menu-bar-open.

	* gtkutil.c (menu_nav_ended): Change x-menu-bar-start to menu-bar-open.

2006-05-31  Juri Linkov  <juri@jurta.org>

	* minibuf.c (Vhistory_add_new_input): New variable.
	(read_minibuf): Use it.
	(syms_of_minibuf) <history-add-new-input>: New Lisp variable.
	(syms_of_minibuf) <history-delete-duplicates>: Doc fix.

2006-05-31  Kim F. Storm  <storm@cua.dk>

	* process.c (select_wrapper): Add wrapper around select to work around
	"incomplete backtrace" bug in gdb 5.3, when emacs is stopped inside
	select called from wait_reading_process_output.

2006-05-30  Andreas Schwab  <schwab@suse.de>

	* xmenu.c (Fmenu_bar_start): Return a value.

2006-05-30  Richard Stallman  <rms@gnu.org>

	* coding.c (Ffind_operation_coding_system): Doc fix.

2006-05-30  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c (x_draw_hollow_cursor): Fix last change.

2006-05-29  Kim F. Storm  <storm@cua.dk>

	* w32term.c (x_draw_stretch_glyph_string): Fix last change.

2006-05-29  Eli Zaretskii  <eliz@gnu.org>

	* coding.c (Ffind_operation_coding_system): Doc fix.

2006-05-29  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c [USE_MAC_FONT_PANEL] (Fmac_set_font_panel_visibility):
	Call mac_set_font_info_for_selection if font panel is made visible.

	* macterm.c (font_panel_shown_p) [USE_MAC_FONT_PANEL]: New variable.
	(mac_font_panel_visible_p, mac_show_hide_font_panel)
	[USE_MAC_FONT_PANEL]: New functions.
	[USE_MAC_FONT_PANEL] (mac_set_font_info_for_selection):
	Return immediately if font panel is not visible.

	* macterm.h (mac_font_panel_visible_p, mac_show_hide_font_panel):
	Add externs.

2006-05-29  Dan Nicolaescu  <dann@ics.uci.edu>

	* search.c (matcher_overflow): Mark as NO_RETURN.

	* xterm.c (x_connection_closed): Likewise.

	* sysdep.c (croak): Likewise.

	* sound.c (sound_perror, alsa_sound_perror): Likewise.

	* lisp.h (die, nsberror): Likewise.

2006-05-29  Jan Djärv  <jan.h.d@swipnet.se>

	* sound.c (alsa_open, alsa_configure, alsa_write):
	Move assignment to err out of if-statement.

	* gtkutil.c (menu_nav_ended): New function.
	(create_menus): Connect menu_nav_ended to "selection-done" to fix
	grabs.

	* xmenu.c (Fmenu_bar_start): New function for USE_GTK and USE_X_TOOLKIT.

2006-05-28  Dan Nicolaescu  <dann@ics.uci.edu>

	* charset.h (invalid_character): Mark as NO_RETURN.

2006-05-29  Kenichi Handa  <handa@m17n.org>

	* coding.c (Ffind_operation_coding_system): Call a function by
	safe_call1 instead of call1.

2006-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (struct saved_window): Add `dedicated'.
	(Fset_window_configuration, save_window_save): Save/restore the
	`dedicated' flag.

2006-05-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): If cursor cannot be set in row,
	don't update w->cursor and return 0.  Return 1 on success.
	(try_cursor_movement): Repeat set_cursor_from_row on successive rows
	until it succeeds.

	* dispextern.h (set_cursor_from_row): Update prototype.

2006-05-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_phys_cursor_geometry): Return computed x and y through
	parameters.  Adjust x and width in case cursor in on a partially
	visible stretch glyph on the left edge.
	(erase_phys_cursor): Don't erase into left fringe/margin in case
	previous cursor glyph is a partially visible stretch glyph on left.

	* dispextern.h (get_phys_cursor_geometry): Update prototype.

	* xterm.c (x_draw_stretch_glyph_string): Fix problems with invisible
	cursor and erasing cursor on partially visible stretch glyph on left.
	(x_draw_hollow_cursor): Compute x via get_phys_cursor_geometry.

	* macterm.c: Likewise.

	* w32term.c: Likewise.

2006-05-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macselect.c (mac_handle_apple_event):
	Return errAEEventNotHandled if key binding is not found.

2006-05-26  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (main) [PROFILING]: Enable also for __MINGW32__.
	[__MINGW32__]: MinGW-specific declaration of `etext'.

	* w32heap.c (etext, edata): Remove unused definitions.

2006-05-26  Chong Yidong  <cyd@stupidchicken.com>

	* fileio.c (Fcopy_file): Delete argument MUSTBENEW.
	Incorporate the exclusive file-opening functionality into the behavior
	when OK-IF-ALREADY-EXISTS is nil.
	(Frename_file): Call Fcopy_file without MUSTBENEW argument.

2006-05-26  Jan Djärv  <jan.h.d@swipnet.se>

	* sound.c (alsa_configure): Move get period/buffer_size after
	setting hwparams.

2006-05-26  Kenichi Handa  <handa@m17n.org>

	* coding.c (Ffind_operation_coding_system): Allow (FILENAME
	. BUFFER) in TARGET.

2006-05-25  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (png_load): Don't call fclose on NULL.

2006-05-25  Luc Teirlinck  <teirllm@auburn.edu>

	* fns.c (Fyes_or_no_p):
	* callint.c (Fcall_interactively): Fread_from_minibuffer now takes
	only seven args.

2006-05-25  Juri Linkov  <juri@jurta.org>

	* lisp.h (Fread_from_minibuffer): Decrement number of args.

	* minibuf.c (read_minibuf): Remove arg KEEP_ALL.  Callers changed.
	(Fread_from_minibuffer): Remove arg KEEP_ALL.  Callers changed.

	* buffer.c (mode-line-format): Fix docstring.

2006-05-25  Richard Stallman  <rms@gnu.org>

	* emacs.c (main, Fdump_emacs): Don't test __linux or __linux__.

2006-05-24  Luc Teirlinck  <teirllm@auburn.edu>

	* puresize.h (BASE_PURESIZE): Increase to 1210000.

2006-05-24  Alan Mackenzie  <acm@muc.de>

	* lread.c (Vload_history): Enhance doc-string to say that the file
	is the absolute truename of the loaded file.

	* lread.c (Vafter_load_alist): doc-string: state that an element
	now has a regexp to match file names, not a file name as such.

	* lread.c (readevalloop): Call file-truename on the name for
	load-history, except at preloading time.

	* lread.c (Fload): At preloading time, preserve the extension of
	the filename which goes into load-history.  New var hist_file_name.

	* lread.c (Fload): Do eval-after-load stuff by calling the lisp
	function do-after-load-evaluation.

2006-05-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (ae_attr_table): New variable.
	(syms_of_mac): Intern and staticpro its elements.
	(mac_aelist_to_lisp): Also convert Apple event attributes.
	(mac_ae_put_lisp): New function.
	(create_apple_event_from_event_ref) [MAC_OSX]: Use typeUTF8Text.

	* macfns.c (Fx_server_version): Use gestaltSystemVersionMajor etc.

	* macselect.c (Qemacs_suspension_id): New variable.
	(syms_of_macselect): Intern and staticpro it.
	(struct suspended_ae_info): New struct.
	(deferred_apple_events, defer_apple_events)
	(Fmac_process_deferred_apple_events): Use it.
	(suspended_apple_events): New variable.
	(mac_handle_apple_event_1): New function.
	(mac_handle_apple_event): Use it.  Don't process previously
	suspended events.
	(cleanup_suspended_apple_events, get_suspension_id)
	(cleanup_all_suspended_apple_events): New functions.
	(init_apple_event_handler): Call cleanup_all_suspended_apple_events
	at exit.
	(Fmac_cleanup_expired_apple_events, Fmac_ae_set_reply_parameter)
	(Fmac_resume_apple_event): New defuns.
	(syms_of_macselect): Defsubr them.

	* macterm.c (fn_keycode_to_keycode_table, XTread_socket) [MAC_OSX]:
	Fix last change.  Don't map `fn' modifier if pressed with F1 ... F12.

	* macterm.h (TYPE_FILE_NAME): Change from macro to enumerator.
	(KEY_EMACS_SUSPENSION_ID_ATTR): New enumerator.
	(keyReplyRequestedAttr) [MAC_OS_X_VERSION_MAX_ALLOWED < 1030]: Likewise.
	(gestaltSystemVersionMajor, gestaltSystemVersionMinor)
	(gestaltSystemVersionBugFix) [MAC_OS_X_VERSION_MAX_ALLOWED < 1040]:
	Likewise.
	(typeUTF8Text, kEventParamWindowMouseLocation)
	[MAC_OSX && MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Likewise.
	(x_get_focus_frame, mac_ae_put_lisp): Add externs.

2006-05-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (fn_keycode_to_xkeysym_table, convert_fn_keycode): Remove.
	(fn_keycode_to_keycode_table) [MAC_OSX]: New variable.
	(mac_set_unicode_keystroke_event) [TARGET_API_MAC_CARBON]: New function.
	(XTread_socket) [TARGET_API_MAC_CARBON]: Use it.
	(XTread_socket) [MAC_OSX]: Try 'uchr' Unicode keyboard-layout
	resource to backtranslate key with modifiers.
	(XTread_socket): Don't set read_socket_inev around AEProcessAppleEvent.

2006-05-23  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c: Remove declarations already in xterm.h.

	* xterm.h: Add extern declarations for x_clear_errors,
	x_fully_uncatch_errors, x_catching_errors and
	x_alloc_lighter_color_for_widget.  Remove duplicated declarations.

2006-05-21  Richard Stallman  <rms@gnu.org>

	* xfaces.c (best_matching_font): Abort for best == NULL
	before we start to use it.

	* buffer.c (syms_of_buffer, Fmake_overlay): Doc fixes.

2006-05-20  Kim F. Storm  <storm@cua.dk>

	* xfaces.c (best_matching_font): Fix crash in 2006-05-17 change.

2006-05-20  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (convert_fn_keycode): Fix last change.

2006-05-19  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (init_environment): Perform the processing of environment
	variables on a copy of default variables and their values, not on
	the original.  Simplify code that calls ExpandEnvironmentStrings
	and make buf1[] and buf2[] more visible for easier debugging.

2006-05-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* frame.c (x_set_border_width): Remove #ifndef MAC_OS.

	* image.c [MAC_OS] (gif_load): Allocate Lisp string first.

	* macfns.c (Fx_focus_frame): Don't check dpyinfo->x_focus_frame.

	* macterm.c (XTread_socket) [TARGET_API_MAC_CARBON && MAC_OSX]:
	Forward keyUp events to toolbox_dispatcher.

	* window.c (foreach_window): Check WINDOWP (FRAME_ROOT_WINDOW (f)).

2006-05-18  Jan Djärv  <jan.h.d@swipnet.se>

	* config.in: Regenerated (HAVE_ALSA).

	* sound.c (alsa_sound_perror, alsa_open, alsa_period_size)
	(alsa_configure, alsa_close, alsa_choose_format, alsa_write)
	(snd_error_quiet, alsa_init): New functions.
	(vox_init): Return 0 if unable to open device.
	(Fplay_sound_internal): Test for alsa first and use vox (oss) as
	a fallback.
	(struct sound_device): Add period_size.
	(wav_play, au_play): Use period_size if set.

	* Makefile.in (CFLAGS_SOUND): New flags for ALSA.
	(ALL_CFLAGS): Add CFLAGS_SOUND.

2006-05-18  Kenichi Handa  <handa@m17n.org>

	* callproc.c (Fcall_process): Reject encoding arguments by
	ascii-incompatible coding systems (e.g. utf-16).

	* coding.c (Qascii_incompatible): New variable.
	(syms_of_coding): Setup Qascii_incompatible.
	(setup_coding_system): Be sure to initialize coding->common_flags.
	Check `ascii-incompatible' property of the coding system.

	* coding.h (CODING_ASCII_INCOMPATIBLE_MASK): New macro.

2006-05-18  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_tool_bar_line): Restore entire tool-bar
	geometry when backtracking in case last image doesn't fit on line.

2006-05-18  MIYOSHI Masanori  <miyoshi@meadowy.org>  (tiny change)

	* xdisp.c (display_tool_bar_line): Don't adjust tool-bar height by
	more than height of one frame default line.

2006-05-17  Richard Stallman  <rms@gnu.org>

	* xfaces.c (better_font_p): Any font beats no font.
	(best_matching_font): Simplify based on above change.

	* buffer.c (Fprevious_overlay_change, Fnext_overlay_change): Doc fixes.

2006-05-16  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Check that f is not NULL before
	calling x_kill_gs_process.

2006-05-14  Richard Stallman  <rms@gnu.org>

	* textprop.c (Fnext_single_char_property_change)
	(Fprevious_single_char_property_change): Don't allow returning
	value beyond LIMIT in any cases.
	(Fnext_char_property_change, Fprevious_char_property_change): Doc fix.

	* intervals.c (get_local_map): Abort if POSITION outside BEGV, ZV.

2006-05-14  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Check that f is not NULL before
	calling _XEditResCheckMessages.

2006-05-14  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Fix crash in 2006-03-24 change.

2006-05-13  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (x_set_border_width): Fix error message to say "frame",
	not "window".

	* Makefile.in (SOME_MACHINE_LISP): Add fringe.elc.

2006-05-12  Chong Yidong  <cyd@stupidchicken.com>

	* intervals.c (set_point_both): Fix mixup before before and after
	in variable names.

	* editfns.c (Fline_beginning_position): Inhibit point-motion hooks
	while setting point temporarily.

2006-05-11  Richard Stallman  <rms@gnu.org>

	* lread.c (readevalloop): Abort if START non-nil for non-buffer input.

2006-05-11  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_tool_bar): Handle large tool-bar-border values.

2006-05-11  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): Fix for the case of IO error
	while handling replace operation.

2006-05-10  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (realize_default_face) [HAVE_X_WINDOWS]: If the font
	chosen for the default face was different from the frame font,
	adjust the frame font.

2006-05-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (Qduration) [MAC_OS]: Undo previous change.
	(syms_of_image) [MAC_OS]: Likewise.
	[MAC_OS] (gif_load): Emulate Graphic Control Extension block.

	* macfns.c (x_to_mac_color): Fix shift amount change.
	(mac_set_font) [USE_MAC_FONT_PANEL]: Use x_get_focus_frame.
	[USE_MAC_FONT_PANEL] (Fmac_set_font_panel_visibility): Doc fix.

	* macselect.c (Vmac_service_selection) [MAC_OSX]: Rename from
	Vmac_services_selection.  All uses changed.
	(mac_store_service_event): Rename from mac_store_services_event in
	extern and calls.

	* macterm.c (Qservice) [MAC_OSX]: Rename from Qservices.  All uses
	changed.
	[MAC_OSX] (mac_store_service_event): Rename from
	mac_store_services_event.  All callers changed.
	[USE_MAC_FONT_PANEL] (mac_set_font_info_for_selection): Add args
	FACE_ID and C.  All callers changed.
	(x_free_frame_resources) [USE_MAC_FONT_PANEL]: Call
	mac_set_font_info_for_selection when focus frame is destroyed.
	(XTread_socket): Revert to FrontNonFloatingWindow/FrontWindow.

	* macterm.h (mac_set_font_info_for_selection): Add 2nd and 3rd
	args in extern.

2006-05-09  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (describe_map): Avoid generating duplicate entries if
	the shadowed binding has the same definition.

2006-05-09  Kenichi Handa  <handa@m17n.org>

	* keymap.c (push_key_description): Handle invalid character key.

2006-05-08  Kenichi Handa  <handa@m17n.org>

	* callproc.c (Fcall_process): Use system_eol_type for encoding
	arguments if eol_type is not yet decided.

	* coding.h (system_eol_type): Extern it.

	* coding.c (setup_coding_system): For invalid coding-system, set
	coding->eol_type to CODING_EOL_UNDECIDED.
	(encode_coding): Cancel previous change.
	(shrink_encoding_region): Likewise.
	(code_convert_region1): Likewise.
	(code_convert_string1): Likewise.
	(code_convert_string_norecord): Likewise.

	* fileio.c (choose_write_coding_system): Use system_eol_type for
	encoding if eol_type is not yet decided.

	* process.c (setup_process_coding_systems): Use system_eol_type
	for encoding if eol_type is not yet decided.
	(read_process_output): Likewise.
	(send_process): Likewise.

2006-05-07  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (syms_of_minibuf) <history-length>: Fix typo in doc.

2006-05-07  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (Fmac_clear_font_name_table): Move defun to macfns.c.
	(syms_of_mac): Likewise for defsubr.

	* macfns.c (mac_set_font): New function.
	(mac_frame_parm_handlers, syms_of_macfns): Replace x_set_font with it.
	(mac_window) [TARGET_API_MAC_CARBON && MAC_OSX]: Specify
	kWindowToolbarButtonAttribute when creating window.
	(Fmac_clear_font_name_table): Move from macfns.c.
	(syms_of_macfns): Likewise for defsubr.
	[USE_MAC_FONT_PANEL] (Fmac_set_font_panel_visibility): New defun.
	(syms_of_macfns) [USE_MAC_FONT_PANEL]: Defsubr it.

	* macgui.h (USE_MAC_FONT_PANEL): Define to 1 if USE_ATSUI is set
	and build is done on Mac OS X 10.2 and later.

	* macselect.c (mac_do_receive_drag): Remove unused variable `index'.
	(mac_store_services_event): Change return type in extern.

	* macterm.c (XLoadQueryFont) [USE_ATSUI]: Set font->mac_fontnum to
	FMFontFamily value.
	[USE_MAC_FONT_PANEL] (mac_set_font_info_for_selection): New function.
	(x_new_focus_frame) [USE_MAC_FONT_PANEL]: Use it.
	(QCfamily, QCweight, QCslant, Qnormal, Qbold, Qitalic): Add extern.
	(QWindow) [MAC_OSX]: Likewise.
	(Qfont) [USE_MAC_FONT_PANEL]: Likewise.
	(Vmac_atsu_font_table) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Defvar it.
	(Qtoolbar_switch_mode) [MAC_OSX]: New variable.
	(Qpanel_closed, Qselection) [USE_MAC_FONT_PANEL]: Likewise.
	(syms_of_macterm): Intern and staticpro them.
	(init_font_name_table) [USE_ATSUI]: Add data to Vmac_atsu_font_table.
	[TARGET_API_MAC_CARBON] (mac_store_event_ref_as_apple_event):
	New function.
	[USE_CARBON_EVENTS] (mac_handle_command_event): Use it.
	[MAC_OSX] (mac_store_services_event): Likewise.
	[USE_CARBON_EVENTS] (mac_handle_window_event) [MAC_OSX]: Handle
	kEventWindowToolbarSwitchMode event.
	(install_window_handler) [USE_CARBON_EVENTS && MAC_OSX]: Register it.
	[MAC_OSX] (mac_store_services_event): Change return type to OSStatus.
	[USE_MAC_FONT_PANEL] (mac_handle_font_event): New function.
	(install_window_handler) [USE_MAC_FONT_PANEL]: Install it.
	(XTread_socket): Select window on mouse click if x_focus_frame is NULL.

	* macterm.h (mac_set_font_info_for_selection): Add extern.

2006-05-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (Qduration) [MAC_OS]: New variable.
	(syms_of_image) [MAC_OS]: Intern and staticpro it.
	[MAC_OS] (gif_load): Save image extension data in img->data.lisp_val.
	[MAC_OSX] (image_load_quartz2d): Use cfstring_create_with_utf8_cstring
	instead of cfstring_create_with_string.

2006-05-06  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (xframe): Print frame name.
	(xlist): New command to print a list (max 10 elements).
	(xpr): Print lisp object of any type.
	(pitx): Print it->pixel_width.

2006-05-05  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_composition_prop): Fix for the case of empty
	composition component.

2006-05-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (make_lispy_event) [MAC_OS]: Get Apple event info
	from event->arg.

	* termhooks.h (enum event_kind) [MAC_OS]: Update comment for
	MAC_APPLE_EVENT.

	* macterm.h (mac_make_lispy_event_code): Remove extern.
	(mac_post_mouse_moved_event): Add extern.
	(mac_aelist_to_lisp, mac_aedesc_to_lisp): Change arg 1 to
	`const AEDesc *' in externs.
	(create_apple_event_from_drag_ref) [TARGET_API_MAC_CARBON]: New extern.

	* mac.c (mac_aelist_to_lisp, mac_aedesc_to_lisp): Change arg 1 to
	`const AEDesc *'.
	[TARGET_API_MAC_CARBON] (create_apple_event): New function.
	[TARGET_API_MAC_CARBON] (create_apple_event_from_event_ref): Use it.
	Use xrealloc instead of repeated xmalloc/xfree.
	[TARGET_API_MAC_CARBON] (create_apple_event_from_drag_ref):
	New function.

	* macmenu.c (restore_menu_items, cleanup_popup_menu): Return a value.

	* macselect.c: Update copyright year.
	(mac_store_apple_event): Change return type to void in extern.
	(mac_handle_apple_event): Don't get return value from
	mac_store_apple_event.
	[TARGET_API_MAC_CARBON] (Vmac_dnd_known_types): New variable.
	(syms_of_macselect) [TARGET_API_MAC_CARBON]: Defvar it.
	[TARGET_API_MAC_CARBON] (mac_do_track_drag): Move function from
	macterm.c.  Use Vmac_dnd_known_types as acceptable flavors.
	[TARGET_API_MAC_CARBON] (mac_do_receive_drag): Likewise.  New
	implementation using create_apple_event_from_drag_ref.
	[TARGET_API_MAC_CARBON] (mac_do_track_dragUPP)
	(mac_do_receive_dragUPP): Move variables from macterm.c.
	(install_drag_handler, remove_drag_handler): New functions.

	* macterm.c (XTread_socket) [TARGET_API_MAC_CARBON]: Try window
	path select also for proxy icon click.
	[TARGET_API_MAC_CARBON] (mac_post_mouse_moved_event): New function.
	[USE_TOOLKIT_SCROLL_BARS] (scroll_bar_timer_callback): Use it.
	(xlfdpat_create): Remove unused label `error' and trailing sentences.
	(mac_do_track_drag, mac_do_receive_drag): Move functions to macselect.c.
	(mac_do_track_dragUPP, mac_do_receive_dragUPP): Move variables to
	macselect.c.
	(install_drag_handler, remove_drag_handler): Add extern.
	(mac_store_apple_event): Change return type to void.  All uses changed.
	Create Lisp object from Apple event and store it into input event.
	(mac_make_lispy_event_code): Remove function.
	[TARGET_API_MAC_CARBON] (mac_store_drag_event): New function.
	(install_window_handler): Call install_drag_handler.
	(remove_window_handler): Call remove_drag_handler.

2006-05-03  Richard Stallman  <rms@gnu.org>

	* sound.c (Fplay_sound_internal): Dynamically allocate
	current_sound_device and current_sound.
	(sound_cleanup): Free them.

	* minibuf.c (read_minibuf): Don't use read_minibuf_noninteractive
	when inside a keyboard macro.

2006-05-02  Andreas Schwab  <schwab@suse.de>

	* xmenu.c (restore_menu_items): Return a value.

2006-05-01  Martin Rudalics  <rudalics@gmx.at>

	* syntax.c (Fforward_comment): Detect generic comment at beginning of
	buffer when moving backwards.

2006-05-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispnew.c (update_window): Don't set changed_p when mode/header
	line is updated.

	* xdisp.c (prepare_menu_bars) [MAC_OS]: Call mac_update_title_bar.
	(get_glyph_face_and_encoding, get_char_face_and_encoding):
	Don't distinguish known faces from others.

	* mac.c (mac_coerce_file_name_ptr): Try typeFSRef if coercion
	through typeFileURL failed.

	* macfns.c (mac_update_title_bar): New function.
	[TARGET_API_MAC_CARBON] (mac_update_proxy_icon): New function.
	(show_hourglass, hide_hourglass) [USE_CG_DRAWING]:
	Call mac_prepare_for_quickdraw.

	* macgui.h (USE_ATSUI): Set default to 1 if MAC_OSX is defined.
	(USE_CG_DRAWING): Don't define if compiled on Mac OS X 10.1.
	(enum pcm_status): New enum.
	(XCHARSTRUCTROW_CHAR_VALID_P, XCHARSTRUCTROW_SET_CHAR_VALID)
	(XCharStructRow): Remove.  Now validity is represented by
	non-negativeness of sum of ascent and descent.
	(struct MacFontStruct): Change type of member `rows'.
	(struct _XGC) [USE_CG_DRAWING]: Add member `clip_rects'.

	* macterm.c (mac_draw_line, mac_draw_line_to_pixmap):
	Adjust endpoints of strictly horizontal/vertical lines.
	(mac_set_clip_rectangles) [USE_CG_DRAWING]: Set clip_rects.
	(pcm_init, pcm_get_status): New functions.
	(x_per_char_metric, XLoadQueryFont): Use them instead of
	XCharStructRow and related macros.
	(x_draw_relief_rect): Don't adjust arguments of mac_draw_line.
	(x_free_frame_resources) [TARGET_API_MAC_CARBON]: Free FRAME_FILE_NAME.
	(XTread_socket) [TARGET_API_MAC_CARBON]: Handle proxy icon drag
	and window path pop-up menu on title bar.
	(mac_use_core_graphics) [USE_CG_DRAWING]: Set default to 1.

	* macterm.h (mac_update_title_bar): Add extern.
	(struct mac_output) [TARGET_API_MAC_CARBON]: New member `file_name'.
	(FRAME_FILE_NAME): New macro.

	* unexmacosx.c (unexec): Error if trying unexec from dumped executable.

2006-04-30  Richard Stallman  <rms@gnu.org>

	* keymap.c (Fdefine_key): Improve error message
	when KEY begins with a non-prefix key.

2006-04-30  Martin Rudalics  <rudalics@gmx.at>

	* syntax.c (Fforward_comment): Don't forget to break out of the loop
	when we skipped backward over a generic comment.

2006-04-27  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit (pp1, pv1): Only print value as expression is now
	printed out by gud-print.
	(pv1): Correct doc string.

2006-04-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (store_in_keymap): Change `def' arg to not be `register'.
	Seems to trigger a bug in gcc-amd64 4.0.2 20051125 (Red Hat 4.0.2-8):
	keymap.c:895: error: address of register variable `def' requested.

2006-04-26  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (construct_mouse_wheel): Handle negative coordinates.

	* w32fns.c (w32_wnd_proc) <WM_LBUTTONDOWN, WM_RBUTTONDOWN>:
	<WM_LBUTTONUP, WM_RBUTTONUP>: Call signal_user_input in the cases
	where we preempt mouse_button_timer.

2006-04-25  Miles Bader  <miles@gnu.org>

	* editfns.c (Ffield_beginning, find_field): Undo change of 2006-04-23.

2006-04-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.h: Include headers for pid_t.

2006-04-24  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (fill_stretch_glyph_string): Set s->nchars = 1 for code which
	does last_glyph=s->first_glyph+s->nchars-1, e.g. if stretch has relief.
	(produce_stretch_glyph): Assume that face box height and width is
	already included in stretch glyph size so caller doesn't have to
	consider the extra space otherwise added (fixes problem in ses.el).

	* frame.c (x_set_font): Clear f->n_tool_bar_rows and current frame
	matrices to force recalculation of tool-bar height after font change.

	* xdisp.c (tool_bar_lines_needed): New local `temp_row' for clarity.
	Clear it when done, so we don't accidentally draw a second copy of
	the tool-bar after resetting f->n_tool_bar_rows.
	(redisplay_tool_bar): Update tool-bar-lines frame parameter whenever
	we recalculate f->n_tool_bar_rows.

2006-04-23  Lars Hansen  <larsh@soem.dk>

	* editfns.c (find_field): Fix comment.
	(Ffield_beginning): Fix bug when POS is at field beginning.

2006-04-22  Eli Zaretskii  <eliz@gnu.org>

	* puresize.h (BASE_PURESIZE): Increase to 1205000.

2006-04-21  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Fix last change.  Don't recenter if
	window start is at BEGV.

	* dispextern.h (struct image): New member `corners'.
	(TOP_CORNER, LEFT_CORNER, BOT_CORNER, RIGHT_CORNER): New macros.

	* image.c (four_corners_best): New arg CORNERS specifies what pixels
	to look at in case image has margin.
	(x_create_bitmap_mask): Pass NULL for CORNERS to four_corners_best.
	(image_background, image_background_transparent)
	(x_build_heuristic_mask): Pass img->corners to four_corners_best.
	(gif_load): Set img->corners according to image's margin spec.
	Use img->corners values directly where applicable.
	Save image extension data in img->data.lisp_val.
	(gif_clear_image): New function to free img->data.lisp_val.
	(gif_type): Use it instead of generic x_clear_image.
	(Fimage_extension_data): New defun.
	(syms_of_image): Defsubr it.

2006-04-21  John Sullivan  <john@wjsullivan.net>  (tiny change)

	* window.c (Fdisplay_buffer): Doc fix.

2006-04-21  Eli Zaretskii  <eliz@gnu.org>

	* s/ms-w32.h (SYSTEM_PURESIZE_EXTRA): Increase to 25000.

2006-04-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (xpm_load_image): Fill in background field
	while we have ximg handy.

	* macmenu.c (restore_menu_items, save_menu_items): New functions
	from xmenu.c.
	(set_frame_menubar, digest_single_submenu): Apply 2006-04-18
	changes for xmenu.c.

	* macterm.c (x_per_char_metric): Return NULL if glyph width is 0.
	(add_mac_font_name): New function.
	(init_font_name_table): Use it.  Adopt the first found font from
	those having the same family name.

2006-04-21  Nick Roberts  <nickrob@snap.net.nz>

	* xdisp.c (note_mouse_highlight): Use build_string.

2006-04-20  Lars Hansen  <larsh@soem.dk>

	* textprop.c (Fremove_list_of_text_properties):
	Ensure modify_region is called only when buffer is modified and that
	signal_after_change is allways called in that case.

	* print.c (PRINTFINISH): Call signal_after_change.

2006-04-20  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Fix last change.

	* xdisp.c (redisplay_window): If current window start is not at the
	beginning of a line, select a new window start if buffer is modified
	and window start is in the modified region, but the first change is
	before window start.

2006-04-18  Richard Stallman  <rms@gnu.org>

	* xmenu.c (restore_menu_items, save_menu_items): New fns.
	(set_frame_menubar): Use save_menu_items.  Save updated vector in
	the frame before unwinding it.  Don't use unuse_menu_items.
	Don't use discard_menu_items.
	(digest_single_submenu): Abort if an item is not in a pane.
	(init_menu_items): Put the error check at the top.

	* keymap.c (describe_map): Make "shadowed" warning more verbose.

	* window.c (adjust_window_trailing_edge): Correctly distinguish
	series vs parallel cases, even when window has no parent.

	* abbrev.c (record_symbol): New function.
	(Finsert_abbrev_table_description): Sort the abbrevs alphabetically.

2006-04-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (x_create_bitmap_from_data) [MAC_OS]: Don't check return
	value of xmalloc.

	* mac.c (mac_coerce_file_name_ptr, mac_coerce_file_name_desc)
	(create_apple_event_from_event_ref, xrm_get_preference_database)
	(cfstring_create_normalized): Don't check return value of xmalloc.

	* macselect.c (get_scrap_target_type_list, defer_apple_events)
	(copy_scrap_flavor_data, mac_handle_service_event): Don't check
	return value of xmalloc/xrealloc.

	* macterm.c (XCreateGC, x_per_char_metric, xlfdpat_create)
	(init_font_name_table, init_font_name_table, mac_do_list_fonts)
	(XLoadQueryFont, mac_store_apple_event): Don't check return value
	of xmalloc.

2006-04-17  Kim F. Storm  <storm@cua.dk>

	* window.c (coordinates_in_window): On the vertical border,
	calculate the row number measured from the top of the window, not
	the top of the frame.
	(window_loop): Test w->dedicated with !NILP instead of EQ Qt.
	(window_scroll_pixel_based): Fix off-by-one bug in 2002-12-23 change.

2006-04-16  Eli Zaretskii  <eliz@gnu.org>

	* s/ms-w32.h (SYSTEM_PURESIZE_EXTRA): Reduce to 24000.

2006-04-16  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Decrement back to 1200000.

2006-04-16  Andreas Schwab  <schwab@suse.de>

	* puresize.h (PURESIZE_RATIO): Reduce to 10/6.

2006-04-15  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1210000.

2006-04-13  Michaël Cadilhac  <michael.cadilhac@lrde.org>

	* print.c (Fprin1_to_string): Mention in the `doc' that the
	behavior is modified by `print-level' and `print-length'.

2006-04-13  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): If eol-type is not yet decided
	and system_eol_type is not LF, set CODING_REQUIRE_ENCODING_MASK.
	If coding_system is nil, return 0.
	(code_convert_region1): Even if coding_system is nil, don't skip
	conversion if system_eol_type is not LF.
	(code_convert_string1): Likewise.
	(code_convert_string_norecord): Likewise.

2006-04-13  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): Fix previous change.
	(encode_coding): If eol_type is not yet decided, use system_eol_type.
	(shrink_encoding_region): If eol_type is not yet decided and
	system_eol_type is not LF, don't shrink.

2006-04-13  Nick Roberts  <nickrob@snap.net.nz>

	* xdisp.c (note_mouse_highlight): Add help echo for dragging vertical
	line.

2006-04-12  Richard Stallman  <rms@gnu.org>

	* keyboard.c (read_key_sequence): Explicitly avoid keybuf[-1].

	* process.c (conv_lisp_to_sockaddr): If FAMILY unknown, just return.
	(Fprocess_send_eof): Abort if fail to open null device.

2006-04-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* fns.c [HAVE_MENUS && MAC_OS]: Include macterm.h.

	* image.c [MAC_OS] (xpm_load_image): Add parentheses around
	assignment used as truth value.  Add explicit braces to avoid
	ambiguous `else'.
	[MAC_OS] (gif_load): Remove unused variable `gcpro1'.

	* lisp.h (syms_of_fontset, Fset_fontset_font): Put extern and
	EXFUN in #ifdef HAVE_WINDOW_SYSTEM.
	(syms_of_xfns, syms_of_xsmfns, syms_of_xselect, syms_of_xterm):
	Put externs in #ifdef HAVE_X_WINDOWS.
	(syms_of_macfns, syms_of_macselect, syms_of_macterm)
	(syms_of_macmenu, syms_of_mac) [MAC_OS]: Add externs.
	(init_mac_osx_environment) [MAC_OSX]: Add extern.

	* mac.c (init_process): Remove undef.
	(select) [MAC_OSX]: Undefine before including sysselect.h.
	(posix_pathname_to_fsspec, fsspec_to_posix_pathname) [MAC_OSX]:
	Remove functions and prototypes.
	(parse_value): Add parentheses around + inside shift.
	(path_from_vol_dir_name): Make static.
	(get_temp_dir_name): Remove unused variables `cpb' and `dir_name'.
	[!MAC_OSX] (get_path_to_system_folder): Likewise.
	(Fmac_get_file_creator, Fmac_get_file_type): Remove unused
	variable `cCode'.
	(Fmac_coerce_ae_data): Remove unused variables `fref' and `fs'.
	(Fmac_get_preference): Add explicit braces to avoid ambiguous `else'.

	* macfns.c (x_to_mac_color): Remove unused variable `tail'.
	(x_set_mouse_color): Remove unused variable `dpy'.
	(Fx_create_frame): Remove unused variable `x_frame_count'.
	(Fx_server_version): Add explicit braces to avoid ambiguous `else'.
	(x_sync): Move from macterm.c.
	(Fx_file_dialog): Remove unused variable `default_filter_index'.

	* macmenu.c (min_menu_id): Make element type explicit.

	* macselect.c (get_flavor_type_from_symbol): Remove unused
	variable `val'.
	(get_scrap_private_timestamp, x_get_foreign_selection)
	(copy_scrap_flavor_data): Add explicit braces to avoid ambiguous `else'.
	(Fmac_process_deferred_apple_events): Remove unused variables
	`keyword', `reply', `apple_event', `count', and `err'.

	* macterm.c: Don't include gnu.h.
	(x_io_error_quitter, x_draw_image_foreground_1): Remove prototypes.
	(x_sync): Move to macfns.c.
	[USE_CG_DRAWING] (mac_define_fringe_bitmap): Remove unused
	variable `mask_bits'.
	(mac_compute_glyph_string_overhangs): Avoid ambiguous `else'.
	(x_draw_image_glyph_string): Remove unused variable `pixmap'.
	(x_mac_to_emacs_modifiers): Remove function.
	(XTset_vertical_scroll_bar, mac_handle_visibility_change)
	(x_make_frame_visible, xlfdpat_create, mac_handle_command_event):
	Add explicit braces to avoid ambiguous `else'.
	(x_make_frame_visible): Remove unused variables `type',
	`original_top', and `original_left'.
	(mac_do_list_fonts, XTread_socket): Add parentheses around && within ||.
	(x_load_font): Remove unused variables `full_name', and `value'.
	(do_get_menus, do_init_managers, do_check_ram_size) [!MAC_OS8]:
	Remove functions.
	(do_zoom_window): Reorganize variables with respect to conditionals.
	(init_command_handler): Remove unused variable `err'.
	[MAC_OSX] (mac_check_bundle): Remove unused variable `child'.

	* macterm.h (x_set_mouse_position, x_set_mouse_pixel_position)
	(x_make_frame_invisible, x_iconify_frame, x_free_frame_resources)
	(x_destroy_window, x_wm_set_size_hint, x_delete_display, XFreeGC)
	(do_menu_choice, have_menus_p, x_real_positions)
	(x_set_menu_bar_lines, x_pixel_width, x_pixel_height, x_char_width)
	(x_char_height, x_sync, x_set_tool_bar_lines, x_activate_menubar)
	(free_frame_menubar): Add externs.

	* unexmacosx.c: Include config.h before using HAVE_MALLOC_MALLOC_H.
	(malloc, realloc, free): Add undefs.
	(read_load_commands): Remove unused variable `n' and `j'.
	(copy_data_segment): Remove unused variable `r'.

	* xdisp.c (get_glyph_string_clip_rects): Add parentheses around &&
	within ||.  Add explicit braces to avoid ambiguous `else'.
	(dump_glyph_row): Remove label for `inverse_p' from legend.

	* xfaces.c (Finternal_merge_in_global_face, try_font_list):
	Add explicit braces to avoid ambiguous `else'.

2006-04-11  Michaël Cadilhac  <michael.cadilhac@lrde.org>

	* dispnew.c (init_display): Don't init X display if the user asked
	for a non-X display.

2006-04-12  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): Use system_eol_type for default
	coding->eol_type.

2006-04-11  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (wrong_type_argument): Mark as NO_RETURN.

	* data.c (wrong_type_argument): Try to avoid compiler warnings due
	to the fact the function is now marked as NO_RETURN.

2006-04-10  Eli Zaretskii  <eliz@gnu.org>

	* s/ms-w32.h (pid_t) [_MSC_VER]: New typedef.

2006-04-10  Romain Francoise  <romain@orebokech.com>

	* xrdb.c (gethomedir): Use xstrdup.

2006-04-10  Andreas Schwab  <schwab@suse.de>

	* xrdb.c (gethomedir): Make sure to always return a pointer that
	can be passed to free.

2006-04-09  Richard Stallman  <rms@gnu.org>

	* lisp.h (Fkill_emacs): Undo previous change.

2006-04-08  Richard Stallman  <rms@gnu.org>

	* search.c (boyer_moore): Test ch >= 0400, not >.

2006-04-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* puresize.h (pure_write_error): Mark as NO_RETURN.

	* lisp.h (args_out_of_range, args_out_of_range_3, Fkill_emacs):
	Likewise.

2006-04-08  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_wnd_proc) <WM_MOUSEMOVE>: Ignore mouse movements
	if a menu is active on this frame.

2006-04-08  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (report_file_error): Mark as NO_RETURN.

2006-04-08  Eli Zaretskii  <eliz@gnu.org>

	* alloc.c [STDC_HEADERS]: Include stddef.h.

	* lisp.h (PSEUDOVECSIZE): Fix last change.

2006-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.h (struct Lisp_Process): Replace Lisp_Objects `pid',
	`raw_status_high', and `raw_status_low' with plain integers, and move
	them to the end of the structure.

	* alloc.c (allocate_process): Use PSEUDOVECSIZE to initialize the
	pseudovector's size field so only the Lisp_Object fields get GC'd.

	* process.c (update_status, make_process, Fdelete_process)
	(Fprocess_status, list_processes_1, start_process_unwind)
	(create_process, Fmake_network_process, server_accept_connection)
	(wait_reading_process_output, send_process, Fprocess_running_child_p)
	(process_send_signal, proc_encode_coding_system, Fprocess_send_eof)
	(sigchld_handler, status_notify): Adjust to new non-Lisp fields for
	`pid' and `raw_status'.
	(Fprocess_id, Fsignal_process): Same, and additionally use floats when
	representing PIDs that are larger than most-positive-fixnum.

	* keymap.c (describe_map): Only use XINT if we checked INTEGERP.

	* lisp.h (OFFSETOF, PSEUDOVECSIZE): New macros.

2006-04-08  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (Fx_show_tip): Add 3 to the 5th arg of SetWindowPos.

2006-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	* editfns.c (TM_YEAR_IN_ASCTIME_RANGE): New macro, identical to
	../lib-src/b2m.c and ../lib-src/editfns.c.
	(Fcurrent_time_string): Use it.
	Document that the year might not consume 4 columns if it's outside
	the range 1000-9999.
	Check for asctime failure.
	Don't assume that the output string length is always exactly 24.

2006-04-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XTread_socket): Initialize variable `f' before its use.

2006-04-03  Kenichi Handa  <handa@m17n.org>

	* image.c: Include "charset.h" and "coding.h".
	(x_find_image_file): Return an encoded file name.

2006-04-01  Eli Zaretskii  <eliz@gnu.org>

	* configure: Regenerated.

2006-03-31  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xg_set_icon): Delete superfluous UNGCPRO.

2006-03-30  Dan Nicolaescu  <dann@ics.uci.edu>

	* xdisp.c (syms_of_xdisp): Fix variable name.

2006-03-30  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_term_init): Delete superfluous UNGCPRO.

2006-03-29  Juanma Barranquero  <lekktu@gmail.com>

	* keyboard.c (process_tool_bar_item): Reorder dummy args.

2006-03-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (tool_bar_items): Use map_keymap.
	(process_tool_bar_item): Add dummy args to fit the required interface.

2006-03-25  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit (pr, pp, pp1, pv, pv1): Force print_output_debug_flag
	to zero before calling debug_print or safe_debug_print.

	* print.c (print_output_debug_flag): New global variable.
	(Fexternal_debugging_output) [WINDOWSNT]: Don't call
	OutputDebugString if print_output_debug_flag is zero.

2006-03-24  Paul Eggert  <eggert@cs.ucla.edu>

	* editfns.c (TM_YEAR_BASE): Move up, so the changes below can use it.
	(Fdecode_time, Fencode_time): Use TM_YEAR_BASE instead of 1900.
	(Fdecode_time): Cast tm_year to EMACS_INT.
	(Fcurrent_time_string): Report an invalid time specification if
	the argument is invalid.  Also, check for out-of-range time stamps.

2006-03-24  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent):
	* w32term.c (w32_read_socket):
	* macterm.c (XTread_socket): Don't let key-press clear mouse face
	on in toolbar window if mouse-highlight is an integer.

	* fns.c (sxhash_list): Include last non-nil CDR in hash.

2006-03-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (enum mac_menu_kind): New enum.
	(min_menu_id): New variable.
	(POPUP_SUBMENU_ID, MIN_POPUP_SUBMENU_ID, MIN_MENU_ID)
	(MIN_SUBMENU_ID): Remove defines.  All uses are replaced with
	min_menu_id and enumerators in enum mac_menu_kind.
	(fill_menu, dispose_menus, install_menu_quit_handler): New arg KIND.
	All uses changed.  Add range check for menu ID.
	(fill_menubar): Add range check for menu ID.
	[HAVE_CANCELMENUTRACKING] (menu_quit_handler): Check error code of
	GetEventParameter.
	(set_frame_menubar, mac_menu_show): Call install_menu_quit_handler
	for each menu kind.

2006-03-22  Kim F. Storm  <storm@cua.dk>

	* xdisp.c: Undo 2006-03-21 change.

	* term.c: Define aliases for append_glyph and produce_stretch_glyph
	when `static' is defined to avoid name clash with those in xdisp.c.

	* process.c (Faccept_process_output): Fix to comply with lisp
	reference.  Change arg "timeout" to "seconds" and allow both
	integer and float value.  Change arg "timeout-msec" to "millisec"
	and interpret" as milliseconds rather than microseconds.  Fix doc
	string accordingly.

2006-03-21  Ken Raeburn  <raeburn@raeburn.org>

	* xdisp.c (store_next_glyph): Rename from append_glyph.
	(generate_stretch_glyph): Rename from produce_stretch_glyph.
	All callers changed accordingly.

2006-03-21  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c: x_session_initialized new variable.
	(x_term_init): Use x_session_initialized to check if
	x_session_initialize should be called.
	(x_initialize): Initialize x_session_initialized.

2006-03-21  Kim F. Storm  <storm@cua.dk>

	* fringe.c (draw_fringe_bitmap): Don't calculate default overlay arrow
	bitmap here, but ...
	(update_window_fringes): ... here, so we can test if it has changed.

2006-03-20  Andreas Schwab  <schwab@suse.de>

	* dispnew.c (init_display): Check DISPLAY here.

	* emacs.c (main): Don't check here.

	* xterm.c (x_display_ok): Don't use DISPLAY env var.

2006-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (window_scroll_pixel_based): Yet another int/Lisp_Object
	mixup (YAILOM).

2006-03-20  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (main): Fix last change.

2006-03-20  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Fwrite_region): Set visit_file to Qnil before GCPRO it.

	* keymap.c (map_keymap): Set tail to Qnil before GCPRO it.

	* xfns.c (xg_set_icon): Remove unnecessary GCPRO.

	* xterm.c (x_term_init): Remove unnecessary GCPRO.

2006-03-19  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): Fix cursor property on overlay string,
	so it doesn't associate overlay string with following glyph by default.
	Allow integer property value to specify explicit number of buffer
	positions associate with overlay string.

2006-03-18  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (x_display_ok): Fix minor bug and compilation warnings.

2006-03-18  Nozomu Ando  <nand@mac.com>

	* m/pmax.h (BROKEN_NOCOMBRELOC) [__NetBSD__]: Define.
	(LIB_STANDARD, START_FILES) [__NetBSD__]: Don't define.
	(START_FILES, RUN_TIME_REMAP, UNEXEC) [__NetBSD__, __OpenBSD__]:
	Don't redefine.

	* m/mips.h: Don't use unexmips on NetBSD.
	(LIBS_MACHINE): Move definition lower, so it doesn't use
	LD_SWITCH_MACHINE, START_FILES, LIB_STANDARD, LIBS_TERMCAP,
	C_SWITCH_MACHINE, and C_DEBUG_SWITCH.

	* unexelf.c [BROKEN_NOCOMBRELOC]: Include assert.h.
	(unexec) [BROKEN_NOCOMBRELOC]: Handle platforms whose nocombreloc
	option is broken (e.g., MIPS/NetBSD).

2006-03-18  Craig McDaniel  <craigmcd@gmail.com>  (tiny change)

	* sheap.c (STATIC_HEAP_SIZE): Enlarge STATIC_HEAP_SIZE to 12MB.
	Remove the HAVE_X_WINDOWS conditional.

2006-03-18  Vivek Dasmohapatra  <vivek@etla.org>  (tiny change)

	* emacs.c (main): If user asks for a display that is unavailable,
	simulate -nw.

	* xterm.c (x_display_ok): New function.

	* xterm.h: Add prototype for x_display_ok.

2006-03-18  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (Fw32_select_font): Doc fix.

2006-03-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (XPutPixel, XGetPixel)
	[!WORDS_BIG_ENDIAN && USE_CG_DRAWING]: Don't use specialized
	version when depth is 32.
	(mac_create_cg_image_from_image) [MAC_OS && USE_CG_DRAWING]:
	New function.
	(prepare_image_for_display) [MAC_OS && USE_CG_DRAWING]: Use it.
	(x_clear_image_1) [MAC_OS && USE_CG_DRAWING]: Release CGImage.

	* macterm.c (XCreatePixmap) [!WORDS_BIG_ENDIAN && USE_CG_DRAWING]:
	Create GWorld in ARGB pixel format.
	(mac_copy_area, mac_copy_area_with_mask) [USE_CG_DRAWING]:
	Remove functions.
	(x_draw_image_foreground) [USE_CG_DRAWING]: Use mac_draw_cg_image
	instead of mac_copy_area/mac_copy_area_with_mask.

2006-03-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (extend_face_to_end_of_line): Always add space glyph to
	empty row.  Fixes memory corruption revealed by 2006-03-02 change.
	(display_tool_bar_line): Skip empty tool-bar line if HEIGHT < 0.
	(tool_bar_lines_needed): Fix tool-bar display in case the tool-bar
	width is exactly the same as the window width.  Don't count a final
	empty tool-bar line (pass HEIGHT = -1 to display_tool_bar_line).

2006-03-15  Juanma Barranquero  <lekktu@gmail.com>

	* fringe.c (w32_init_fringe, w32_reset_fringes): Revert to being
	conditional on HAVE_NTGUI, not WINDOWS_NT.

2006-03-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h (mac_init_fringe) [MAC_OS]: Add prototype.

	* fringe.c (mac_init_fringe) [MAC_OS]: New function.

	* macterm.c (mac_initialize) [USE_CG_DRAWING]: Call mac_init_fringe.
	(max_fringe_bmp, fringe_bmp) [USE_CG_DRAWING]: New variables.
	(mac_define_fringe_bitmap, mac_destroy_fringe_bitmap)
	(mac_draw_cg_image) [USE_CG_DRAWING]: New functions.
	(mac_draw_bitmap) [USE_CG_DRAWING]: Remove function.
	(x_draw_fringe_bitmap) [USE_CG_DRAWING]: Use mac_draw_cg_image
	instead of mac_draw_bitmap.
	(x_redisplay_interface) [USE_CG_DRAWING]: Set handlers for
	define_fringe_bitmap and destroy_fringe_bitmap.

2006-03-14  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (x_uncatch_errors): Block input for entire function.

2006-03-12  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_create_frame): Remove call to
	Qface_set_after_frame_default (from xfns.c 2003-05-26).

	* w32menu.c (Fx_popup_menu): Call w32_free_menu_strings when
	finished with the menu.

	* w32term.c: Sync 2005-10-24 xterm.c changes.
	(last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(w32_mouse_position): Set last_mouse_glyph_frame.
	Remove OLD_REDISPLAY_CODE block.

2006-03-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h [USE_ATSUI && MAC_OSX]: Define USE_CG_TEXT_DRAWING to 1.

	* macterm.h (struct mac_output) [USE_CG_DRAWING]: New member cg_context.
	(mac_prepare_for_quickdraw) [USE_CG_DRAWING]: Add prototype.

	* mac.c (sys_select) [USE_CG_DRAWING]: Call mac_prepare_for_quickdraw.

	* macfns.c (x_create_tip_frame): Apply 2006-03-11 change for xfns.c.

	* macterm.c (mac_draw_rectangle, x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground)
	(x_draw_image_foreground): Undo previous changes.
	(x_draw_hollow_cursor): Likewise.  Subtract 1 from the last
	argument of mac_draw_rectangle.
	(CG_SET_FILL_COLOR, CG_SET_STROKE_COLOR): New macros.
	(mac_draw_string_common, mac_draw_image_string_cg): Use them.
	(FRAME_CG_CONTEXT) [USE_CG_DRAWING]: New macro.
	(mac_begin_cg_clip, mac_end_cg_clip, mac_prepare_for_quickdraw)
	[USE_CG_DRAWING]: New functions.
	(mac_draw_line, mac_erase_rectangle, mac_clear_window)
	(mac_fill_rectangle, mac_draw_rectangle, mac_draw_string_common)
	(mac_draw_image_string_cg) [USE_CG_DRAWING]: Add Quartz 2D drawing part.
	(mac_draw_bitmap, mac_invert_rectangle, mac_draw_string_common)
	(mac_copy_area, mac_scroll_area, x_scroll_bar_create)
	(x_scroll_bar_remove, XTset_vertical_scroll_bar, x_set_window_size)
	(XTread_socket) [USE_CG_DRAWING]: Call mac_prepare_for_quickdraw.

2006-03-12  Lőrentey Károly  <lorentey@elte.hu>

	* xfns.c (x_icon): Disable redundant call to `x_wm_set_window_state'.

2006-03-11  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (signal_user_input): New function.
	(post_character_message): Use it for keyboard input.
	(w32_msg_pump): Use it for mouse input.

2006-03-11  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c: Rename preserve_y to window_scroll_pixel_based_preserve_y.
	(window_scroll_pixel_based, syms_of_window): Adapt to above change.

2006-03-11  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_wnd_proc): Ignore middle and extra button events
	if a menu is already active (the menubar_active flag is on).

2006-03-11  David Ponce  <david@dponce.com>

	* xfns.c (x_create_tip_frame): Preserve received parms by copying them.

2006-03-11  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c: Add x_fully_uncatch_errors and x_catching_errors to
	the list of unused display error handling functions.

	* eval.c (unwind_to_catch): Call x_fully_uncatch_errors only if
	HAVE_X_WINDOWS.
	(internal_condition_case, internal_condition_case_1)
	(internal_condition_case_2): Call x_catching_errors only if
	HAVE_X_WINDOWS.

	* vm-limit.c [HAVE_GETRLIMIT]: Don't define unconditionally.
	Don't include sys/resource.h unless defined.

2006-03-11  Richard Stallman  <rms@gnu.org>

	* keymap.c (describe_map): Shorten string to indicate shadowed binding.

	* vm-limit.c (get_lim_data, lim_data, data_space_start):
	Move from mem-limits.h.
	(enum warnlevel): New data type.
	(check_memory_limits): Rewrite the logic about warnings.
	Use standard `struct rlimit'.  Check return values for nonsense.
	(memory_warnings): Always clear lim_data.

	* mem-limits.h (get_lim_data, lim_data, data_space_start):
	Move to vm-limit.c.

	* xterm.c (x_fully_uncatch_errors, x_catching_errors): New functions.

	* eval.c (unwind_to_catch): Call x_fully_uncatch_errors.
	(internal_condition_case_1, internal_condition_case_2):
	Abort if within unclosed x_catch_errors.

2006-03-11  Romain Francoise  <romain@orebokech.com>

	* process.c (Vprocess_adaptive_read_buffering): Doc fix.

2006-03-11  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* lisp.h: Remove duplicate prototypes.  Make the prototype of
	getloadavg be conditioned on HAVE_GETLOADAVG being undefined.

2006-03-11  Eli Zaretskii  <eliz@gnu.org>

	* xterm.c (x_draw_hollow_cursor): Subtract 1 from the last
	argument of XDrawRectangle.

	* xdisp.c (get_phys_cursor_geometry): Don't decrease height by 1.

	* macterm.c (mac_draw_rectangle): Don't add 1 to width and height.
	(x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground)
	(x_draw_image_foreground): Don't subtract 1 from width and height
	arguments to mac_draw_rectangle.
	(x_draw_hollow_cursor): Add 1 to w->phys_cursor_width.

2006-03-10  Kim F. Storm  <storm@cua.dk>

	* alloc.c (USE_POSIX_MEMALIGN): Fix last change.

2006-03-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (USE_POSIX_MEMALIGN): New macro.
	(ABLOCKS_BASE, lisp_align_malloc, lisp_align_free): Use it.

2006-03-09  Kenichi Handa  <handa@m17n.org>

	* coding.c (DECODE_EMACS_MULE_COMPOSITION_CHAR): Fix decoding
	ASCII component of a composition.

2006-03-08  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c: Declare preserve_y as a static global variable.
	(window_scroll_pixel_based): No longer declare preserve_y;
	it is global now.
	(syms_of_window): Set preserve_y to -1.

2006-03-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (XPutPixel): Set alpha channel bits if pixmap
	depth is 32.
	[MAC_OS] (XGetPixel): Strip off alpha channel bits if pixmap
	depth is 32.

2006-03-06  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (handle_invisible_prop): Don't update it->position with
	a buffer position if we're in a display string.

2006-03-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.h (MAC_AQUA_VERTICAL_SCROLL_BAR_WIDTH)
	(MAC_AQUA_SMALL_VERTICAL_SCROLL_BAR_WIDTH): New defines.

	* macfns.c (x_default_scroll_bar_color_parameter)
	(x_set_scroll_bar_foreground, x_set_scroll_bar_background):
	Remove unnecessary prototypes.
	(x_set_scroll_bar_default_width):
	Use MAC_AQUA_VERTICAL_SCROLL_BAR_WIDTH.
	(mac_set_scroll_bar_width): New function.
	(mac_frame_parm_handlers): Set it as handler for scroll-bar-width.

	* macterm.c (get_control_part_bounds): Fix type of return value.
	(x_set_toolkit_scroll_bar_thumb, x_scroll_bar_create)
	(XTset_vertical_scroll_bar) [USE_TOOLKIT_SCROLL_BARS]: Don't show
	scroll bar if it is not tall enough to display scroll bar thumb.
	[USE_CARBON_EVENTS] (mac_convert_event_ref)
	(mac_handle_command_event, mac_handle_window_event)
	(mac_handle_mouse_event): Check error code of GetEventParameter.
	(convert_fn_keycode) [MAC_OSX]: Likewise.

2006-03-05  Andreas Schwab  <schwab@suse.de>

	* xselect.c (x_catch_errors_unwind): Fix missing return value.

2006-03-02  Kim F. Storm  <storm@cua.dk>

	* frame.h (struct frame): New member n_tool_bar_rows.

	* xdisp.c: Minimize the unpleasent visual impact of the requirement
	that non-toolkit tool-bars must occupy an integral number of screen
	lines, by distributing the rows evenly over the tool-bar screen area.
	(Vtool_bar_border): New variable.
	(syms_of_xdisp): DEFVAR_LISP it.
	(display_tool_bar_line): Add HEIGHT arg for desired row height.
	Make tool-bar row the desired height.  Use default face for border
	below tool-bar.
	(tool_bar_lines_needed): Add N_ROWS arg.  Use it to return number of
	actual tool-bar rows.
	(redisplay_tool_bar): Calculate f->n_tool_bar_rows initially.
	Adjust the height of the tool-bar rows to fill tool-bar screen area.
	(redisplay_tool_bar): Calculate f->n_tool_bar_rows when tool-bar area
	is resized.

2006-03-01  Luc Teirlinck  <teirllm@auburn.edu>

	* search.c (Fregexp_quote): Do not precede a literal `]' with two
	backslashes to try to make clear that it has a literal meaning; it
	does not do that.  (It could close a character alternative
	containing a backslash.)

2006-02-28  Chong Yidong  <cyd@stupidchicken.com>

	* xselect.c (x_catch_errors_unwind): New function.
	(x_reply_selection_request): Put x_uncatch_errors in an unwind.
	(Fx_get_atom_name): Call x_uncatch_errors earlier.

	* window.c (Qscroll_up, Qscroll_down): New syms.
	(window_scroll_pixel_based): Make preserve_y static to avoid
	getting point stuck when scrolling 1 line.

2006-02-26  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.h, xterm.c (x_uncatch_errors): Delete unneccessary argument.

	* xterm.c (x_load_font, x_term_init, XTmouse_position)
	(handle_one_xevent, x_connection_closed, x_list_fonts):
	No arg for x_uncatch_errors.

	* xselect.c (x_own_selection, x_decline_selection_request)
	(x_reply_selection_request, x_get_foreign_selection)
	(Fx_get_atom_name, Fx_send_client_event): Likewise.

	* xfns.c (x_real_positions, x_set_mouse_color, Fx_focus_frame):
	Likewise.

2006-02-26  Luc Teirlinck  <teirllm@auburn.edu>

	* lread.c: Declare Vload_file_rep_suffixes instead of
	deleted variable default_suffixes.
	(Fget_load_suffixes): New function.
	(Fload): Use Fget_load_suffixes and Vload_file_rep_suffixes.
	No longer use deleted variable default_suffixes.  Update docstring.
	(syms_of_lread): defsubr Sget_load_suffixes.
	Expand `load-suffixes' docstring.
	Delete default_suffixes and DEFVAR_LISP the new variable
	`load-file-rep-suffixes'.

	* w32.c (check_windows_init_file): Use Fget_load_suffixes instead
	of Vload_suffixes.

	* lisp.h: EXFUN Fget_load_suffixes.
	Extern Vload_file_rep_suffixes.

	* eval.c (specpdl_ptr): Remove volatile qualifier for consistency
	with lisp.h.

2006-02-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (struct specbinding, specpdl_ptr): Remove the volatile
	qualifier which was trying to avoid the bug that was fixed by
	yesterday's changes to xterm.c.

2006-02-25  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.h (x_catch_errors) Return value changed to void.
	(x_uncatch_errors): Delete unused count argument.

	* xterm.c (x_catch_errors): Don't use record_unwind_protect, since
	it can be called in a signal handler.
	(x_catch_errors_unwind): Function deleted.
	(x_uncatch_errors): Deallocate last x_error_message_stack struct.
	(x_check_errors): Call x_uncatch_errors before signalling error.

	(x_load_font, x_term_init, XTmouse_position, handle_one_xevent)
	(x_connection_closed, x_list_fonts): Use new versions of
	x_catch_errors and x_uncatch_errors.

	* xselect.c (x_own_selection, x_decline_selection_request)
	(x_reply_selection_request, x_get_foreign_selection)
	(Fx_get_atom_name, Fx_send_client_event): Likewise.

	* xfns.c (x_real_positions, x_set_mouse_color, Fx_focus_frame):
	Likewise.

	* eval.c (record_unwind_protect): Add an assertion.

2006-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Fmake_network_process): Init the process's mark.

2006-02-25  Kim F. Storm  <storm@cua.dk>

	* buffer.c (modify_overlay): Force redisplay if we modify an
	overlay at the end of the buffer.

2006-02-24  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_image_for_pixmap): If x_find_image_file returns
	nil the image file has been removed, in that case use the (cached)
	pixmap.

2006-02-24  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): When a text is replaced
	partially, be sure to set point before the inserted characters.

2006-02-23  Zhang Wei  <id.brep@gmail.com>  (tiny change)

	* xfns.c (Fx_file_dialog): Return a decoded file name.

2006-02-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispnew.c (update_text_area): Avoid needless redraw of rightmost
	glyph whose face is extended to the text area end.

	* macterm.c (x_set_toolkit_scroll_bar_thumb): Don't set control
	values if control is not visible or values are not changed.

2006-02-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fwindow_list): Check `window' before doing XWINDOW.
	The default `window' should not be "on a different frame".

2006-02-22  Kim F. Storm  <storm@cua.dk>

	* indent.c (Fvertical_motion): Only try to move back if we can.

2006-02-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (struct _XGC) [!MAC_OSX || !USE_ATSUI]: New member
	n_clip_rects.

	* macmenu.c (digest_single_submenu): Apply 2006-02-19 change for
	xmenu.c.

	* macterm.c (GC_CLIP_REGION): Remove macro.
	(mac_begin_clip, mac_end_clip): Take arg GC instead of REGION.
	All uses changed.  Don't do clipping if n_clip_rects is zero.
	(mac_set_clip_rectangles): Use xassert instead of abort.
	Set n_clip_rects.  Don't make clip_region empty when number of
	clipping rectangles is zero.
	(mac_reset_clip_rectangles): Set n_clip_rects directly instead of
	calling mac_set_clip_rectangles.
	(x_set_toolkit_scroll_bar_thumb): Temporarily hide scroll bar to
	avoid multiple redraws.

2006-02-22  Kim F. Storm  <storm@cua.dk>

	* fringe.c (draw_fringe_bitmap): Fix overlay-arrow display.

2006-02-21  Kim F. Storm  <storm@cua.dk>

	* fringe.c (syms_of_fringe) <fringe-bitmaps>: Doc fix.

2006-02-21  Zhang Wei  <brep@newsmth.org>

	* xfns.c (Fx_file_dialog, Motif and GTK): DECODE_FILE before
	returning it.

2006-02-21  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* fringe.c (horizontal_bar_bits): Rename from `horisontal_bar_bits'.
	(standard_bitmaps): Use it.

2006-02-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_draw_string_common): Remove arg MODE.  New arg
	BG_WIDTH.  All uses changed.  Draw background if BG_WIDTH is not zero.
	(mac_draw_image_string, mac_draw_image_string_16): New arg BG_WIDTH.
	[USE_CG_TEXT_DRAWING] (mac_draw_image_string_cg): Rename from
	mac_draw_string_cg.  New arg BG_WIDTH.  All uses changed.
	Draw background if BG_WIDTH is not zero.  Use float constants as
	divisors instead of double.  Use alloca instead of xmalloc/xfree.
	(x_draw_glyph_string_background, x_draw_glyph_string_foreground)
	[!MAC_OS8 || USE_ATSUI]: Background may be drawn using
	mac_draw_image_string* functions.
	(XLoadQueryFont) [MAC_OS8 && USE_ATSUI]: Don't adjust heights of
	some fonts when srcCopy text transfer mode might be used.
	(mac_begin_clip, mac_end_clip): Check if region is empty.
	(mac_set_clip_rectangles): When resetting clip region, make it
	empty instead of disposing of it.

2006-02-20  Kim F. Storm  <storm@cua.dk>

	* Makefile.in: Add fringe.elc to WINDOW_SUPPORT.

	* buffer.h (struct buffer): New members fringe_indicator_alist and
	fringe_cursor_alist.

	* buffer.c (init_buffer_once): Set dummy default values for
	fringe-indicator-alist and fringe-cursor-alist.  The proper
	default values are set by pre-loading fringe.el.
	(syms_of_buffer): defvar_per_buffer new fringe-indicator-alist and
	fringe-cursor-alist buffer-local variables and defvar_lisp_nopro
	corresponding default- variables.

	* fringe.c (enum fringe_bitmap_type): Remove.  Change all uses
	to use `int'.
	(NO_FRINGE_BITMAP, UNDEF_FRINGE_BITMAP, MAX_STANDARD_FRINGE_BITMAPS):
	Define explicitly.
	(Qtruncation, Qcontinuation, Qempty_line, Qtop_bottom)
	(Qhollow_small): New variables.
	(syms_of_fringe): Intern and staticpro them.
	(question_mark_bits): Rename from unknown_bits.
	(left_curly_arrow_bits): Rename from continuation_bits.
	(right_curly_arrow_bits): Rename from continued_bits.
	(left_triangle_bits): Rename from ov_bits.
	(right_triangle_bits): Add.
	(filled_rectangle_bits): Rename from filled_box_cursor_bits.
	(hollow_rectangle_bits): Rename from hollow_box_cursor_bits.
	(filled_square_bits): Add.
	(vertical_bar_bits): Rename from bar_cursor_bits.
	(horizontal_bar_bits): Rename from hbar_cursor_bits.
	(empty_line_bits): Rename from zv_bits.
	(standard_bitmaps): Update to use new names.
	(draw_fringe_bitmap_1): Make static.
	(get_logical_cursor_bitmap, get_logical_fringe_bitmap): New functions
	to map from logical cursors and indicators to physical bitmaps.
	(draw_fringe_bitmap): Resolve fringe cursor and overlay-arrow
	bitmaps using symbol names instead of bitmap numbers.
	(update_window_fringes): Use logical indicator symbol names
	instead of bitmap numbers for logical.  Add bitmap cache.
	(LEFT_FRINGE, RIGHT_FRINGE): New helper macros.

2006-02-20  Chong Yidong  <cyd@stupidchicken.com>

	* regex.c: Revert 2006-02-19 change.
	(xmalloc, xrealloc): Define these when not linked to Emacs.
	Redefine malloc -> xmalloc, realloc -> xrealloc as in Emacs case.

2006-02-19  Luc Teirlinck  <teirllm@auburn.edu>

	* regex.c (extend_range_table_work_area): Fix typo.

2006-02-19  Richard M. Stallman  <rms@gnu.org>

	* xterm.c (x_catch_errors): Use xmalloc.

	* regex.c (extend_range_table_work_area): Call xmalloc and xrealloc.
	(regex_compile): Likewise.
	(regcomp): Use xmalloc.

	* gtkutil.c (malloc_widget_value): Use xmalloc.

	* vm-limit.c [HAVE_GETRLIMIT]: Include sys/resource.h.
	(check_memory_limits) [HAVE_GETRLIMIT]: Use getrlimit.

	* xmenu.c (digest_single_submenu): When pane_string is empty,
	do initialize save_wv.

2006-02-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (update_menu_bar) [MAC_OS]: Don't set
	w->update_mode_line if arg F is not the selected frame.

	* macmenu.c (popup_activated_flag, submenu_id)
	(next_menubar_widget_id): Remove variables.
	(initialize_frame_menubar): Remove function.
	(pop_down_menu, mac_menu_show): Simplify save value.
	(dispose_menus): New function.
	(pop_down_menu, fill_menubar): Use it.
	(fill_submenu): Remove function.  All uses changed to fill_menu.
	(add_menu_item): Remove args SUBMENU and FORCE_DISABLE.  New arg
	POS.  Don't call SetMenuItemHierarchicalID here.
	(fill_menu): Add arg SUBMENU_ID.  Return submenu_id that is to be
	used next.  Call SetMenuItemHierarchicalID here.
	(fill_menubar): Add arg DEEP_P.  All uses changed.  Clean up menu
	objects if needed.  Reuse existing menu bar titles if possible.
	(set_frame_menubar): Don't clean up menu objects here.

2006-02-18  Chong Yidong  <cyd@stupidchicken.com>

	* window.c (window_min_size_1): Ensure room for the scroll bar and
	fringes.

2006-02-17  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1200000.

2006-02-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (Fmake_symbol): Comment-out left-over assert from before the
	addition of the BLOCK_INPUTs.

2006-02-17  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fset_window_scroll_bars): Doc fix.

2006-02-17  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (display_mode_element): Call display_string with correct
	PREC arg (which must be a number of characters, not column width).

2006-02-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* frame.c (x_get_arg): Clear out PARAM in ALIST also on Mac.

	* macfns.c (x_set_menu_bar_lines): Menu bar is always shown on Mac.

	* macmenu.c (set_frame_menubar): Don't call DrawMenuBar.

2006-02-14  Richard M. Stallman  <rms@gnu.org>

	* frame.c (x_get_arg): Clear out all occurrences of PARAM in ALIST.

	* m/ibms390x.h: New file.

2006-02-14  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_tool_bar_detach_callback): Set show-arrow to the
	value of x-gtk-whole-detached-tool-bar.
	(xg_tool_bar_attach_callback): Set show-arrow to TRUE.

	* xfns.c (syms_of_xfns): New variable: x-gtk-whole-detached-tool-bar.

2006-02-14  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (x_x_to_emacs_modifiers): Make non-static.

	* xterm.h: Declare x_x_to_emacs_modifiers.

	* gtkutil.c (xg_tool_bar_button_cb): New function.
	(xg_tool_bar_callback): Call x_x_to_emacs_modifiers to
	store modifiers in event.
	(update_frame_tool_bar): Connect button-release-event to
	xg_tool_bar_button_cb.

2006-02-13  Richard M. Stallman  <rms@gnu.org>

	* .gdbinit (xwindow): Update the code to show the window box.

2006-02-13  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (note_mouse_movement): Check for NULL FRAME_X_OUTPUT (frame).

2006-02-12  Richard M. Stallman  <rms@gnu.org>

	* cmds.c (internal_self_insert): Handle weird auto-fill-function.

2006-02-11  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (Venable_disabled_menus_and_buttons): New variable.
	(syms_of_keyboard): DEVFAR_LISP and initialize it.
	(parse_tool_bar_item, parse_menu_item): If that variable is
	non-nil, don't disable menu items and tool-bar buttons.

2006-02-11  Juanma Barranquero  <lekktu@gmail.com>

	* doc.c (Fsubstitute_command_keys): Doc fix.

2006-02-10  Thien-Thi Nguyen  <ttn@gnu.org>

	* data.c (Findirect_function): Rewrite docstring.
	Fix omission bug: Declare new arg NOERROR.

2006-02-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_mouse_color): Don't call rif->define_frame_cursor
	if window_desc is not set yet.
	(Fx_create_frame): Remove variable x_frame_name.  Apply 2005-12-07
	and 2006-01-26 changes for xfns.c.  Call x_iconify_frame if frame
	parameter `visibility' is `icon'.
	(Fx_create_frame, x_create_tip_frame): Use "fontset-standard"
	instead of "fontset-mac".
	(Fx_focus_frame): New defun.
	(syms_of_macfns): Defsubr it.

	* macterm.c (mac_define_frame_cursor): Don't change pointer shape
	for unfocused frame.
	(x_raise_frame): Call BringToFront instead of SelectWindow.
	(x_lower_frame): Use NULL instead of nil.
	(x_make_frame_visible): Don't call SelectWindow.
	(XTread_socket): Increment handling_signal at the start, decrement
	it at the end.
	[USE_CG_TEXT_DRAWING] (init_cg_text_anti_aliasing_threshold): Use
	CFPreferencesGetAppIntegerValue instead of Fmac_get_preference.

2006-02-10  Kim F. Storm  <storm@cua.dk>

	* data.c (Findirect_function): Add NOERROR arg.  All callers changed
	to pass Qnil for NOERROR.

	* keymap.c (current_minor_maps_error): Remove.
	(current_minor_maps): Pass Qt for NOERROR to Findirect_function
	instead of using internal_condition_case_1+current_minor_maps_error.

2006-02-09  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Must note mouse movement even for nil
	frames for GTK, in that case it is the tool bar.  This is so that
	highlighted text get reset properly.

2006-02-09  Juanma Barranquero  <lekktu@gmail.com>

	* alloc.c (Fmake_bool_vector, Fpurecopy): Doc fixes.

2006-02-08  Jan Djärv  <jan.h.d@swipnet.se>

	* window.c (adjust_window_trailing_edge): Check that shrinking
	does not set a window to size zero or less.

2006-02-08  Miles Bader  <miles@gnu.org>

	* editfns.c (Fconstrain_to_field): Use Fget_char_property instead
	of Fget_text_property (other field functions work with overlays as
	well as text-properties).

2006-02-07  Kenichi Handa  <handa@m17n.org>

	* dispextern.h (unibyte_display_via_language_environment): Extern it.

	* xterm.h (unibyte_display_via_language_environment):
	* w32term.h (unibyte_display_via_language_environment):
	* macterm.h (unibyte_display_via_language_environment): Delete extern.

2006-02-07  Kenichi Handa  <handa@m17n.org>

	* term.c (append_glyph): Refer to it->char_to_display instead of it->c.
	(produce_glyphs): Set the character to print in
	it->char_to_display.  Handle unibyte-display-via-language-environment.
	(produce_stretch_glyph): Set character to print in it->char_to_display.

2006-02-06  Kenichi Handa  <handa@m17n.org>

	* lread.c (openp): Initialize encoded_fn before GCPRO it.

2006-02-05  Ken Raeburn  <raeburn@raeburn.org>

	* editfns.c (Fconstrain_to_field): Fix int/Lisp_Object mixup.

	* lisp.h (XPNTR) [!NO_UNION_TYPE && !HAVE_SHM && !DATA_SEG_BITS]:
	Cast bitfield value to EMACS_INT, to suppress gcc warning.

	* xrdb.c (malloc, realloc, free) [emacs]: Undefine macros before
	defining.

2006-02-03  Kim F. Storm  <storm@cua.dk>

	* xdisp.c: Cache last merged escape glyph face.
	(last_escape_glyph_frame, last_escape_glyph_face_id)
	(last_escape_glyph_merged_face_id): New variables.
	(get_next_display_element): Use/update them.
	(redisplay_internal): Reset them before redisplay.

	* xdisp.c (set_iterator_to_next): Optimize 2004-12-13 fix.
	Only recheck faces after displaying ellipsis.

2006-02-02  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_composition_emacs_mule): Fix handling of
	incorrect format data.

2006-01-31  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (update_frame_tool_bar): Use new tool bar function
	gtk_toolbar_insert() so we can have tool bars of different sizes.

2006-01-30  Luc Teirlinck  <teirllm@auburn.edu>

	* data.c (Flistp): Doc fix.

2006-01-30  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fother_window, Fwindow_vscroll, Fset_window_vscroll):
	Fix typos in docstrings.

2006-01-28  Luc Teirlinck  <teirllm@auburn.edu>

	* data.c (Fcar, Fcdr): Add links to Elisp manual to the docstrings.

2006-01-27  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (make_interval, allocate_string)
	(allocate_string_data, make_float, Fcons, allocate_vectorlike)
	(Fmake_symbol, allocate_misc): Use BLOCK_INPUT when accessing
	global variables.

2006-01-27  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (DIRENTRY_NONEMPTY) [__CYGWIN__]: Don't use d_ino; use
	the MSDOS definition.

2006-01-26  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (check_pure_size): Make overflow message an "error message".

	* keymap.c (Fmap_keymap): Doc fix.

	* xfns.c (Fx_create_frame): Put all specified parms into f->param_alist
	unless they were cleared out.

	* frame.c (x_get_arg): "Clear out" the parm in ALIST if found there.

2006-01-26  Lőrentey Károly  <lorentey@elte.hu>

	* editfns.c (Fconstrain_to_field): Fix behavior on field boundaries.
	(find_field): Set before_field to after_field when pos is at BEGV.
	(Fline_beginning_position, Fline_end_position):
	Clarify confusing doc string.

	* cmds.c (Fbeginning_of_line, Fend_of_line): Clarify confusing doc
	string.

2006-01-26  Kenichi Handa  <handa@m17n.org>

	* callproc.c (Fcall_process): GCPRO error_file.  Encode infile,
	current_dir, and error_file.  On reporting an error, decode them
	back.

2006-01-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.c (IMMEDIATE_QUIT_CHECK): Use it with SYNC_INPUT as well.
	(re_match_2_internal) <on_failure_jump, on_failure_jump_smart>:
	Don't check for quit, since any loop will go through fail or jump.

2006-01-24  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (allocate_string_data): Update next_free immediately, to
	reduce risk of memory clobberage.

2006-01-24  Lőrentey Károly  <lorentey@elte.hu>

	* xdisp.c (handle_invisible_prop): Set it->position to fix cursor
	display when point moves across an ellipsis.  If there are
	adjacent invisible texts, don't lose the second one's ellipsis.
	(x_produce_glyphs): Doc fix.

2006-01-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_catch_errors_unwind): Yet another int/Lisp_Object mixup.

2006-01-23  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_single_display_spec): Fix handling of space
	property on char from string: set *position rather than
	it->current.pos.
	(produce_stretch_glyph): Reduce width of stretch glyphs so they
	don't get wider than the window (unless truncate-lines is on).

2006-01-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c: Avoid allocating Lisp data from a signal handler.
	(x_error_message): New var to replace x_error_message_string.
	(x_error_catcher, x_catch_errors, x_catch_errors_unwind)
	(x_check_errors, x_had_errors_p, x_clear_errors, x_error_handler)
	(syms_of_xterm): Use it instead of x_error_message_string.

	* alloc.c (lisp_align_free): Add an assertion.
	(make_interval, allocate_string, make_float, Fcons, Fmake_symbol)
	(allocate_misc): If ENABLE_CHECKING is on, check we're not called from
	a signal handler.

2006-01-21  Luc Teirlinck  <teirllm@auburn.edu>

	* dired.c (syms_of_dired) <completion-ignored-extensions>: Doc fix.

2006-01-21  Romain Francoise  <romain@orebokech.com>

	* xdisp.c (get_window_cursor_type): Fix last change.
	Update copyright year.

2006-01-20  Eli Zaretskii  <eliz@gnu.org>

	* lread.c (Fload): Don't leak the file descriptor returned by
	openp if we are going to signal an error.

	* w32.c (sys_close): If FD is outside [0..MAXDESC) limits, pass it
	directly to _close.
	(sys_dup): Protect against new_fd larger than fd_info[] can handle.
	(sys_read): If FD is outside [0..MAXDESC) limits, pass it directly
	to _read.
	(sys_write): If FD is outside [0..MAXDESC) limits, pass it
	directly to _write.

	* .gdbinit: Don't dereference Vsystem_type's Lisp_Symbol pointer
	if it is NULL.

2006-01-20  Kenichi Handa  <handa@m17n.org>

	* puresize.h (BASE_PURESIZE): Increment to 1190000.

2006-01-19  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (get_window_cursor_type): Use cursor type specified by
	the selected buffer for the echo area too.

2006-01-19  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (Fmap_keymap): Doc fix.

	* s/irix6-5.h (GC_SETJMP_WORKS, GC_MARK_STACK): New definitions.

	* keyboard.c (echo_char): Don't omit the space between first two
	echoed chars.

	* minibuf.c (read_minibuf): Fix previous change.

2006-01-19  Kenichi Handa  <handa@m17n.org>

	* xterm.c (handle_one_xevent): Handle keysyms 0x1000000..0x10000FF.

2006-01-17  Richard M. Stallman  <rms@gnu.org>

	* frame.c (x_frame_get_and_record_arg): Don't record Qunbound
	value in f->param_alist.

2006-01-15  Andreas Schwab  <schwab@suse.de>

	* search.c (Freplace_match): Use UPPERCASEP instead of !NOCASEP.

2006-01-13  Richard M. Stallman  <rms@gnu.org>

	* Makefile.in: Define new macro WINDOW_SUPPORT.
	(lisp): Use it.
	(SOME_MACHINE_LISP): Add conditionally loaded files.

2006-01-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_ATSUI] (atsu_get_text_layout_with_text_ptr)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1020]: Specify kATSLineUseQDRendering.
	(XLoadQueryFont) [USE_ATSUI]: Display diacritical marks in
	decomposed form.

	* process.c [HAVE_INTTYPES_H]: Include inttypes.h.
	(ifflag_table): Fix typo (IFF_OACTIV -> IFF_OACTIVE).
	(Fnetwork_interface_info): Use HAVE_STRUCT_IFREQ_IFR_NETMASK
	macro.  Also try member ifr_addr when getting netmask.

2006-01-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fexpand_file_name): Remove redundant tests.
	Fix elimination of // so that it doesn't prevent elimination of an
	immediately following /. or /..

2006-01-09  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_toggle_notify_cb): New function.
	(xg_toggle_visibility_cb): Move setting of x_gtk_show_hidden_files to
	xg_toggle_notify_cb.
	(xg_get_file_with_chooser): Add callback to xg_toggle_notify_cb when
	parameter value changes so the toggle button gets updated.

2006-01-06  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit: Fix typo.

2006-01-05  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Fix last change.

2006-01-05  Kim F. Storm  <storm@cua.dk>

	* process.c (Fmake_network_process): Use AF_INET instead of
	AF_UNSPEC when AF_INET6 is not defined.

2006-01-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (mac_coerce_file_name_ptr, mac_coerce_file_name_desc):
	Don't check that the other type is known file-related one.

	* macfns.c (Fx_server_version): Use gestaltSystemVersionMajor,
	gestaltSystemVersionMinor, and gestaltSystemVersionBugFix on Mac
	OS X 10.4 and later.

2006-01-04  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_image_for_pixmap): If the image is from a file,
	let GTK do all image processing.  Importing Emacs own pixmaps to GTK
	looks bad for inactive tool bar items with some Gnome themes.

2006-01-04  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Avoid a warning message when x_error_quitter is not
	compiled in.

	* process.c [WINDOWSNT]: Undef AF_INET6 to disable IPv6 support
	for w32.

2006-01-04  Kim F. Storm  <storm@cua.dk>

	* process.c: Add IPv6 support.
	(Qipv4, Qipv6): New vars.
	(syms_of_process): Intern and staticpro them.
	(Fformat_network_address): Handle 9 or 8 element vector as IPv6 address
	with or without port number.  Handle 4 element vector as IPv4 address
	without port number.
	(conv_sockaddr_to_lisp, get_lisp_to_sockaddr_size)
	(conv_lisp_to_sockaddr): Handle IPv6 addresses.
	(Fmake_network_process): Use :family 'ipv4 and 'ipv6 to explicitly
	request that address family only.  :family nil or omitted means to
	determine address family from the specified :host and :service.
	(ifflag_table): Add missing OpenBSD IFF_ flags.
	(server_accept_connection): Handle IPv6 addresses.
	(init_process): Add (:family ipv4) and (:family ipv6) sub-features.

	* .gdbinit: Undo last change.  Instead, look at Vsystem_type to
	determine which breakpoints to set.

2006-01-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (describe_map_compare): Yet another int/Lisp_Object mixup.

	* window.h (Fwindow_minibuffer_p): Declare (for use in minibuf.c).

2006-01-03  Romain Francoise  <romain@orebokech.com>

	* emacs.c (main): Update copyright year.

2006-01-03  Ken Raeburn  <raeburn@gnu.org>

	* callproc.c (delete_temp_file): Bind file-name-handler-alist to
	nil for the call to internal_delete_file.

2006-01-01  Ken Raeburn  <raeburn@gnu.org>

	* callproc.c (Fcall_process_region): Bind file-name-handler-alist
	to nil for the call to Fwrite_region.

2005-12-31  Richard M. Stallman  <rms@gnu.org>

	* minibuf.c (read_minibuf): Clear out all other minibuffer windows.

2005-12-31  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (gdb_pvec_type): A dummy variable for GDB's sake.

2005-12-30  Luc Teirlinck  <teirllm@auburn.edu>

	* textprop.c (set_text_properties): Reword description of return value.
	Return Qnil if caller wants to remove all text properties from a
	string and the string already has no intervals.

2005-12-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term.c (visible_cursor): New boolean var.
	(set_terminal_modes, tty_show_cursor): Use "vs" or "ve" depending on
	visible_cursor.
	(syms_of_term): Export the new var as "visible-cursor".

2005-12-30  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Tell users not to worry about GDB warnings that some
	functions do not exist in the binary.

2005-12-30  Andreas Schwab  <schwab@suse.de>

	* process.c (Fnetwork_interface_info): Correctly terminate the
	loop over ifflag_table.

2005-12-29  Richard M. Stallman  <rms@gnu.org>

	* lread.c (readevalloop): Test for reading a whole buffer
	before actually reading anything.  Handle all cases, including
	START = END = nil and an already-narrowed buffer.
	Convert END to a marker if it is a number.

	* keymap.c (describe_map): Put sparse map elements into an array,
	sort them, then output a sequence of identical bindings on one line.
	(struct describe_map_elt): New data type.
	(describe_map_compare): New function.

2005-12-28  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Change message shown
	in file chooser.

2005-12-27  Richard M. Stallman  <rms@gnu.org>

	* lread.c (readevalloop): Set PT and ZV in the proper buffer,
	not the current one.

	* minibuf.c (Fminibuffer_message): Doc fix.
	(read_minibuf): Set current_buffer->enable_multibyte_characters sooner.

	* eval.c (do_autoload): Ignore elements of Vautoload_queue
	where car is not symbol.

2005-12-27  Kenichi Handa  <handa@m17n.org>

	* charset.c (lisp_string_width): Check multibyteness of STRING.

2005-12-27  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (x_show_hidden_files): New variable.
	(syms_of_xfns): Defvar it.

	* gtkutil.c (xg_toggle_visibility_cb): New function.
	(xg_get_file_with_chooser): Add toggle hidden files and a message
	to the new file chooser dialog.  Show hidden files if
	x_show_hidden_files is non-zero.

2005-12-26  Richard M. Stallman  <rms@gnu.org>

	* keyboard.h: Undo previous change.

	* Makefile.in (undo.o): Undo previous change.

	* undo.c: Undo previous change.

2005-12-26  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.h: extern last_point_position_window.

	* undo.c: include keyboard.h.

	* Makefile.in (undo.o): Depend on keyboard.h.

2005-12-26  Richard M. Stallman  <rms@gnu.org>

	* commands.h (last_point_position_window): Declare.

	* undo.c: Depend on window.h.
	(record_point): Save old point from the correct window.

	* keyboard.c (last_point_position_window): New variable.
	(command_loop_1): Set last_point_position_window.
	(syms_of_keyboard): Init it.

	* Makefile.in (undo.o): Depend on window.h.

2005-12-25  Richard M. Stallman  <rms@gnu.org>

	* eval.c (un_autoload): Expect (0 . OFEATURES) in Vautoload_queue
	to undo a `provide'.

	* fns.c (Fprovide): Store (0 . OFEATURES) in Vautoload_queue.

2005-12-25  Giorgos Keramidas  <keramida@ceid.upatras.gr>

	* m/amdx86-64.h [__FreeBSD__] (START_FILES, LIB_STANDARD):
	define for FreeBSD on this platform.

2005-12-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.h (TYPE_FILE_NAME): New define.
	(posix_pathname_to_fsspec, fsspec_to_posix_pathname): Remove externs.

	* mac.c (posix_pathname_to_fsspec, fsspec_to_posix_pathname):
	Add prototypes.  Make static.
	(mac_aedesc_to_lisp): Initialize err to noErr.
	(mac_coerce_file_name_ptr, mac_coerce_file_name_desc)
	(init_coercion_handler): New functions.
	(Fmac_coerce_ae_data): Use coercion of Apple event data for
	translation from/to file names.

	* macterm.c: Don't include sys/param.h.
	(init_coercion_handler): Add extern.
	[MAC_OS8] (main): Call init_coercion_handler.
	(mac_initialize) [MAC_OSX]: Likewise.
	[TARGET_API_MAC_CARBON] (mac_do_receive_drag): Use coercion of
	Apple event data for translation from/to file names.

	* macfns.c [TARGET_API_MAC_CARBON] (Fx_file_dialog): Likewise.

	* image.c [MAC_OS] (find_image_fsspec): Likewise.

2005-12-23  Martin Rudalics  <rudalics@gmx.at>

	* insdel.c (insert, insert_and_inherit, insert_before_markers)
	(insert_before_markers_and_inherit): Make sure FROM is correct
	when `after-change-functions' are called.

2005-12-23  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_uses_old_gtk_dialog): New function.

	* gtkutil.c (xg_uses_old_file_dialog): New function.
	(xg_get_file_name): Use xg_uses_old_file_dialog.

	* gtkutil.h: Declare xg_uses_old_file_dialog.

2005-12-22  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (xmenu_show): Call inhibit_garbage_collection.

2005-12-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (Fmac_coerce_ae_data) [MAC_OSX]: Fix memory leak.

	* macgui.h (XCharStruct): Remove member `valid_p'.
	(STORE_XCHARSTRUCT): Don't set member `valid_p'.
	(XCharStructRow): New typedef.
	(XCHARSTRUCTROW_CHAR_VALID_P, XCHARSTRUCTROW_SET_CHAR_VALID):
	New macros.
	(struct MacFontStruct): Add member `bounds'.  Remove member
	`per_char'.  All uses for QuichDraw Text fonts are changed to
	`bounds.per_char'.  ATSUI font bounds are represented as an array
	`bounds.rows' of XCharStructRow's, each of which consists of a
	bitmap of valid entries and an array of char bounds.

	* macterm.c (mac_per_char_metric): Add prototype.
	(x_per_char_metric) [USE_CG_TEXT_DRAWING]: Remove prototype.
	(mac_query_char_extents): New function.
	(x_per_char_metric): Use it.
	(XLoadQueryFont): Likewise.  Consolidate min/max_bounds calculations.
	[USE_CG_TEXT_DRAWING] (mac_draw_string_cg):
	Use mac_per_char_metric instead of x_per_char_metric.
	(mac_text_extents_16): New function.
	(mac_compute_glyph_string_overhangs): Use it.
	(mac_unload_font): Free member `bounds' in struct MacFontStruct.

2005-12-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Fdisplay_completion_list): Use XCAR/XCDR.
	(Fminibuffer_completion_help): Remove duplicates before display.

2005-12-21  Lőrentey Károly  <lorentey@elte.hu>

	* print.c (print_preprocess): Don't lose print_depth levels while
	iterating.

2005-12-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (Qmac_apple_event): Add extern.
	(set_frame_menubar, mac_menu_show keymp_panes)
	(single_keymap_panes, list_of_panes, list_of_item)
	(single_menu_item): Add argument types to prototypes.
	(mac_dialog_show) [HAVE_DIALOGS]: Likewise.
	(struct skp): New struct (from xmenu.c).
	(single_keymap_panes, single_menu_item, list_of_panes)
	(list_of_item): Sync with xmenu.c.
	(Fx_popup_menu, Fx_popup_dialog): Likewise.  Don't get window from
	POSITION if it is mac-apple-event event.
	(menubar_selection_callback): Don't use menu_command_in_progress.
	(set_frame_menubar): First parse all submenus, then make
	widget_value trees from them.  Don't allocate any widget_value
	objects until we are done with the parsing.
	(parse_single_submenu, digest_single_submenu): New functions.
	(single_submenu): Function deleted, replaced by those two.
	(install_menu_quit_handler) [HAVE_CANCELMENUTRACKING]: Don't create
	or dispose of EventHandlerUPP.  Install hander to all submenus.
	(mac_menu_show) [!HAVE_MULTILINGUAL_MENU]: Use ENCODE_MENU_STRING
	instead of ENCODE_SYSTEM.
	(free_frame_menubar, fill_submenu, fill_menu): Don't use NULL for
	integer values.
	[HAVE_DIALOGS] (mac_dialog_show): Sync with xdialog_show (in xmenu.c).
	(add_menu_item) [TARGET_API_MAC_CARBON]: Use CFString functions to
	format menu item string.  Don't use NULL for integer value.

	* macterm.h (struct mac_output): Remove unused member
	menu_command_in_progress.

2005-12-20  Juri Linkov  <juri@jurta.org>

	* xmenu.c (Fx_popup_menu): Set Vmenu_updating_frame to f if
	position is non-nil, else set it to nil.

	* macmenu.c (Fx_popup_menu): Add `else' to set
	Vmenu_updating_frame to nil only if position is nil.

	* w32menu.c (Fx_popup_menu): Add `else' to set
	Vmenu_updating_frame to nil only if position is nil.

2005-12-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (make_lispy_event): Drag-and-drop items are now
	stored in member `args' of struct input_event.

	* termhooks.h (struct input_event): Fix comment for DRAG_N_DROP_EVENT.

	* xselect.c (x_handle_dnd_message): Drag-and-drop items are now
	stored in member `args' of struct input_event.

	* w32term.c (construct_drag_n_drop): Likewise.

	* macterm.c (mac_do_receive_drag): Likewise.
	(x_use_underline_position_properties): Undo 2005-07-13 change.
	(syms_of_macterm) <x-use-underline-position-properties>: Likewise.
	(mac_use_core_graphics, mac_wheel_button_is_mouse_2)
	(mac_pass_command_to_system, mac_pass_control_to_system):
	New boolean variables renamed from Lisp_Object ones
	Vmac_use_core_graphics, Vmac_wheel_button_is_mouse_2,
	Vmac_pass_command_to_system, and Vmac_pass_control_to_system.
	All uses changed.
	(syms_of_macterm): DEFVAR_BOOL them.  Remove previous DEFVAR_LISPs.
	Make them user options.
	(mac_handle_command_event, mac_store_services_event):
	Call create_apple_event_from_event_ref without 5th argument.
	(backtranslate_modified_keycode): Mask off modifier keys that are
	mapped to some Emacs modifiers before passing it to KeyTranslate.
	(syms_of_macterm): Make variables `mac-emulate-three-button-mouse',
	`mac-wheel-button-is-mouse-2', and `mac-*-modifier' user options.
	Fix docstrings of `mac-*-modifier'.

	* mac.c (create_apple_event_from_event_ref): Remove arg `types'.
	(do_applescript): Change argument types to Lisp_Object.
	All uses changed.

	* macterm.h (create_apple_event_from_event_ref): Remove 5th
	argument from extern.

2005-12-18  Dan Nicolaescu  <dann@ics.uci.edu>

	* xfns.c (Fx_backspace_delete_keys_p): In case we cannot determine
	the answer, return `lambda', not nil.

2005-12-17  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (bootstrap-temacs): Warn that parts of commands
	enclosed in $(ARGQUOTE)s should not be split between two lines, as
	that will break with GNU Make >3.80, when sh.exe is used and
	arg quoting is with '..'.

2005-12-17  Chong Yidong  <cyd@stupidchicken.com>

	* print.c (print_preprocess): Just signal an error if print_depth
	is exceeded.

2005-12-17  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Set a breakpoint on w32_abort.

2005-12-16  Juri Linkov  <juri@jurta.org>

	* minibuf.c (Fminibuffer_completion_contents): New Lisp function
	created from minibuffer_completion_contents.
	(minibuffer_completion_contents): Remove.
	(do_completion, Fminibuffer_complete_word)
	(Fminibuffer_completion_help): Replace minibuffer_completion_contents
	with Fminibuffer_completion_contents.
	(syms_of_minibuf): Add Sminibuffer_completion_contents.
	(Fdisplay_completion_list): Doc fix.
	(display_completion_list_1): Use `nil' for second arg of
	`Fdisplay_completion_list'.

2005-12-14  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (compute_tip_xy): Handle negative dx and dy.

	* w32fns.c (compute_tip_xy): Ditto.

	* macfns.c (compute_tip_xy): Ditto.

2005-12-14  Chong Yidong  <cyd@stupidchicken.com>

	* print.c (print_preprocess): Go to a deeper print_depth to avoid
	print_object loop.

2005-12-14  Kyotaro HORIGUCHI  <horiguti@meadowy.org>  (tiny change)

	* coding.c (code_convert_region_unwind): GCPRO arg.

2005-12-12  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (compute_tip_xy): Calculate root_y the same way as root_x,
	i.e. dy is offset from top of frame instead of bottom.

	* macfns.c (compute_tip_xy): Ditto.

	* w32fns.c (compute_tip_xy): Ditto.

	* gtkutil.c (SSDATA): New macro to remove compiler warnings.
	(xg_get_image_for_pixmap, xg_create_frame_widgets)
	(xg_get_file_with_chooser): Use SSDATA instead of SDATA.

	* xmenu.c (menubar_selection_callback): Do nothing if the callback
	is for an unselected radio menu item.

2005-12-11  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (syms_of_xdisp) <blink-cursor-alist>: Doc fix.

	* lisp.h [! NO_UNION_TYPE] (EQ): Use == so args are computed just once.

	* keymap.c (Fset_keymap_parent, store_in_keymap): Use CHECK_IMPURE.
	(Flookup_key): Doc fix.
	(syms_of_keymap) <function-key-map>: Doc fix.

	* fns.c (Frequire): Treat evaluating from a source file
	like loading the file.

	* floatfns.c (Flog): Doc fix.

	* fileio.c (Finsert_file_contents): Set Vdeactivate_mark
	when we change the buffer.

2005-12-11  Juri Linkov  <juri@jurta.org>

	* minibuf.c (display_completion_list_1):
	Call `minibuffer_completion_contents' instead of using `nil' as
	second arg of `Fdisplay_completion_list'.
	(keys_of_minibuf): Unbind SPC in
	Vminibuffer_local_filename_completion_map (see also related
	change on 2005-12-06).

2005-12-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main) [MAC_OS8]: Undo previous change.

	* macselect.c (syms_of_macselect) <mac-apple-event-map>:
	Initialize to nil.  Keymap is now created in lisp/term/mac-win.el.

2005-12-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (macselect.o): Depend on keymap.h.

	* emacs.c (main) [MAC_OS8]: Call syms_of_keymap before
	syms_of_macselect.

	* image.c (init_image) [MAC_OS]: Don't call EnterMovies.
	[!HAVE_GIF && MAC_OS] (gif_load): Call EnterMovies.

	* keyboard.c (Qmac_apple_event) [MAC_OS]: New variable.
	(syms_of_keyboard) [MAC_OS]: Initialize it.
	(make_lispy_event) [MAC_OS]: Build lisp event for MAC_APPLE_EVENT.

	* mac.c (Qundecoded_file_name): New variable.
	(syms_of_mac): Initialize it.
	(mac_aelist_to_lisp, mac_aedesc_to_lisp): New functions.
	[TARGET_API_MAC_CARBON] (create_apple_event_from_event_ref): New fun.
	(Fmac_coerce_ae_data): New defun.
	(syms_of_mac): Defsubr it.

	* macselect.c: Include keymap.h.
	(mac_ready_for_apple_events): New variable.
	(Vmac_apple_event_map, Qmac_apple_event_class)
	(Qmac_apple_event_id): New variables.
	(syms_of_macselect): Initialize them.
	(Qundefined, mac_store_apple_event): Add externs.
	(struct apple_event_binding): New struct.
	(find_event_binding_fun, find_event_binding)
	(mac_find_apple_event_spec, defer_apple_events)
	(mac_handle_apple_event, init_apple_event_handler)
	(copy_scrap_flavor_data): New functions.
	(Fmac_process_deferred_apple_events): New defun.
	(syms_of_macselect): Defsubr it.
	(mac_store_services_event): Fix extern.
	(mac_handle_service_event): Don't allocate Lisp objects during
	asynchronous input processing.  Use mac_store_services_event
	instead of mac_store_application_menu_event.

	* macterm.c (Qmac_ready_for_drag_n_drop, Qapplication, Qabout)
	(Qpreferences): Remove variables.
	(syms_of_macterm): Don't initialize them.
	(Qhicommand) [USE_CARBON_EVENTS]: New variable.
	(syms_of_macterm) [USE_CARBON_EVENTS]: Initialize it.
	(init_required_apple_events, do_ae_open_application)
	(do_ae_print_documents, do_ae_open_documents)
	(do_ae_quit_application): Remove functions and prototypes.
	(mac_ready_for_apple_events, Qundefined, init_apple_event_handler)
	(mac_find_apple_event_spec): Add externs.
	(mac_store_application_menu_event): Remove function.
	(mac_store_apple_event, mac_make_lispy_event_code): New functions.
	(mac_handle_command_event): Create Apple event from Carbon event.
	Use mac_store_apple_event instead of mac_store_application_menu_event.
	[MAC_OSX] (mac_store_services_event): Likewise.
	(struct SelectionRange, SelectionRange): Remove struct and typedef.
	[MAC_OS8] (main): Call init_apple_event_handler instead of
	init_required_apple_events.
	(mac_initialize) [MAC_OSX]: Likewise.
	[!USE_CARBON_EVENTS] (mac_wait_next_event):
	Use mac_ready_for_apple_events instead of Qmac_ready_for_drag_n_drop.

	* macterm.h (mac_make_lispy_event_code, mac_aedesc_to_lisp):
	Add externs.
	(create_apple_event_from_event_ref) [TARGET_API_MAC_CARBON]: Likewise.
	(Fmac_get_preference): Add EXFUN.

	* termhooks.h (enum event_kind) [MAC_OS]: Add new MAC_APPLE_EVENT
	event.

2005-12-09  Richard M. Stallman  <rms@gnu.org>

	* xfns.c (Fx_create_frame): Reinstate previous change.

2005-12-09  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_abort) [__GNUC__]: Add instructions for attaching
	GDB to the abort dialog.

2005-12-09  Kyotaro HORIGUCHI  <horiguti@meadowy.org>  (tiny change)

	* indent.c (Fvertical_motion): Force move if starting on
	stretch glyph.

2005-12-08  Richard M. Stallman  <rms@gnu.org>

	* lread.c (read_escape) <\s>: Don't treat strings specially.

	* xfns.c (Fx_create_frame): Comment out previous change.

2005-12-07  Lőrentey Károly  <lorentey@elte.hu>

	* xfns.c (Fx_create_frame): Initialize Vdefault_minibuffer_frame,
	when needed.

2005-12-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (keys_of_minibuf): Just unbind SPC in
	Vminibuffer_local_filename_completion_map rather than forcing it
	explicitly to the same binding as the global map.

2005-12-06  Ken Raeburn  <raeburn@gnu.org>

	* buffer.c (Fkill_buffer): Avoid dangerous side effects in NILP args.
	* bytecode.c (Fbyte_code): Likewise.
	* fileio.c (internal_delete_file, Fread_file_name_internal): Likewise.
	* minibuf.c (Fminibuffer_complete_and_exit): Likewise.
	* undo.c (truncate_undo_list): Likewise.

2005-12-05  Richard M. Stallman  <rms@gnu.org>

	* window.c (enlarge_window): Eliminate arg preserve_before.
	Assume it is 0.  All callers changed.
	(Fenlarge_window, Fshrink_window): Likewise.

2005-12-02  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (compute_tip_xy): Put tip above pointer if it doesn't
	fit below.

2005-12-02  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.h: Add prototype for xg_set_icon_from_xpm_data.

	* xfns.c (x_real_positions): int ign => unsigned int.
	(xg_set_icon_from_xpm_data): Remove unused variable err.
	(x_set_name_internal, Fx_create_frame, xg_set_icon): Add cast
	to remove compiler warning.
	(compute_tip_xy): Put tip above pointer if it doesn't fit below.

2005-12-02  David Reitter  <david.reitter@gmail.com>

	* minibuf.c (Fcompleting_read): If Vminibuffer_completing_file_name is
	non-nil, use the new keymaps Vminibuffer_local_filename_completion_map
	and Vminibuffer_local_must_match_filename_map keymaps.
	(keys_of_minibuf): Bind SPC in the new file-name completion keymaps.

	* keymap.c (Vminibuffer_local_filename_completion_map)
	(Vminibuffer_local_must_match_filename_map): New variables.
	(syms_of_keymap): DEFVAR_LISP them, initialize them, and set their
	parent to be Vminibuffer_local_completion_map and
	Vminibuffer_local_must_match_map, respectively.

	* commands.h (Vminibuffer_local_filename_completion_map)
	(Vminibuffer_local_must_match_filename_map): Declare the new keymaps.

2005-12-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fset_window_configuration): Don't accidentally copy the
	window-point of one window to another.

2005-11-30  Lőrentey Károly  <lorentey@elte.hu>

	* buffer.c (Fpop_to_buffer): Remove superfluous call to record_buffer.

2005-11-30  Kim F. Storm  <storm@cua.dk>

	* alloc.c: Include fcntl.h.  Define O_WRONLY if not defined.
	(valid_lisp_object_p) [!GC_MARK_STACK]: Validate pointer by
	passing it to `emacs_write'.

2005-11-29  Ari Roponen  <arjuropo@cc.jyu.fi>  (tiny change)

	* atimer.c (stop_other_atimers): Fix loop to correctly compute `prev'.

2005-11-27  Richard M. Stallman  <rms@gnu.org>

	* window.c (adjust_window_trailing_edge): New function.
	(Fadjust_window_trailing_edge): New function.
	(syms_of_window): Defsubr it.
	(window_deletion_count): New variable.
	(delete_window): Update window_deletion_count.

2005-11-26  Eli Zaretskii  <eliz@gnu.org>

	* minibuf.c (syms_of_minibuf): Mention the extension of
	`completion-auto-help's meaning by complete.el.

2005-11-26  Henrik Enberg  <henrik.enberg@telia.com>

	* xfaces.c (Finternal_set_lisp_face_attribute_from_resource):
	Handle :inherit property as a lisp expression.

2005-11-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (Qcontrol): Rename from Qctrl.  All uses changed.
	(syms_of_macterm): Staticpro Qcontrol, Qmeta, Qalt, Qhyper,
	Qsuper, and Qmodifier_value.
	(Vmac_control_modifier, Vmac_option_modifier)
	(Vmac_command_modifier, Vmac_function_modifier)
	(Vmac_emulate_three_button_mouse, Vmac_wheel_button_is_mouse_2)
	(Vmac_pass_command_to_system, Vmac_pass_control_to_system)
	(Vmac_charset_info_alist): Doc fixes.

2005-11-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main) [MAC_OSX]: Change working directory to home
	directory if `-psn_*' option is specified.

	* mac.c (DECODE_UTF_8): Remove macro.
	[TARGET_API_MAC_CARBON] (cfstring_to_lisp_nodecode): New function
	created from cfstring_to_lisp.
	[TARGET_API_MAC_CARBON] (cfstring_to_lisp): Use it.
	(xrm_get_preference_database) [TARGET_API_MAC_CARBON]: Likewise.

	* macterm.h (cfstring_to_lisp_nodecode) [TARGET_API_MAC_CARBON]:
	Add prototype.

2005-11-21  Ken Raeburn  <raeburn@gnu.org>

	* keymap.c (shadow_lookup): Use make_number to pass a number to
	Fsubstring.

2005-11-21  Juri Linkov  <juri@jurta.org>

	* puresize.h (BASE_PURESIZE): Increment to 1180000.

2005-11-20  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (Finternal_set_lisp_face_attribute):
	Use :ignore-defface for new frame defaults when `unspecified' is
	supplied.
	(Finternal_get_lisp_face_attribute): Hide :ignore-defface.
	(merge_face_vectors): Don't do :ignore-defface overwriting here.
	(Finternal_merge_in_global_face): Do it here.

2005-11-20  Juri Linkov  <juri@jurta.org>

	* charset.c (invalid_character): Use Lisp-readable syntax
	for octal and hex.  Reorder decimal, octal and hex values.

2005-11-20  Nick Roberts  <nickrob@snap.net.nz>

	* lisp.h: Use typedef when Lisp_Object is EMACS_INT so that
	this type is recognised when debugging.

2005-11-19  Andreas Schwab  <schwab@suse.de>

	* .gdbinit (nextcons, xcdr, xfloat): Update for changes in
	Lisp_Cons and Lisp_Float.

2005-11-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_CG_TEXT_DRAWING] (cg_text_anti_aliasing_threshold):
	New variable.
	[USE_CG_TEXT_DRAWING] (init_cg_text_anti_aliasing_threshold): New fun.
	(init_font_name_table) [USE_ATSUI && USE_CG_TEXT_DRAWING]: Use it.
	[USE_CG_TEXT_DRAWING] (mac_draw_string_cg): Don't do antialiasing if
	font size is smaller than or equal to cg_text_anti_aliasing_threshold.

2005-11-17  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (x_create_bitmap_from_xpm_data): Free attributes on fail.

	* xfaces.c (Qignore_defface): New variable.
	(syms_of_xfaces): Provide `:ignore-defface'.
	(IGNORE_DEFFACE_P): New macro.
	(check_lface_attrs, lface_fully_specified_p)
	(Finternal_set_lisp_face_attribute)
	(Fface_attribute_relative_p, Fmerge_face_attribute):
	Handle Qignore_defface as a possible value.
	(merge_face_vectors): The merged face is `unspecified' if the
	mergee specifies `:ignore-defface'.

2005-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Add missing GCPROs.

2005-11-16  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (xg_set_icon_from_xpm_data): New function.

	* gnu.h (gnu_xpm_bits): Rename from gnu_bits.
	(gnu_xbm_bits): Rename from gnu_bits (xbm version).

	* xterm.c (x_bitmap_icon): Use the xpm if available.

	* image.c (x_create_bitmap_from_xpm_data): New function.
	(x_create_bitmap_from_xpm_data): Initialize XpmAttributes.

2005-11-15  Luc Teirlinck  <teirllm@auburn.edu>

	* Makefile.in (lisp, shortlisp): Add rfn-eshadow.

2005-11-16  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit: Make SIGTSTP work like SIGINT normally does.

2005-11-15  Andreas Schwab  <schwab@suse.de>

	* lisp.h (struct Lisp_Cons): Make cdr a union.
	(XCDR_AS_LVALUE): Adjust.
	(struct Lisp_Float): Make data a union.
	(XFLOAT_DATA): Adjust.

	* alloc.c (free_float): Make free list chaining aliasing-safe.
	(make_float): Likewise.
	(free_cons): Likewise.
	(Fcons): Likewise.
	(check_cons_list): Likewise.
	(Fmake_symbol): Likewise.
	(allocate_misc): Likewise.
	(free_misc): Likewise.
	(gc_sweep): Likewise.

2005-11-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (HASHKEY_QUERY_CACHE): New define.
	(xrm_create_database, xrm_q_put_resource): Empty query cache.
	(xrm_get_resource): Use query cache.

	* image.c (init_image) [MAC_OS]: Don't call EnterMovies if
	inhibit_window_system is set.

2005-11-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (USE_CG_TEXT_DRAWING): New define.
	(struct MacFontStruct) [USE_CG_TEXT_DRAWING]: New members cg_font
	and cg_glyphs.

	* macterm.c [USE_CG_TEXT_DRAWING] (mac_draw_string_cg): New function.
	(x_draw_glyph_string_foreground) [USE_CG_TEXT_DRAWING]: Use it.
	(XLoadQueryFont) [USE_CG_TEXT_DRAWING]: Set members cg_font and
	cg_glyphs in struct MacFontStruct if synthesized bold or italic is
	not used and font substitution never occurs for ASCII and Latin-1
	characters.
	(XLoadQueryFont): Maximum and minimum metrics are now those among
	ASCII characters.
	(XLoadQueryFont) [!MAC_OS8 || USE_ATSUI]: Apply WebKit-style
	height adjustments for Courier, Helvetica, and Times.

	* s/darwin.h (LIBS_CARBON) [!HAVE_CARBON]: Remove `-framework Carbon'.

2005-11-11  David Reitter  <david.reitter@gmail.com>

	* macterm.c (syms_of_macterm): Remove macCtrlKey, macShiftKey,
	macMetaKey, macAltKey.  Introduce Qctrl, Qmeta,
	Vmac_control_modifier / mac-control-modifier,
	Vmac_option_modifier / mac-option-modifier,
	Vmac_command_modifier / mac-command-modifier.
	(mac_to_emacs_modifiers): Use the new style modifier
	variables.  Return UInt32 (modifiers are longs now.)
	(backtranslate_modified_keycode): New function (refactoring).
	(XTread_socket): Use new modifier variables and refactored function.
	(mac_determine_quit_char_modifiers): Remove macMetaKey (there is
	no dedicated meta key.  Not in use anyway.)
	(convert_fn_keycode): Map Fn-keys to their original keycode
	using a table (english keyboard only).

2005-11-11  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Fix output format if n_overlay_strings > 0.
	Add post hook to "backtrace" to always dump lisp call stack to
	increase chance of people sending it to us when reporting bugs.

	* doc.c (Fsubstitute_command_keys): Doc fix.

	* dispextern.h (struct it): New member ignore_overlay_strings_at_pos_p.

	* xdisp.c (handle_stop): Skip overlay string handling if
	ignore_overlay_strings_at_pos_p is set.
	(set_iterator_to_next): At end of display vector, set
	ignore_overlay_strings_at_pos_p if dpvec came from an overlay
	string, so we skip those overlay strings at current pos.

2005-11-10  Lars Hansen  <larsh@soem.dk>

	* fileio.c (file-regular-p): Doc fix.

2005-11-10  Kim F. Storm  <storm@cua.dk>

	* alloc.c (valid_lisp_object_p): New function to validate that
	an object is really a valid Lisp_Object.

	* lisp.h (valid_lisp_object_p): Add prototype.

	* print.c (safe_debug_print): New function to be called from gdb
	to print Lisp objects; use valid_lisp_object_p to avoid crashing
	if user tries to print something which is not a Lisp object.

	* .gdbinit (pp, pp1): Use safe_debug_print.
	(pv, pv1): New commands to print value of a lisp variable.

2005-11-10  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit (pp1): New user-defined function.

2005-11-09  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OSX] (image_load_quartz2d): Fix memory leak.

	* mac.c [MAC_OSX] (init_mac_osx_environment): Reinitialize locale
	related variables for dumped executable.

	* unexmacosx.c (unexec_write_zero): New function.
	(copy_data_segment): Clear uninitialized local variables in
	statically linked libraries.

	* s/darwin.h (C_SWITCH_SYSTEM): Remove -fno-common.

2005-11-09  Juri Linkov  <juri@jurta.org>

	* keymap.c (shadow_lookup): If Flookup_key returns a number,
	call it again with a sub-key-sequence, and if its return value
	is non-nil (sub-key is bound), return nil.

2005-11-08  Kim F. Storm  <storm@cua.dk>

	* process.c (Fsignal_process): Recognize signal names with and
	without SIG prefix, e.g. SIGHUP and HUP.

	* search.c (search_buffer): No need to initialize base_pat.

2005-11-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fget_lru_window, Fget_largest_window, window_loop):
	Don't abuse the `mini' arg.  Use the `obj' arg instead.

2005-11-04  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (show_mouse_face): Clear mouse face to eol.

2005-11-03  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (lisp, shortlisp): Add emacs-lisp/syntax.elc,
	font-lock.elc and jit-lock.elc.

2005-11-03  Richard M. Stallman  <rms@gnu.org>

	* window.c (Fenlarge_window): Rename SIDE to HORIZONTAL.
	(enlarge_window): Rename WIDTHFLAG to HORIZ_FLAG.
	(CURBEG, CURSIZE): Use HORIZ_FLAG instead of WIDTHFLAG.

	* sheap.c (STATIC_HEAP_SIZE): Increment both definitions.

	* alloc.c (refill_memory_reserve): Move decl out of conditionals.

2005-11-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fdisplay_buffer): Fix last change to not use
	a dedicated window.

2005-11-01  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Undo 2005-10-27 change.
	Instead, rotate the bottom angle bitmap 180 degrees to indicate
	that the bottom row does not end in a newline.

2005-11-01  Andreas Schwab  <schwab@suse.de>

	* unexelf.c (unexec): Handle .plt section in BSS segment.

2005-11-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Yet another int/Lisp_Object mixup (YAILOM).

	* window.c (window_loop): For LRU and LARGEST, let the `mini' argument
	determine whether to consider dedicated windows as well.
	(Fget_lru_window, Fget_largest_window): Add `dedicated' argument.
	(Fdisplay_buffer): Do consider dedicated windows in those cases where
	we will split the window rather than reuse it.
	Don't try to use windows on other displays.

2005-10-31  Dan Nicolaescu  <dann@ics.uci.edu>

	* puresize.h (BASE_PURESIZE): Increment to 1170000.

2005-10-31  Romain Francoise  <romain@orebokech.com>

	* macfns.c: Update copyright year.
	* m/gould.h: Likewise.

2005-10-30  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_line): Restore it->current_x and call
	extend_face_to_end_of_line when last glyph doesn't fit on line.
	(set_glyph_string_background_width): Remove specific tests here
	to see if face background should extend to end of line.  Simplify.

2005-10-30  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (BYTES_USED): Use uordblks, not arena.
	(bytes_used_when_reconsidered): New variable.
	(emacs_blocked_free): Set that.

2005-10-29  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (emacs_blocked_free): Fix typo.

2005-10-29  Richard M. Stallman  <rms@gnu.org>

	* data.c (Fmake_variable_frame_local): Doc fix.

	* xdisp.c (handle_fontified_prop): Do nothing if memory full.
	(format_mode_line_unwind_data): New arg SAVE_PROPTRANS
	controls whether to save and restore mode_line_proptrans_alist.
	Callers changed.
	(unwind_format_mode_line): Work with that feature.
	(redisplay_internal): Don't call prepare_menu_bars if memory full.
	(move_elt_to_front): New function.
	(display_mode_element): Use move_elt_to_front.
	Don't bother munging text props on a null string.
	Delete obsolete elts from mode_line_proptrans_alist.
	(decode_mode_spec): Test Vmemory_full, not spare_memory.
	(Fformat_mode_line): Clear mode_line_proptrans_alist after saving.

	* lisp.h (memory_full_cons_threshold): Declare.
	(internal_lisp_condition_case): Declare.

	* alloc.c (syms_of_alloc) <memory-full>: Doc fix.
	(Fmemory_full_p): Function deleted.
	(syms_of_alloc): Don't defsubr it.
	(memory_full_cons_threshold): New variable.
	(spare_memory): Now a vector of 7 elts.
	(buffer_memory_full): Don't set Vmemory_full here.
	(xfree): Don't try to refill here.
	(emacs_blocked_free): Record BYTES_USED in local var.
	(memory_full): Now free all the slots in spare_memory.
	(refill_memory_reserve): Allocate each slot in spare_memory.
	(init_alloc_once): Call refill_memory_reserve.

	* keyboard.c (command_loop_1): Don't set Vmemory_full here.

	* eval.c (internal_lisp_condition_case): New function.
	(Fcondition_case): Use internal_lisp_condition_case.
	(Feval): Test Vmemory_full and memory_full_cons_threshold.
	(Ffuncall): Likewise.

	* bytecode.c (Fbyte_code): Use internal_lisp_condition_case.

2005-10-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fparse_partial_sexp): Fix docstring.

2005-10-28  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1130000.

2005-10-28  Richard M. Stallman  <rms@gnu.org>

	* xfns.c (syms_of_xfns): Provide `x' as feature.

	* xdisp.c (decode_mode_spec): Define %e to indicate memory full.

	* editfns.c (Fformat): Don't include string padding
	between info[n].start and info[n].end.

	* alloc.c (spare_memory): No longer static.
	(xfree) [!SYSTEM_MALLOC]: Call refill_memory_reserve.

	* puresize.h (BASE_PURESIZE): Increment to 1120000.

2005-10-27  Chong Yidong  <cyd@stupidchicken.com>

	* data.c (Fmake_variable_frame_local): Add clarification to docstring.

	* fringe.c (update_window_fringes): Handle case where buffer ends
	with a newline.

2005-10-27  Kenichi Handa  <handa@m17n.org>

	* coding.h (DECODE_SYSTEM): Fix argument name; name->str.

2005-10-24  Kenichi Handa  <handa@m17n.org>

	* charset.h (charset_mule_unicode_0100_24ff)
	(charset_mule_unicode_2500_33ff, charset_mule_unicode_e000_ffff):
	Extern them.

	* charset.c (charset_mule_unicode_0100_24ff)
	(charset_mule_unicode_2500_33ff, charset_mule_unicode_e000_ffff):
	New variables.
	(Fsetup_special_charsets): Initialize them.

	* xterm.c (handle_one_xevent): Handle keysyms directly mapped to
	supported Unicode characters.

2005-10-25  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_to_x_font): Avoid forcing font widths.

2005-10-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (image_load_qt_1): Check image size.
	Use GraphicsImportGetImageDescription instead of
	GraphicsImportGetNaturalBounds.
	[MAC_OSX] (image_load_quartz2d): Check image size.
	[MAC_OS] (xpm_load_image): Likewise.

	* macterm.c (last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(XTmouse_position): Set last_mouse_glyph_frame.
	(XTread_socket): Clear last_mouse_glyph_frame on mouse up/down event.
	(mac_draw_string_common) [USE_ATSUI && WORDS_BIG_ENDIAN]: Fix typo.
	Use EndianU16_BtoN.
	(mac_draw_string_common) [MAC_OSX]: Don't use ATSUClearLayoutControls.
	(x_per_char_metric, XLoadQueryFont)
	[MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Use device origins to get
	glyph bounds.
	(mac_to_x_fontname, mac_do_list_fonts)
	(mac_initialize_display_info): Change screen resolutions to 72dpi.

2005-10-25  Masatake YAMATO  <jet@gyve.org>

	* minibuf.c (Fdisplay_completion_list): Small doc fix.

2005-10-24  Kim F. Storm  <storm@cua.dk>

	* xterm.c: Undo 2005-10-23 change.
	(last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(XTmouse_position): Set last_mouse_glyph_frame.
	(handle_one_xevent): Clear last_mouse_glyph_frame [instead of
	last_mouse_glyph] on mouse up/down event.

	* editfns.c (Fcompare_buffer_substrings): Fix last change.

2005-10-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fcompare_buffer_substrings): Handle multibyte chars.

2005-10-23  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (note_mouse_movement): Always call note_mouse_highlight
	so tool tips don't interfere with press on tool bar button.

2005-10-23  Richard M. Stallman  <rms@gnu.org>

	* casetab.c (Fset_case_table): Doc fix.

	* lread.c (build_load_history): Replace STREAM arg with ENTIRE.
	(readevalloop): Compute ENTIRE properly.
	(syms_of_lread) <load-history>: Doc fix.

2005-10-21  Richard M. Stallman  <rms@gnu.org>

	* lread.c (Fload): Simplify gcpro structure.
	Gcpro FOUND as well as FILE, but not EFOUND.
	Unless preloading, record FOUND instead of FILE in Vload_history.
	Rename repeat local FILE to MSG_FILE.
	(syms_of_lread) <load-history>: Doc fix.

2005-10-21  Kenichi Handa  <handa@m17n.org>

	* search.c (boyer_moore): Add parens to fix and/or precedence bug.

2005-10-20  Kim F. Storm  <storm@cua.dk>

	* buffer.c (clone_per_buffer_values): Remove unused var tem.
	(init_buffer): Remove unused vars dotstat, pwdstat.

	* ccl.c (check_ccl_update): Remove unused var vp.

	* fileio.c (auto_save_error): Call SAFE_FREE.

	* fns.c (Fchar_table_range): Remove unused var i.

	* minibuf.c (display_completion_list_1): New wrapper function
	for Fdisplay_completion_list.
	(Fminibuffer_completion_help): Use it.

	* term.c (encode_terminal_code): Remove unused var src_start.

	* window.c (Fwindow_tree): Remove unused var alist.

	* xterm.c (x_calc_absolute_position): Remove unused vars win_x, win_y.

2005-10-20  Aubrey Jaffer  <agj@alum.mit.edu>  (tiny change)

	* unexelf.c (unexec): Fix calls to `fatal' with less than 3 arguments.

2005-10-20  Olli Savia  <ops@iki.fi>  (tiny change)

	* syssignal.h [__Lynx__]: Undef SIGPOLL along with SIGIO.

2005-10-20  Andreas Schwab  <schwab@suse.de>

	* minibuf.c (Fdisplay_completion_list): Doc fix.

2005-10-19  Kim F. Storm  <storm@cua.dk>

	* image.c (check_image_size): Handle integer Vmax_image_size value
	directly as max pixel value.  Use default frame size for null frame.
	(syms_of_image) <max-image-size>: Describe integer value.

2005-10-19  Romain Francoise  <romain@orebokech.com>

	* emacs.c (main): Update copyright year.

2005-10-18  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (Vmax_image_size): New variable.
	(check_image_size): New function.
	(xbm_read_bitmap_data, pbm_load, png_load, jpeg_load, tiff_load)
	(gif_load, gs_load): Use it.
	(lookup_image): Try loading again if previous load failed.
	(xbm_read_bitmap_data): Add a new argument, a pointer to the frame
	to display in, NULL if none.
	(xbm_load_image, xbm_file_p): Pass xbm_read_bitmap_data the new
	argument.

2005-10-18  Richard M. Stallman  <rms@gnu.org>

	* search.c (Fstring_match): Doc fix.

2005-10-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement): Use PtInRect.
	(XTread_socket): Also ignore mouse motion just before a button
	release event.  Don't process button release event when mouse is
	not grabbed.

2005-10-16  Masatake YAMATO  <jet@gyve.org>

	* minibuf.c (Fdisplay_completion_list): Add new optional
	argument COMMON_SUBSTRING.  Bind `completion-common-substring'
	to the optional argument during running `completion-setup-hook'.

2005-10-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [TARGET_API_MAC_CARBON] (get_cfstring_encoding_from_lisp):
	Allow nil as argument.
	[TARGET_API_MAC_CARBON] (Fmac_code_convert_string): Regard nil
	for encoding arguments as UTF-16 in native byte order, no BOM.

	* macfns.c (Fx_create_frame): Add debugging code.
	(Fx_show_tip): Set frame pixel width and height.

	* macterm.c (MAC_WINDOW_NORMAL_GC): Remove macro.
	(FRAME_NORMAL_GC): New macro.
	(mac_draw_line, mac_clear_area, mac_clear_window)
	(mac_fill_rectangle, mac_draw_string, mac_draw_string_16)
	(mac_draw_image_string, mac_draw_image_string_16): Rename from
	XDrawLine, XClearArea, XClearWindow, XFillRectangle, XDrawString,
	XDrawString16, XDrawImageString, and XDrawImageString16, respectively.
	All uses changed.
	(mac_draw_line, mac_erase_rectangle, mac_clear_area)
	(mac_clear_window, mac_draw_bitmap, mac_draw_rectangle)
	(mac_invert_rectangle, mac_draw_string_common, mac_draw_string)
	(mac_draw_string_16, mac_draw_image_string)
	(mac_draw_image_string_16, mac_copy_area, mac_copy_area_with_mask)
	(mac_scroll_area): Drawing functions now take frame as destination.
	All uses changed.
	(mac_draw_string_common): Get port height with FRAME_PIXEL_HEIGHT.
	(x_draw_fringe_bitmap): Set clipping area in face->gc.

	* macterm.h (mac_clear_area): Add extern.

2005-10-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement, XTread_socket): Apply 2005-10-14
	changes for xterm.c.

	* w32term.c (note_mouse_movement, w32_read_socket): Likewise.

2005-10-14  Kenichi Handa  <handa@m17n.org>

	* search.c (search_buffer): Give up BM search on case-fold-search
	if one of a target character has a case-equivalence of different
	charset even if that target charcter is an ASCII.

	* casefiddle.c (casify_object): Fix for the case that case
	conversion change the byte length.

2005-10-14  Kim F. Storm  <storm@cua.dk>

	* xterm.c (note_mouse_movement): Return 1 if mouse moved; 0 otherwise.
	(handle_one_xevent): Only clear help_echo_string; restore it if
	note_mouse_movement didn't record any mouse movement.

	* xdisp.c (pos_visible_p): Convert w->hscroll to pixels before use.
	(remember_mouse_glyph): Clear RECT if mouse is over an image glyph.

	* keyboard.c (make_lispy_position): Adjust wx for left margin if
	ON_TEXT.
	(Fposn_at_x_y): Fix calculation of x coordinate.
	(Fposn_at_point): Return nil if point is hscrolled out of view.

2005-10-13  Andreas Schwab  <schwab@suse.de>

	* sysdep.c (request_sigio, unrequest_sigio): Do nothing in
	non-interactive mode.

2005-10-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xterm.c, w32term.c, macterm.c (note_mouse_movement): Undo last change.

2005-10-12  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Clear last_mouse_glyph on mouse up/down.

2005-10-12  Romain Francoise  <romain@orebokech.com>

	* buffer.c (init_buffer): Rename `rc' to `len' for clarity.

2005-10-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (remember_mouse_glyph): Use MATRIX_BOTTOM_TEXT_ROW to
	get end of text rows.  Obtain header-line/mode-line rows directly.

	* xterm.c, w32term.c, macterm.c (note_mouse_movement):
	Restore help_echo_string if mouse is moved inside last_mouse_glyph.

2005-10-12  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (remember_mouse_glyph): New generic version based on
	glyph_rect and remember_mouse_glyph from xterm.c enhanced to
	properly handle all different window areas.

	* dispextern.h (remember_mouse_glyph): Add prototype.

	* xterm.c (glyph_rect, remember_mouse_glyph): Remove X versions.
	(note_mouse_movement, XTmouse_position): Use generic
	remember_mouse_glyph, add last_mouse_glyph arg.

	* w32term.c (note_mouse_movement): Fix last_mouse_glyph check.
	(glyph_rect, remember_mouse_glyph): Remove w32 specific versions.
	(note_mouse_movement, w32_mouse_position): Use generic
	remember_mouse_glyph, add last_mouse_glyph arg.

	* macterm.c (note_mouse_movement): Add call to remember_mouse_glyph.
	(glyph_rect, remember_mouse_glyph): Remove mac specific versions.
	(XTmouse_position): Adapt to use generic remember_mouse_glyph
	instead of pixel_to_glyph_coords.

	* window.c (coordinates_in_window): Fix x position for ON_RIGHT_MARGIN.
	Fix x position for ON_TEXT when left margin width > 0.

2005-10-11  Kim F. Storm  <storm@cua.dk>

	* window.c (coordinates_in_window): Fix y position for ON_SCROLL_BAR.

	* keyboard.c (make_lispy_position): Fix buffer calculations for
	mouse click or movement in right fringe and the margins.

2005-10-11  Juanma Barranquero  <lekktu@gmail.com>

	* image.c (fn_jpeg_stdio_src): Don't define it.
	(init_jpeg_functions): Don't initialize `fn_jpeg_stdio_src'.
	(our_common_init_source): Rename from `our_init_source'.
	(our_common_term_source): Rename from `our_term_source'.
	(our_memory_fill_input_buffer): Rename from
	`our_fill_input_buffer'.
	(our_memory_skip_input_data): Rename from `our_skip_input_data'.
	(jpeg_memory_src): Use the new names.
	(struct jpeg_stdio_mgr): New struct.
	(JPEG_STDIO_BUFFER_SIZE): New constant.
	(our_stdio_fill_input_buffer, our_stdio_skip_input_data)
	(jpeg_file_src): New functions.
	(jpeg_load): Use `jpeg_file_src' instead of `fn_jpeg_stdio_src'.

2005-10-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (PER_CHAR_METRIC): Remove unused macro.
	(fm_font_family_alist): New variable.
	(syms_of_macterm): Initialize and staticpro it.
	(decode_mac_font_name): Replace '-' in family name with '_' if it
	occurs just once.  Lower family name.
	(parse_x_font_name): Rename from x_font_name_to_mac_font_name.
	All uses changed.  Remove argument MF and code conversion for it.
	Add argument SIZE.  Rename argument MF_DECODED to FAMILY, and CS
	to CHARSET.  Parse font size.  Lower family name.  Return integer
	value for status of parsing.
	(init_font_name_table) [USE_ATSUI]: Use decode_mac_font_name.
	Don't use Fdowncase because family name is already lowered by
	decode_mac_font_name.
	(init_font_name_table): Always call decode_mac_font_name.
	Add pair of family name and its reference to fm_font_family_alist.
	(mac_clear_font_name_table): Clear fm_font_family_alist.
	(XLoadQueryFont): Move font size parsing part to parse_x_font_name.
	Lookup fm_font_family_alist to get font family reference.
	(XLoadQueryFont) [USE_ATSUI]: Don't use Fdowncase because family
	name is already lowered by parse_x_font_name.

2005-10-11  Kim F. Storm  <storm@cua.dk>

	* xterm.c (glyph_rect): Return 0 if position is outside text area.

	* keyboard.c (make_lispy_position): Fix buffer position calculation for
	mouse click or movement in fringe.

2005-10-10  Jason Rumney  <jasonr@gnu.org>

	* xterm.c (remember_mouse_glyph): New function.
	(note_mouse_movement): Use it to remember the current glyph if changed.
	(XTmouse_position): Fix calculation of fake glyph under mouse.
	Move code to calculate glyph under mouse into remember_mouse_glyph.

2005-10-10  Jan Djärv  <jan.h.d@swipnet.se>

	* emacs.c (USAGE3, standard_args): -nb => -nbi.

2005-10-10  Juanma Barranquero  <lekktu@gmail.com>

	* frame.c (Fredirect_frame_focus): Fix typos in docstring.
	(next_frame, prev_frame, set_term_frame_name): Make static.

	* window.c (Fwindow_tree): Fix spelling.

2005-10-09  Romain Francoise  <romain@orebokech.com>

	* window.c (Fwindow_end): Don't try to redisplay if non-interactive.

2005-10-09  Jan Djärv  <jan.h.d@swipnet.se>

	* emacs.c (standard_args): Remove options -i, -itype, --icon-type.
	Add options -nb, --no-bitmap-icon.

	* xfns.c (Fx_create_frame): Make bitmapIcon have default on.

2005-10-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (MAX_CLIP_RECTS): New define.
	(struct _XGC): New member clip_region.
	(struct _XGC) [MAC_OSX && USE_ATSUI]: New members n_clip_rects and
	clip_rects.

	* macterm.c (GC_CLIP_REGION): New macro.
	(saved_port_clip_region): New variable.
	(mac_begin_clip, mac_end_clip): New functions.
	(XDrawLine, mac_erase_rectangle, mac_draw_bitmap, XFillRectangle)
	(mac_draw_rectangle, mac_draw_string_common, mac_copy_area)
	(mac_copy_area_with_mask, mac_scroll_area): Use them.
	(mac_set_clip_rectangle, mac_reset_clipping): Remove functions.
	[USE_ATSUI] (atsu_get_text_layout_with_text_ptr)
	[MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Specify kATSLineFractDisable.
	(mac_draw_string_common) [MAC_OSX && USE_ATSUI]: Clip to clipping
	rectangles stored in gc.
	(XFreeGC): Dispose of clipping region.
	(mac_set_clip_rectangles, mac_reset_clip_rectangles): New functions.
	(x_draw_fringe_bitmap, x_set_glyph_string_clipping)
	(x_draw_relief_rect, x_draw_box_rect, x_draw_stretch_glyph_string)
	(x_draw_glyph_string, x_clip_to_row, x_draw_hollow_cursor)
	(x_draw_bar_cursor): Use them.
	(x_set_glyph_string_clipping): Use get_glyph_string_clip_rects to
	get multiple clipping rectangles.

	* macterm.h (mac_term_init): Add types to extern.
	(struct mac_output): Remove members mWP and pending_menu_activation.
	Put members scroll_bar_foreground_pixel and
	scroll_bar_background_pixel in #if 0.
	(FRAME_MAC_WINDOW, FRAME_X_WINDOW): Use window_desc.

	* xfaces.c (x_create_gc, x_free_gc) [MAC_OS]: Add BLOCK_INPUT.
	Add debugging code.

2005-10-08  Kim F. Storm  <storm@cua.dk>

	* window.c (window_tree, Fwindow_tree): Rename fns added 2005-10-04.

2005-10-07  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (redraw_overlapped_rows, redraw_overlapping_rows)
	[!HAVE_WINDOW_SYSTEM]: Don't declare them...
	(update_window) [!HAVE_WINDOW_SYSTEM]: ...and don't call them.

2005-10-07  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h (struct glyph_string): Rename member for_overlaps_p
	to for_overlaps.  Now occupy 3 bits.
	(OVERLAPS_PRED, OVERLAPS_SUCC, OVERLAPS_BOTH)
	(OVERLAPS_ERASED_CURSOR): New defines.
	(struct redisplay_interface): Add new OVERLAPS arg to member
	fix_overlapping_area.
	(x_fix_overlapping_area): Add new OVERLAPS arg.
	(get_glyph_string_clip_rects): Add extern.

	* dispnew.c (redraw_overlapping_rows):
	Call rif->fix_overlapping_area with new OVERLAPS arg as redrawn part.

	* xdisp.c: Rename member for_overlaps_p in struct glyph_string to
	for_overlaps.
	(get_glyph_string_clip_rects): New function created from
	get_glyph_string_clip_rect.  Set clipping rectangles according to the
	value of for_overlaps.  Enable to store multiple clipping rectangles.
	(get_glyph_string_clip_rect): Use get_glyph_string_clip_rects.
	(fill_composite_glyph_string, fill_glyph_string, draw_glyphs):
	Rename argument OVERLAPS_P to OVERLAPS.  All uses in macros changed.
	(x_fix_overlapping_area): Add OVERLAPS arg.  Pass it to draw_glyphs.
	(draw_phys_cursor_glyph): Set width of erased cursor to use it for
	calculating clipping rectangles later.  Call x_fix_overlapping_area
	with new OVERLAPS arg to draw only erased cursor area.
	(expose_overlaps): Call x_fix_overlapping_area with new OVERLAPS arg
	to draw overlaps in both preceding and succeeding rows.

	* xterm.c, w32term.c, macterm.c: Rename member for_overlaps_p in
	struct glyph_string to for_overlaps.

2005-10-04  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (refill_memory_reserve): Conditionalize the body,
	not the function's existence.

2005-10-04  Kim F. Storm  <storm@cua.dk>

	* window.c (window_split_tree): New function.
	(Fwindow_split_tree): New defun.
	(syms_of_window): Defsubr it.

2005-10-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_invert_rectangle): New function.
	(XTflash): Use it.

2005-10-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.h (re_char): Don't expose it in the interface.
	(re_set_whitespace_regexp): Adjust the arg's type to not use it.

	* regex.c (re_char): Move it back here.
	(re_set_whitespace_regexp): Change the arg's type to not use it.

	* keyboard.c (make_lispy_event): If point has moved between down and up
	event, make it a drag, not a click, to mirror what
	mouse-drag-region expects.

2005-10-02  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (fatal): Undo previous change.
	* term.c (fatal): Undo previous change.

2005-10-01  Richard M. Stallman  <rms@gnu.org>

	* xfaces.c (face_color_gray_p): Colors close to black count as gray.

2005-10-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (try_window): Skip scroll-margin check if ZV is visible.

2005-10-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (init_keyboard) [MAC_OSX]: Don't install SIGINT handler.

	* macfns.c (start_hourglass): Apply 2005-05-07 change for xfns.c.
	(x_create_tip_frame) [GLYPH_DEBUG]: Uncomment debugging code.
	(Fx_create_frame, x_create_tip_frame) [USE_ATSUI]:
	Try ATSUI-compatible 12pt Monaco font first.

	* macgui.h (struct _XCharStruct): New member valid_p.
	(STORE_XCHARSTRUCT): Set valid_p.
	(struct MacFontStruct) [USE_ATSUI]: New member mac_style.

	* macterm.c (mac_draw_string_common, x_per_char_metric)
	(mac_compute_glyph_string_overhangs, init_font_name_table)
	(XLoadQueryFont, mac_unload_font) [USE_ATSUI]: Add ATSUI support.
	(atsu_get_text_layout_with_text_ptr) [USE_ATSUI]: New function.
	(x_draw_glyph_string_background)
	(x_draw_glyph_string_foreground) [MAC_OS8 && USE_ATSUI]: Don't use
	XDrawImageString.  Always draw background and foreground separately.
	(x_draw_glyph_string_foreground) [USE_ATSUI]: Don't use 8-bit
	functions for one-byte chars when using ATSUI-compatible fonts.
	(atsu_font_id_hash) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Initialize and staticpro it.
	(XLoadQueryFont): Set min_byte1, max_byte1, min_char_or_byte2, and
	max_char_or_byte2 more in detail.
	(quit_char_comp, mac_check_for_quit_char) [MAC_OSX]: Remove functions.

2005-09-30  Dan Nicolaescu  <dann@ics.uci.edu>

	* image.c (slurp_file, xbm_read_bitmap_data): Cast to the correct type.
	* xterm.c (handle_one_xevent, handle_one_xevent): Likewise.

	* unexelf.c (fatal): Fix prototype.

	* term.c (fatal): Implement using varargs.

	* regex.c (re_char): Move typedef ...
	* regex.h (re_char): ... here.
	(re_iswctype, re_wctype, re_set_whitespace_regexp): New prototypes.

	* emacs.c (malloc_set_state): Fix return type.
	(endif): Fix type.

	* lisp.h (fatal): Add argument types.

	* dispextern.h (fatal): Delete prototype.

	* systime.h (make_time): Prototype moved from ...
	* editfns.c (make_time): ... here.

	* editfns.c: Move systime.h include after lisp.h.
	* dired.c:
	* xsmfns.c:
	* process.c: Likewise.

	* alloc.c (old_malloc_hook, old_realloc_hook, old_realloc_hook):
	Add parameter types.
	(__malloc_hook, __realloc_hook, __free_hook): Fix prototypes.
	(emacs_blocked_free): Change definition to match __free_hook.
	(emacs_blocked_malloc): Change definition to match __malloc_hook.
	(emacs_blocked_realloc): Change definition to match __realloc_hook.

2005-09-30  Romain Francoise  <romain@orebokech.com>

	* minibuf.c (Fread_buffer): Follow convention for reading from the
	minibuffer with a default value.  Doc fix.

2005-09-29  Juri Linkov  <juri@jurta.org>

	* editfns.c (Fmessage, Fmessage_box, Fmessage_or_box):
	Rename argument name `string' to `format-string'.
	(Fformat): Doc fix.

2005-09-28  Kim F. Storm  <storm@cua.dk>

	* image.c (gif_load): Fix size of allocated image buffer
	for images where a sub-image may be larger than the image's
	total height/width specifications.

